<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>Apusic应用服务器应用管理</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="baseUrl" value="${contextPath}/protect/application" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript"
	src="${resBase}/scripts/lib/underscore.js"></script>
<script type="text/javascript" src="${resBase}/scripts/aas-core.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/form.js"></script>
<script type="text/javascript" src="${resBase}/scripts/app.js"></script>
<script type="text/javascript"
		src="${resBase}/scripts/server_dir_selector.js"></script>

<link rel="stylesheet" type="text/css"
	href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css"
	href="${resBase}/css/selector.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/app.css" />
<style type="text/css">
html {
	overflow:hidden;
}
body {
	scroll: no;
}
</style>
<%
    response.setHeader("Cache-Control", "no-cache");
    response.setHeader("Cache-Control", "no-store");
    response.setDateHeader("Expires", 0);
    response.setHeader("Pragma", "no-cache");
%>
<script>
	$(function() {
		aas.initContext('${fn:escapeXml(contextPath)}');

		window.$a = AASMonitor.appMgmt;
		$a.baseUrl = '${fn:escapeXml(baseUrl)}';

		var appName = '${fn:escapeXml(appName)}';
		var operation = '${fn:escapeXml(operation)}';
		var errorMsg = '${fn:escapeXml(errorMsg)}';
		
		if (appName.length > 0) {
			AASMonitor.info('{1}应用[{0}]成功！'
					.format(appName, operation));
		}

		if (errorMsg != null && errorMsg != '') {
			AASMonitor.error(errorMsg);
		}

		$('#appDeployButtonbar').omButtonbar({
			btns : [ {
				label : "部署应用",
				id : "button1",
				icons : {
					left : '${resBase}/images/add.png'
				},
				onClick : function() {
					appDeploy();
				}
			}, {
                separtor : true
            }, {
                label : "公共类库管理",
                id : "button2",
                icons : {
                    left : '${resBase}/images/setting.png'
                },
                onClick : function() {
                    var share = null;
                    $.ajax({
                        url : '${baseUrl}/get-share-lib',
                        type: 'post',
                        async: false,
                        success : function(data) {
                            if(data != "null") {
                                share = data;
                            }
                        },
                        error : function() {
                            showMsgTip("请求错误!","error");
                        }
                    });

                    new aas.utils.ServerDirSelector({
                        selectedPath: share,
                        callback : function(dialog, sharelib) {
                            $.ajax({
                                url : '${baseUrl}/config-share-lib',
                                type: 'post',
                                dataType: 'json',
                                data : {"sharelib": sharelib},
                                success : function(data) {
                                    if ('success' == data.status) {
                                        dialog.omDialog('close');
                                        showMsgTip("设置公共类库成功!请重新启动应用或者重启应用服务器生效！","success");
                                    } else {
                                        showMsgTip(data.content, "error");
                                    }
                                },
                                error : function() {
                                    showMsgTip("请求错误,请重新提交!","error");
                                }
                            });
                        }
                    });
                }
            }]
		});

        function showMsgTip(msg,type) {
            $.omMessageTip.show({
                type : type,
                title : '提示信息',
                content : msg,
                timeout : 3000
            });
        }

	});

	function appDeploy() {
		location.href = "${baseUrl}/deploy";
	}
	function appConfig(name) {
		location.href = "${baseUrl}/config?name=" + name;
	}
	function libConfig(name) {
		location.href = "${baseUrl}/libconfig?name=" + name;
	}
	function aarConfig(name) {
		location.href = "${baseUrl}/aarconfig?name=" + name;
	}

    function sharelibConfig(name) {
        location.href = "${baseUrl}/share-lib-config";
    }
	
</script>
</head>
<body>
	<div style="margin: 0px; padding: 0px;">
		<div style="padding: 8px; height: 100%; overflow: hidden;">
			<div id="appDeployButtonbar" class="as_btn_bar"></div>
			<div class="list_container">
				<c:forEach items="${apps}" var="app">
					<div class="app-item">
						<div
							class="app ${app.j2eeType.startsWith('.') ? app.j2eeType.substring(1) : (app.j2eeType == null ? 'unknown' : app.j2eeType)}-${app.state} ">
							<table cellpadding="0" cellspacing="0" width="100%">
								<tr>
									<td>
										<div class="description">
											<span>对象名称：</span><span>${app.appName}</span> <span>状态：</span><span
												class="state-${app.state}">${app.state.equals('Running')
												? '启动' : '停止'}</span>
										</div>
									</td>
									<td width="200px;">
										<div class="inner-toolbar">
											<a href="#" onclick="libConfig('${app.appName}');"><span>类库管理</span></a>
											<span class="ml_10 mr_10">|</span> <a href="#"
												onclick="$a.viewModules('${app.appName}');"><span>查看应用模块</span></a>
										</div>
									</td>
								</tr>
								<tr>
									<td>
										<div class="description">
											<span>部署路径：</span><span>${app.deployPath}</span>
										</div>
									</td>
									<td>
										<div class="inner-toolbar">
											<a href="#" onclick="$a.viewWebXML('${app.appName}');"><span>查看J2EE标准控制文件</span></a>
										</div>
									</td>
								</tr>
								<tr>
									<td>
										<div class="description">
											<a href="#" onclick="$a.monitor('${app.appName}');">监控应用</a>
											<span class="ml_10 mr_10">|</span>
											<c:choose>
												<c:when test="${app.state.equals('Running')}">
													<a href="${baseUrl}/stopApp?name=${app.appName}"
														onclick="return window.confirm('确定要停止应用吗？停止后不可访问此应用！');"><span>停止应用</span></a>
												</c:when>
												<c:otherwise>
													<a href="${baseUrl}/startApp?name=${app.appName}"><span>启动应用</span></a>
												</c:otherwise>
											</c:choose>
											<span class="ml_10 mr_10">|</span> <a class="undeploy"
												href="${baseUrl}/undeployApp?name=${app.appName}"
												onclick="return window.confirm('确定要卸载应用吗？卸载后不可恢复！');">卸载</a>
										   <span class="ml_10 mr_10">|</span><a href="#" onclick="appConfig('${app.appName}');"><span>参数配置</span></a>
										   <c:choose>
												<c:when test="${app.specialType.startsWith('axis')}">
												    <span class="ml_10 mr_10">|</span>
													<a href="#" onclick="aarConfig('${app.appName}');"><span>AAR管理</span></a>
												</c:when>												
											</c:choose>
										</div>
									</td>
									<td>
										<div class="inner-toolbar">
											<a href="#"
												onclick="$a.viewApusicApplicationXML('${app.appName}');"><span>查看apusic-application.xml</span></a>
										</div>
									</td>
								</tr>
							</table>
						</div>
						<hr class="app_division_line" />
					</div>
				</c:forEach>
			</div>
		</div>
	</div>
</body>
</html>
