<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>Apusic应用服务器应用管理</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="baseUrl" value="${contextPath}/protect/application" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript"
	src="${resBase}/scripts/lib/underscore.js"></script>
<script type="text/javascript" src="${resBase}/scripts/aas-core.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/form.js"></script>
<script type="text/javascript" src="${resBase}/scripts/app.js"></script>
<script type="text/javascript"
	src="${resBase}/scripts/server_file_selector.js"></script>

<link rel="stylesheet" type="text/css"
	href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css"
	href="${resBase}/css/selector.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/app.css" />

<script>
	$(function() {
	    $('#backToListButtonbar').omButtonbar({
	    	btns : [{
	    				label : "返回列表",
	    				id : "button1",
	    				icons : {
							left : '${resBase}/images/service.png'
						},
	    				onClick : function() {
	    					backToList();
	    				}
	    			}]
	    });
	    
		aas.initContext('${contextPath}');
		window.$a = AASMonitor.appMgmt;
		$a.baseUrl = '${baseUrl}';
		$a.pageInit();
		
		$('#btnConfig').omButton({
	        onClick : function(event){
	        	$a.config();
	        }
		});
		$('#btnReset').omButton({});
	});

	function backToList() {
		location.href = "${baseUrl}";
	}
</script>

<style type="text/css">
	.om-panel-noheader {
		border: 0px;
	}
	.app_config_tbl tr {
		line-height:25px;
	}
	.om-buttonbar {
		margin: 8px 8px 0px 8px;
	}
</style>
</head>
<body>
	<div id="page" class="app_page">
		<div id="north-panel">
			<div id="backToListButtonbar"></div>
		</div>

		<div id="center-panel">
			<div class="app_container">
				<div class="app_container_explain">
					<div>
						<center>
							<strong>说明</strong>
						</center>
						<ul>
							<li>应用名称：作为标识整个应用的主键信息，必须唯一；</li>
							<li>应用基础上下文：如应用的web模块配置了context-root，那么应用所有web模块的context-root会以应用基础上下文为前缀，访问路径变为http://hostname/base-context/context-root/。具体请参考帮助文档；</li>
							<li>是否立即启动：如果勾选立即启动，部署应用就会立刻启动，否则仅仅执行部署动作；</li>
							<li>允许或禁止IP地址列表格式：192.168.6.5：表示IP地址
								192.168.6.5；192.168.6.10-50：表示192.168.6.10到192.168.6.50之间的所有IP；192.168.6.*：表示192.168.6.1到192.168.6.254之间的所有IP；多个IP地址之间用英文逗号分隔。</li>
						</ul>
					</div>
				</div>
				<div class="app_container_main" >
					<div class="app_container_main_content">
						<div class="title">
							<strong>参数配置</strong>
						</div>
						<hr class="app_division_line" />
						<form id="app_deploy_param_form" name="app_deploy_param_form"
							style="width: 100%; height: 100%;" action="${baseUrl}/configApp"
							method="post">
							<table class="app_config_tbl" cellpadding="1" cellspacing="1">
								<tr>
									<td class="label">应用名称：</td>
									<td class="value"><input type="text" 
										value="${app.appName}" disabled="disabled" class="app_config_input" /> <input
										type="hidden" name="appName" value="${app.appName}" /></td>
								</tr>
								<tr>
									<td class="label">应用目录：</td>
									<td class="value"><input value="${deployPath}" class="app_config_input"
										disabled="disabled" /> <input type="hidden" name="deployPath"
										value="${deployPath}" /></td>
								<tr>
								<tr>
									<td class="label">应用基础上下文：</td>
									<td class="value"><input name="baseContext" class="app_config_input"
										value="${app.baseContext}" /></td>
								</tr>
								<tr>
									<td class="label">启动类型：</td>
									<td class="value"><select name="startType" class="app_config_select">
											<c:choose>
												<c:when test="${app.startType == 'auto'}">
													<option label="auto" value="auto" selected="selected">auto</option>
													<option label="demand" value="demand">demand</option>
												</c:when>
												<c:otherwise>
													<option label="auto" value="auto">auto</option>
													<option label="demand" value="demand" selected="selected">demand</option>
												</c:otherwise>
											</c:choose>
									</select></td>
								</tr>

								<tr>
									<td class="label">加载顺序：</td>
									<td class="value"><input name="loadon" id="loadon" type="text" class="app_config_input"
										value="${app.loadon}" /></td>
								</tr>
								<tr>
									<td class="label">是否全局session：</td>
									<td class="value"><input name="globalSession"
										type="checkbox"
										${app.globalSession ? 'checked="checked"' : ''} value="true" /></td>
								</tr>

								<tr>
									<td class="label">虚拟主机：</td>
									<td class="value"><textarea id="virtualHost" name="virtualHost" class="app_config_input_textarea">${app.virtualHost}</textarea>
									</td>
								</tr>
								<tr>
									<td class="label">允许访问IP列表：</td>
									<td class="value"><textarea id="allowHosts" class="app_config_input_textarea"
											name="allowHosts">${app.allowHosts}</textarea></td>
								</tr>
								<tr>
									<td class="label">禁止访问IP列表：</td>
									<td class="value"><textarea id="denyHosts" class="app_config_input_textarea"
											name="denyHosts">${app.denyHosts}</textarea></td>
								</tr>

								<tr>
									<td colspan="2">
										<div style="text-align: left; margin-top: 20px; padding-left: 130px;">
											&nbsp; <input type="button" value="保存" onclick="" id="btnConfig">
											&nbsp;&nbsp; <input type="reset" value="重置" id="btnReset">
										</div>
									</td>
								</tr>
							</table>
						</form>
					</div>
				</div>
			</div>
		</div>
	</div>
</body>
</html>
