<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />

<script>
$(function() {
    $('#jsp_component').omGrid({
        height: 180,
        width : 310,
        limit : 0,
        showIndex : false,
        singleSelect : true,
        loadingMsg : '正在加载数据，请稍候...',
        colModel : [ {
            header : 'jsp文件',
            name : 'name',
            width : 'autoExpand',
            align : 'left',
            sort : 'clientSide'
        }, {
            header : '服务数',
            name : 'serviceCount',
            width : 50,
            align : 'center',
            sort : 'clientSide'
        }, {
            header : '服务时间',
            name : 'serviceTime',
            width : 60,
            align : 'center',
            sort : 'clientSide',
            renderer : function(colValue, rowData, rowIndex) {
                if (rowData.serviceTime) {
                    return rowData.serviceTime + "ms";
                } else {
                    return "0ms";
                }
            }
        }, {
            header : '平均时间',
            name : 'avgTime',
            width : 60,
            align : 'center',
            sort : 'clientSide',
            renderer : function(colValue, rowData, rowIndex) {
                if (rowData.serviceCount != 0) {
                    return roundFun((rowData.serviceTime / rowData.serviceCount), 1) + "ms/次";
                } else {
                    return "--";
                }
            }
        } ],
        dataSource : '${contextPath}/protect/monitor/j2ee/jspStatistics?j2eeType=1&name=${app}'
    });

    $('#servlet_component').omGrid({
        height: 180,
        width : 310,
        limit : 0,
        showIndex : false,
        singleSelect : true,
        loadingMsg : '正在加载数据，请稍候...',
        colModel : [ {
            header : 'Servlet名',
            name : 'name',
            width : 'autoExpand',
            align : 'left',
            sort : 'clientSide'
        }, {
            header : '服务数',
            name : 'serviceCount',
            align : 'center',
            width : 50,
            sort : 'clientSide'
        }, {
            header : '服务时间',
            name : 'totalServiceTime',
            align : 'center',
            width : 60,
            sort : 'clientSide',
            renderer : function(colValue, rowData, rowIndex) {
                if (rowData.totalServiceTime != null) {
                    return rowData.totalServiceTime + "ms";
                } else {
                    return "0ms";
                }
            }
        }, {
            header : '平均时间',
            name : 'serviceTime',
            align : 'center',
            width : 60,
            sort : 'clientSide',
            renderer : function(colValue, rowData, rowIndex) {
            	 if (rowData.serviceCount != 0) {
                     return roundFun((rowData.serviceTime / rowData.serviceCount), 1) + "ms/次";
                 } else {
                     return "--";
                 }
            }
        } ],
        dataSource : '${contextPath}/protect/monitor/j2ee/servletStatistics?j2eeType=1&name=${app}'
    });

    $('#ejb_component').omGrid({
        height: 180,
        width : 310,
        limit : 0,
        showIndex : false,
        singleSelect : true,
        loadingMsg : '正在加载数据，请稍候...',
        colModel : [ {
            header : 'ejb名',
            name : 'name',
            width : 'autoExpand',
            align : 'left',
            sort : 'clientSide'
        }, {
            header : '提交数',
            name : 'committedCount',
            width : 50,
            align : 'center',
            sort : 'clientSide'
        }, {
            header : '创建数',
            name : 'createCount',
            width : 50,
            align : 'center',
            sort : 'clientSide'
        }, {
            header : '删除数',
            name : 'removeCount',
            width : 50,
            align : 'center',
            sort : 'clientSide'
        }, {
            header : '成功率',
            name : 'serviceTime',
            width : 50,
            align : 'center',
            sort : 'clientSide',
            renderer : function(colValue, rowData, rowIndex) {
            	 if (rowData.createCount != 0) {
                	 return roundFun((rowData.committedCount/rowData.createCount),1);
                }else{
                	 return "--";
                }
            }
        } ],
        dataSource : '${contextPath}/protect/monitor/j2ee/ejbStatistics?j2eeType=1&name=${app}'
    });
    
    $('#jca_component').omGrid({
        height: 180,
        width : 310,
        limit : 0,
        showIndex : false,
        singleSelect : true,
        loadingMsg : '正在加载数据，请稍候...',
        colModel : [ {
            header : 'jca名',
            name : 'name',
            width : 'autoExpand',
            align : 'left',
            sort : 'clientSide'
        }, {
            header : '创建数',
            name : 'createCount',
            width : 50,
            align : 'center',
            sort : 'clientSide'
        }, {
            header : '关闭数',
            name : 'closeCount',
            width : 50,
            align : 'center',
            sort : 'clientSide'
        }, {
            header : '当前连接数',
            name : 'currentConnectionCount',
            width : 50,
            align : 'center',
            sort : 'clientSide'
        }, {
            header : '可用连接数',
            name : 'currentAvailableConnectionCount',
            width : 50,
            align : 'center',
            sort : 'clientSide'           
        } ],
        dataSource : '${contextPath}/protect/monitor/j2ee/rarStatistics?j2eeType=1&name=${app}'
    });
});

function roundFun(numberRound, roundDigit) {
    var digit;
    digit = 1;
    digit = Math.pow(10, roundDigit);
    return (Math.round(numberRound * digit) / digit);
}
</script>

<table cellspacing="0" cellpadding="0" class="monitor_tbl" style="border-collapse: collapse; width: 100%; height: 100%">
    <tr>
        <td width="50%" valign="top">
            <div class="title">JSP组件</div>
            <table id="jsp_component"></table>
        </td>
        <td width="50%" valign="top">
            <div class="title">Servlet组件</div>
            <table id="servlet_component"></table>
        </td>
    </tr>
    <tr>
        <td valign="top">
            <div class="title">EJB组件</div>
            <table id="ejb_component"></table>
        </td>
        <td valign="top">
            <div class="title">JCA组件</div>
            <div id="jca_component"></div>
        </td>
    </tr>
</table>