<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />

<script>
</script>
<style type="text/css">
	td.logtitle {
		color: #316AC5;
		line-height: 1.5em;
		padding-left: 5px;
		font-size:12px;
		width: 135px;
	}
	td.error {
		width: 30px;
	}
	input.loginput{
		width: 140px;
		float: left;
		text-align: left;
	}
		
</style>
<div style="padding: 1px 1px; width: 100%; overflow: hidden; background-color: #FFFFFF;">
	<form id="asconfig_acp_param_form" name="asconfig_acp_param_form">
        <table class="">
            <tr>
                <td>开启ACP服务:</td>
                <td><input type="checkbox" id="acpEnabled" name="acpEnabled" ${acpConfig.acpEnabled ? ' checked="checked"' : ' ' } onclick="selectACPCheckbox(this.checked);"/></td>
                <td class="error"><span class="errorMsg"></span></td>
            </tr>
            <tr>
                <td >超时时间(秒):</td>
                <td><input type="text" class="loginput" id="acpTimeout" name="timeout" value="${acpConfig.timeout}"/></td>
                <td class="error"><span class="color_red">*</span><span class="errorMsg"></span></td>
            </tr>
            <tr>
                <td>运行状态:</td>
                <td>
				<c:choose>
					<c:when test='${acpConfig.stateString eq "Running"}'>
						<span style="color: green">${acpConfig.stateString}</span>
					</c:when>
					<c:otherwise>
						<span style="color: red">${acpConfig.stateString}</span>
					</c:otherwise>
				</c:choose>                 
                </td>
                <td class="error"><span class="errorMsg"></span></td>
            </tr>
        </table>
    </form>
</div>
<script type="text/javascript">

	function saveACPConfig(Obj){	
        var flag = validateForm();          
		if(flag){
	  		$.ajax({
				type : "post",
				async:false,
				dataType : "text",
				url :'${pageContext.request.contextPath}/protect/aasconfig/advance/updateACP',
				data : AASMonitor.FormToJSON.formToJSON($('#asconfig_acp_param_form')),
				error: function(){
					showMsgTip("请求错误,请重新提交!","error");
				},
				complete : function() {
					changeServerState('ACP');
				},
				success : function(data) {
					if(data=="success"){
						showMsgTip("配置ACP成功！重启后生效！","success");
					}else{
						showMsgTip("配置ACP失败!","warning");
					}
					Obj.omDialog('destroy');
					Obj.remove();
				}
			});			
			
		}else{
			return false;
		}
	}
	
	
	function validateForm(){
        var flag = $("#asconfig_acp_param_form").validate({
            rules : {
         	  timeout : {
         		 required : true,
         		 isInteger  : true
                }
            },
            messages : {
         	   timeout : {
         		  required : '超时时间为必填项',
         		  isInteger : "请输入有效的整数"
                }
            },
            errorPlacement : function(error, element) {
                if(error.html()){
                    $(element).parents().map(function(){
                        if(this.tagName.toLowerCase()=='td'){
                            var attentionElement = $(this).next().children('.errorMsg').eq(0);
    	                    attentionElement.html(error);
                        }
                    });
                }
	        },

            showErrors: function(errorMap, errorList) {
                if(errorList && errorList.length > 0){
                    $.each(errorList,function(index,obj){
                        var msg = this.message;
                        $(obj.element).parents().map(function(){
	                        if(this.tagName.toLowerCase()=='td'){
	                            var attentionElement = $(this).next().children('.errorMsg').eq(0);
	    	                    attentionElement.html(msg);
	                        }
	                    });
	                   });
                }else{
                    $(this.currentElements).parents().map(function(){
                        if(this.tagName.toLowerCase()=='td'){
                            $(this).next().children('.errorMsg').eq(0).hide();
                        }
                    });
                }
                this.defaultShowErrors();
            }
	        
        }).form();		
		return flag;
	}

    $(':input').bind('mouseover',function(){
    	$(this).parent('td').next().children('.errorMsg').eq(0).css('display','block');
    }).bind('mouseout',function(){
    	$(this).parent('td').next().children('.errorMsg').eq(0).css('display','none');
    });

	function selectACPCheckbox(checkFlag){
		if(checkFlag){
			$("[id=acpEnabled]:checkbox").attr("checked", true);
			$("[id=acpTimeout]:input").attr("disabled",false);
		}else{
			$("[id=acpTimeout]:input").attr("disabled",true);
		}
	}
	
	function changeServerState(serverType){
		$.post( "${pageContext.request.contextPath}/protect/aasconfig/advance/getServerState",{serverType:serverType},
		function(data,status){
			if(data != '' && 'success' == status){
				$('#state_acp').attr("class", data);
			}
		});
	}
</script>




