<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />

<script>
</script>
<style type="text/css">

</style>
<div style="padding: 1px 1px; width: 100%; overflow: hidden; background-color: #FFFFFF;">
	<form id="asconfig_ajp_param_form" name="asconfig_ajp_param_form">
        <table class="">
            <tr>
                <td class="logtitle">开启AJP服务:</td>
                <td><input type="checkbox" id="ajpEnabled"  name="ajpEnabled" ${ajpConfig.ajpEnabled ? ' checked="checked"' : ' ' } onclick="selectAJPCheckbox(this.checked);"/></td>
            </tr>
            <tr>
                <td class="logtitle">绑定地址:</td>
                <td><input type="text" class="loginput" id="address" name="address" value="${ajpConfig.address}"/></td>
            </tr>
            <tr>
                <td class="logtitle">端口:</td>
                <td><input type="text" class="loginput" id="port" name="port" value="${ajpConfig.port}"/><span class="color_red">*</span></td>
            </tr>
            <tr>
                <td class="logtitle">Backlog:</td>
                <td><input type="text" class="loginput" id="backlog" name="backlog" value="${ajpConfig.backlog}"/><span class="color_red">*</span></td>
            </tr>            
            <tr>
                <td class="logtitle">AJP协议类型:</td>
                <td>
	                <select id="type" name="type" style="width: 153px;">
	                	<option  value="AJP13" ${ajpConfig.type eq 'AJP13' ? 'selected' : '' }>AJP13</option>
						<option value="AJP12" ${ajpConfig.type eq 'AJP12' ? 'selected' : '' }>AJP12</option>
					</select>
				</td>
            </tr> 
            <tr>
                <td class="logtitle">URL编码:</td>
                <td><input type="text" class="loginput" id="urlEncoding" name="urlEncoding" value="${ajpConfig.urlEncoding}"/></td>
            </tr>                         
            <tr>
                <td class="logtitle">超时时间(秒):</td>
                <td><input type="text" class="loginput" id="timeout" name="timeout" value="${ajpConfig.timeout}"/></td>
            </tr> 
            <tr>
                <td class="logtitle">运行状态:</td>
                <td>
				<c:choose>
					<c:when test='${ajpConfig.stateString eq "Running"}'>
						<span style="color: green">${ajpConfig.stateString}</span>
					</c:when>
					<c:otherwise>
						<span style="color: red">${ajpConfig.stateString}</span>
					</c:otherwise>
				</c:choose>                 
                </td>
            </tr>
        </table>
    </form>
</div>
<script type="text/javascript">

	function saveAJPConfig(Obj){	
	    var flag = validateForm();          
		if(flag){
			if($("#timeout").val()==''){
				$("#timeout").val("0");
			}
	  		$.ajax({
				type : "post",
				async:false,
				dataType : "text",
				url :'${pageContext.request.contextPath}/protect/aasconfig/advance/updateAJP',
				data : AASMonitor.FormToJSON.formToJSON($('#asconfig_ajp_param_form')),
				error: function(){
					showMsgTip("请求错误,请重新提交!","error");
				},
				complete : function() {
					changeServerState('AJP');
				},
				success : function(data) {
					if(data=="success"){
						showMsgTip("配置AJP成功！重启后生效！","success");
					}else{
						showMsgTip(data,"warning");
					}
					Obj.omDialog('destroy');
					Obj.remove();
				}
			});
		}else{
			return false;
		}
	}


	function validateForm(){
		var flag = $('#asconfig_ajp_param_form').validate({
		    validateOnEmpty : true,
		    rules : {
		    	port : {
		            required : true,
		            digits : true,
		            max : 65535
		        },
		        backlog : {
		        	required : true,
		            digits : true
		        },
		        timeout : {
		            digits : true
		        }
		    },
		    messages : {
		    	port : {
		            required : '端口为必填项，默认为80',
		            digits : '端口为正整数',
		            max : '端口范围是0～65535'
		        },
		        backlog : {
		        	required : 'Backlog为必填项，默认为50',
		            digits : 'Backlog为正整数'
		        },
		        timeout : {
		            digits : '超时时间为正整数，默认为300'
		        }
		    },
		    showErrors: function(errorMap, errorList) {
		        var next = $(this.currentElements).next();
		        while(next.hasClass('errorMsg')) {
		            next.remove();
		            next = $(this.currentElements).next();
		        }
		        $(this.currentElements).removeClass('error');
		        $(this.currentElements).unbind('mouseover').unbind('mouseout');
		        if(errorList && errorList.length > 0){
		            $.each(errorList, function(index, obj){
		                $(obj.element).addClass('error');
		                var msg = this.message;
		                var em = $('<span class="errorMsg">{0}</span>'.format(msg));
		                $(obj.element).after(em);
		                $(obj.element).mouseover(function() {
		                    em.show();
		                }).mouseout(function() {
		                    em.hide();
		                });
		            });
		        }
		    }
		}).form();
		return flag;
	}
	
	function selectAJPCheckbox(checkFlag){
		if(checkFlag){
			$("[id=ajpEnabled]:checkbox").attr("checked", true);
			$("[id=type]:input").attr("disabled",false);
			$("[id=address]:input").attr("disabled",false);
			$("[id=port]:input").attr("disabled",false);
			$("[id=backlog]:input").attr("disabled",false);
			$("[id=urlEncoding]:input").attr("disabled",false);
			$("[id=timeout]:input").attr("disabled",false);
		}else{
			$("[id=type]:input").attr("disabled",true);
			$("[id=address]:input").attr("disabled",true);
			$("[id=port]:input").attr("disabled",true);
			$("[id=backlog]:input").attr("disabled",true);
			$("[id=urlEncoding]:input").attr("disabled",true);
			$("[id=timeout]:input").attr("disabled",true);
		}
	}
	
	function changeServerState(serverType){
		$.post( "${pageContext.request.contextPath}/protect/aasconfig/advance/getServerState",{serverType:serverType},
		function(data,status){
			if(data != '' && 'success' == status){
				$('#state_ajp').attr("class", data);
			}
		});
	}	
	
</script>
	           
