<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<form id="asconfig_ejbHandler_form" name="asconfig_ejbHandler_form">
	<table>
		<tr>
			<td>CMP1.1 Promotion:</td>
			<td><input type="checkbox" class="f2j" name="cmpPromotion"
				id="cmpPromotion" ${model.cmpPromotion ?'checked' :''}></td>
		</tr>
		<tr>
			<td>CMP2.0延迟装载:</td>
			<td><input type="checkbox" class="f2j" name="cmpDelayLoader"
				id="cmpDelayLoader" ${model.cmpDelayLoader ?'checked' :''}></td>
		</tr>
		<tr>
			<td>按引用传递:</td>
			<td><input type="checkbox" class="f2j" name="quoteTransfer"
				id="quoteTransfer" ${model.quoteTransfer ?'checked' :''}></td>
		</tr>
		<tr>
			<td>缺省EntityBean数据源:</td>
			<td><input type="text" class="f2j"
				name="defaultEntityBeanDatasource" id="defaultEntityBeanDatasource"
				value='${(empty model.defaultEntityBeanDatasource) ? "jdbc/sample" : model.defaultEntityBeanDatasource}'></td>
		</tr>
		<tr>
			<td>缺省消息连接创建器:</td>
			<td><input type="text" class="f2j"
				name="defaultResourceConnCreation" id="defaultResourceConnCreation"
				value='${(empty model.defaultResourceConnCreation)  ? "jms/ConnectionFactory" : model.defaultResourceConnCreation}'>
				<span style="color:red">*</span>
				</td>
		</tr>
		<tr>
			<td>Session存储目录:</td>
			<td><input type="text" class="f2j" name="sessionStoraCatelog"
				id="sessionStoraCatelog"
				value='${(empty model.sessionStoraCatelog) ? "store/ejb" : model.sessionStoraCatelog}'>
				<span style="color:red">*</span>
				</td>
		</tr>
		<tr>
			<td>实体bean缓存大小:</td>
			<td><input type="text" class="f2j" name="entityBeanCacheSize"
				id="entityBeanCacheSize"
				value='${model.entityBeanCacheSize}'></td>
		</tr>
		<tr>
			<td>有状态bean缓存大小:</td>
			<td><input type="text" class="f2j" name="hasStatusBeanCacheSize"
				id="hasStatusBeanCacheSize"
				value='${model.hasStatusBeanCacheSize}'></td>
		</tr>
		<tr>
			<td>运行状态:</td>
			<td><c:choose>
					<c:when test='${model.stateString eq "Running"}'>
						<span style="color: green">${model.stateString}</span>
					</c:when>
					<c:otherwise>
						<span style="color: red">${model.stateString}</span>
					</c:otherwise>
				</c:choose></td>
		</tr>
	</table>
</form>
<script type="text/javascript">
	function ejbHandler_Init() {
		$("#asconfig_ejbHandler_form").validate(
		{
				validateOnEmpty : true,
				rules : {
					defaultResourceConnCreation : {
						required : true,
					},
					sessionStoraCatelog : {
						required : true,
					},
					entityBeanCacheSize : {
						digits : true,
						min : 0
					},
					hasStatusBeanCacheSize : {
						digits : true,
						min : 0
					}
				},
				messages : {
					defaultResourceConnCreation : {
						required : '值不能为空!'
					},
					sessionStoraCatelog : {
						required : '值不能为空!'
					},
					entityBeanCacheSize : {
						required : '值不能为空!',
						digits : '请输入正整数!',
						min : '请输入正整数!'
					},
					hasStatusBeanCacheSize : {
						required : '值不能为空!',
						digits : '请输入正整数!',
						min : '请输入正整数!'
					}
				},
				showErrors : function(errorMap, errorList) {
					var next = $(this.currentElements).next();
					while (next.hasClass('errorMsg')) {
						next.remove();
						next = $(this.currentElements).next();
					}
					$(this.currentElements).removeClass('error');
					$(this.currentElements).unbind('mouseover').unbind(
							'mouseout');
					if (errorList && errorList.length > 0) {
						$.each(errorList, function(index, obj) {
							$(obj.element).addClass('error');
							var msg = this.message;
							var em = $('<span class="errorMsg">{0}</span>'
									.format(msg));
							$(obj.element).after(em);
							$(obj.element).mouseover(function() {
								em.show();
							}).mouseout(function() {
								em.hide();
							});
						});
					}
				}
				});
		}
</script>
