<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<form id="Http_config_param_form" name="Http_config_param_form">
	<table align="center">
		<tr>
			<td>最大等待客户数:</td>
			<td><input type="text" class="f2j" name="maxWaitingClients"
				id="maxWaitingClients" value="${(empty model.maxWaitingClients)? 500 : model.maxWaitingClients}">
				<span style="color: red">*</span>
				</td>
			<td>等待客户超时时间(s):</td>
			<td><input type="text" class="f2j" name="waitingClientTimeout"
				id="waitingClientTimeout" value="${(empty model.waitingClientTimeout) ? 10 : model.waitingClientTimeout}">
				<span style="color: red">*</span>
				</td>
		</tr>
		<tr>
			<td>文件缓存大小(KB):</td>
			<td><input type="text" class="f2j" name="fileCacheSize"
				id="fileCacheSize" value="${(empty model.fileCacheSize)? 1024 : model.fileCacheSize }">
				<span style="color: red">*</span>
				</td>
			<td>Servlet检查间隔(s):</td>
			<td><input type="text" class="f2j"
				name="servletReloadCheckIntegererval"
				id="servletReloadCheckIntegererval"
				value="${(empty model.servletReloadCheckIntegererval) ? 3 : model.servletReloadCheckIntegererval}">
				<span style="color: red">*</span>
				</td>
		</tr>
		<tr>
			<td>URI编码:</td>
			<td><input type="text" class="f2j" name="uriEncoding"
				id="uriEncoding" value="${model.uriEncoding}"></td>
			<td>运行状态:</td>
			<td>
				<c:choose>
					<c:when test='${model.stateString eq "Running"}'>
						<span style="color:green">${model.stateString}</span>
					</c:when>
					<c:otherwise>
						<span style="color:red">${model.stateString}</span>
					</c:otherwise>
				</c:choose>
			</td>
		</tr>
		<tr>
			<td colspan="4"><span>Keep Alive:</span>
				<hr
					style="width: 100%; height: 1px; border: none; border-top: 1px dashed #0066CC;" />
			</td>
		</tr>
		<tr>
			<td>开启keepAlive:</td>
			<td><input type="checkbox" class="f2j" name="keepAlive"
				id="keepAlive" ${model.keepAlive ? 'checked' :'' }></td>
			<td>KeepAlive超时时间(s)：</td>
			<td><input type="text" class="f2j" name="keepAliveTimeout"
				id="keepAliveTimeout" value="${(empty model.keepAliveTimeout) ? 15 :model.keepAliveTimeout}"></td>
		</tr>
		<tr>
			<td>最大keepAlive请求数:</td>
			<td><input type="text" class="f2j" name="maxKeepAliveRequests"
				id="maxKeepAliveRequests" value="${(empty model.maxKeepAliveRequests) ? 100:model.maxKeepAliveRequests}"></td>
			<td>最大keepAlive链接数:</td>
			<td><input type="text" class="f2j"
				name="maxKeepAliveConnections" id="maxKeepAliveConnections"
				value="${(empty model.maxKeepAliveConnections)? 300 :model.maxKeepAliveConnections}"></td>
		</tr>

		<tr>
			<td colspan="4"><span>访问日志:</span>
				<hr
					style="width: 100%; height: 1px; border: none; border-top: 1px dashed #0066CC;" />
			</td>
		</tr>
		<tr>
			<td>开启访问日志:</td>
			<td><input type="checkbox" class="f2j" name="enableLog"
				id="enableLog" ${model.enableLog ? 'checked' :'' } ></td>
			<td>日志文件大小(Byte):</td>
			<td><input type="text" class="f2j" name="logFileLimit"
				id="logFileLimit"
				value="${(empty model.logFileLimit) ? 1000000 : model.logFileLimit }"></td>
		</tr>
		<tr>
			<td>日志文件名:</td>
			<td><input type="text" class="f2j" name="logFileName"
				id="logFileName"
					value="${(empty model.logFileName)  ? 'logs/access.log': model.logFileName}"
				></td>
			<td>日志格式:</td>
			<td><input type="text" class="f2j" name="logFormat"
				id="logFormat"
				value="${(empty model.logFormat)  ? '%a %l %u %t %r %s %b': model.logFormat}"></td>
		</tr>
		<tr>
			<td>日志输出对象:</td>
			<td>
				<select name="logHandler" id="logHandler" style="width:140px" >
					<c:choose>
						<c:when test='${model.logHandler eq "java.util.logging.FileHandler"}'>
							<option value="java.util.logging.FileHandler" selected="selected">FileHandler</option>
							<option value="com.apusic.logging.DateFileHandler">DateFileHandler</option>
						</c:when>
						<c:otherwise>
							<option value="java.util.logging.FileHandler" >FileHandler</option>
							<option value="com.apusic.logging.DateFileHandler" selected="selected">DateFileHandler</option>
						</c:otherwise>
					</c:choose>
				</select>
			</td>
			<td>日志文件数量:</td>
			<td><input type="text" class="f2j" name="logFileCount"
				id="logFileCount" value="${(empty model.logFileCount)? 10: model.logFileCount}"></td>
		</tr>

	</table>
</form>
<script type="text/javascript">

	function httpConfig_Init() {
		$('#Http_config_param_form').validate(
			{
				validateOnEmpty : true,
				rules : {
					maxWaitingClients : {
						required : true,
						digits : true
					},
					waitingClientTimeout : {
						required : true,
						digits : true
					},
					fileCacheSize : {
						required : true,
						digits : true
					},
					servletReloadCheckIntegererval : {
						required : true,
						number : true
					},
					logFileName:{
						required : true,
					}
					},
					messages : {
						maxWaitingClients : {
							required : '值不能为空!',
							digits : '请填写有效数字!'
						},
						waitingClientTimeout : {
							required : '值不能为空!',
							digits : '请填写有效数字!'
						},
						fileCacheSize : {
							required : '值不能为空!',
							digits : '请填写有效数字!'
						},
						servletReloadCheckIntegererval : {
							required : '值不能为空!',
							number : '请填写有效数字!'
						},
						logFileName:{
							required : '请填写文件名!',
						}
					},
					showErrors : function(errorMap, errorList) {
						var next = $(this.currentElements).next();
						while (next.hasClass('errorMsg')) {
							next.remove();
							next = $(this.currentElements).next();
						}
						$(this.currentElements).removeClass('error');
						$(this.currentElements).unbind('mouseover').unbind(
								'mouseout');
						if (errorList && errorList.length > 0) {
							$.each(errorList, function(index, obj) {
								$(obj.element).addClass('error');
								var msg = this.message;
								var em = $('<span class="errorMsg">{0}</span>'
										.format(msg));
								$(obj.element).after(em);
								$(obj.element).mouseover(function() {
									em.show();
								}).mouseout(function() {
									em.hide();
								});
							});
						}
					}
				});

		var keepAlive = '${model.keepAlive}';
		var enableLog = '${model.enableLog}';
		selectedKeepAlive(keepAlive) ;
		selectedEnableLog(enableLog);
		
		$("#keepAlive").change(function() {
			var status = this.checked ? true:false ;
				selectedKeepAlive(status) ;
		}); 
		
		$("#enableLog").change(function() {
			var status = this.checked ? true:false ;
			selectedEnableLog(status) ;
		}); 
	}
	
	
	function selectedKeepAlive(status) {
		if (status==true || status=='true') {
			$("#keepAliveTimeout").removeAttr("disabled");
			$("#maxKeepAliveRequests").removeAttr("disabled");
			$("#maxKeepAliveConnections").removeAttr("disabled");
		} else {
			$("#keepAliveTimeout").attr("disabled", "disabled");
			$("#maxKeepAliveRequests").attr("disabled", "disabled");
			$("#maxKeepAliveConnections").attr("disabled", "disabled");
		}
	}

	function selectedEnableLog(status) {
		if (status==true || status=='true') {
			$("#logFileLimit").removeAttr("disabled");
			$("#logFileName").removeAttr("disabled");
			$("#logFormat").removeAttr("disabled");
			$("#logHandler").removeAttr("disabled");
			$("#logFileCount").removeAttr("disabled");
		} else {
			$("#logFileLimit").attr("disabled",true);
			$("#logFileName").attr("disabled",true);
			$("#logFormat").attr("disabled",true);
			$("#logHandler").attr("disabled",true);
			$("#logFileCount").attr("disabled",true);
		}
	}
</script>
