<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />

<script>
</script>
<style type="text/css">
	td.logtitle {
		color: #316AC5;
		line-height: 1.5em;
		padding-left: 5px;
		font-size:12px;
		width: 135px;
	}
	td.error {
		width: 30px;
	}
	input.loginput{
		width: 140px;
		float: left;
		text-align: left;
	}
</style>
<div style="padding: 1px 1px; overflow: hidden; width: 100%; height: 100%; background-color: #FFFFFF;">
	<form id="asconfig_httpSession_param_form" name="asconfig_httpSession_param_form">
        <table class="">
            <tr>
                <td class="logtitle">默认超时时间(秒):</td>
                <td><input type="text" class="f2j loginput" id="defaultOvertime" name="defaultOvertime" value="${httpSession.defaultOvertime}"/></td>
                <td class="error"><span class="errorImg"></span><span class="errorMsg"></span></td>
            </tr>
            <tr>
                <td class="logtitle">最大缓存数:</td>
                <td><input type="text" class="f2j loginput" id="maxCacheNum" name="maxCacheNum" value="${httpSession.maxCacheNum}"/></td>
                <td class="error"><span class="errorImg"></span><span class="errorMsg"></span></td>
            </tr>
            <tr>
                <td class="logtitle">超时检查间隔(秒):</td>
                <td><input type="text" class="f2j loginput" id="chechOvertimeInterval" name="chechOvertimeInterval" value="${httpSession.chechOvertimeInterval}"/></td>
                <td class="error"><span class="errorImg"></span><span class="errorMsg"></span></td>
            </tr>
            <tr>
                <td class="logtitle">交换时间间隔(秒):</td>
                <td><input type="text" class="f2j loginput"   id="exchangeTimeInterval" name="exchangeTimeInterval" value="${httpSession.exchangeTimeInterval}"/></td>
                <td class="error"><span class="errorImg"></span><span class="errorMsg"></span></td>
            </tr>
            <tr>
                <td class="logtitle">运行Session分布式:</td>
                <td><input type="checkbox" class="f2j" name="runningSessionDistributed" ${httpSession.runningSessionDistributed ? ' checked="checked"' : ' ' }/></td>
                <td class="error"><span class="errorImg"></span><span class="errorMsg"></span></td>
            </tr>
            <tr>
                <td class="logtitle">允许Session复制:</td>
                <td><input type="checkbox" class="f2j" name="permitCopySession" ${httpSession.permitCopySession ? ' checked="checked"' : ' ' }/></td>
                <td class="error"><span class="errorImg"></span><span class="errorMsg"></span></td>
            </tr>
            <tr>
                <td class="logtitle">开启Session粘滞:</td>
                <td><input type="checkbox" class="f2j" name="sessionStick" ${httpSession.sessionStick ? ' checked="checked"' : ' ' }/></td>
                <td class="error"><span class="errorImg"></span><span class="errorMsg"></span></td>
            </tr>
            <tr>
                <td class="logtitle">持久Session:</td>
                <td><input type="checkbox" class="f2j" name="persistentSession" ${httpSession.persistentSession ? ' checked="checked"' : ' ' }/></td>
                <td class="error"><span class="errorImg"></span><span class="errorMsg"></span></td>
            </tr>
            <tr>
                <td class="logtitle">应用停止时销毁session:</td>
                <td><input type="checkbox" class="f2j" name="destroySession" ${httpSession.destroySession ? ' checked="checked"' : ' ' }/></td>
                <td class="error"><span class="errorImg"></span><span class="errorMsg"></span></td>
            </tr>
            <tr>
                <td class="logtitle">运行状态:</td>
                <td>
				<c:choose>
					<c:when test='${httpSession.stateString eq "Running"}'>
						<span style="color: green">${httpSession.stateString}</span>
					</c:when>
					<c:otherwise>
						<span style="color: red">${httpSession.stateString}</span>
					</c:otherwise>
				</c:choose>                
                </td>
                <td class="error"><span class="errorImg"></span><span class="errorMsg"></span></td>
            </tr>
        </table>
    </form>
</div>
<script type="text/javascript">

	function httpSession_Init() {
		$('#asconfig_httpSession_param_form').validate(
			{
				validateOnEmpty : false,
				rules : {
					defaultOvertime : {
						digits : true
					},
					maxCacheNum : {
						digits : true
					},
					chechOvertimeInterval : {
						digits : true
					},
					exchangeTimeInterval : {
						digits : true
					}
					},
					messages : {
						defaultOvertime : {
							digits : '请填写有效数字!'
						},
						maxCacheNum : {
							digits : '请填写有效数字!'
						},
						chechOvertimeInterval : {
							digits : '请填写有效数字!'
						},
						servletReloadCheckIntegererval : {
							digits : '请填写有效数字!'
						},
						exchangeTimeInterval:{
							digits : '请填写有效数字!'
						}
					},
					showErrors : function(errorMap, errorList) {
						var next = $(this.currentElements).next();
						while (next.hasClass('errorMsg')) {
							next.remove();
							next = $(this.currentElements).next();
						}
						$(this.currentElements).removeClass('error');
						$(this.currentElements).unbind('mouseover').unbind(
								'mouseout');
						if (errorList && errorList.length > 0) {
							$.each(errorList, function(index, obj) {
								$(obj.element).addClass('error');
								var msg = this.message;
								var em = $('<span class="errorMsg">{0}</span>'
										.format(msg));
								$(obj.element).after(em);
								$(obj.element).mouseover(function() {
									em.show();
								}).mouseout(function() {
									em.hide();
								});
							});
						}
					}
				});
	}
	
</script>
