<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>Apusic应用服务器参数配置</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-rules.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/form.js"></script>
<script type="text/javascript" src="${resBase}/scripts/asconfig.js"></script>
<script type="text/javascript" src="${resBase}/scripts/config/threadpool.js"></script>
<script type="text/javascript" src="${resBase}/scripts/config/mux.js"></script>
<link rel="stylesheet" type="text/css"
    href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/config.css" />



<script>
$(function() {
    window.$c = AASMonitor.asconfig;
    $c.baseUrl = '${contextPath}/protect/aasconfig';
});



function showMsgTip(msg,type) {     
    $.omMessageTip.show({
        type : type,
        title : '提示信息',
        content : msg,
        timeout : 4000
    });
}
</script>
</head>
<body>
    <div class="body_wrapper">
        <div class="config_category">
            <div class="category_title">HTTP服务</div>
            <ul>
                <li>
                  <a href="#" onclick="$c.httpWebConfig();"><div class="http_config"></div><span>HTTP配置</span></a>
                </li>
                <li>
                    <a href="#" onclick="$c.httpSession();"><div class="session_service"></div><span>会话服务</span></a>
                </li>
                <li>
                    <a href="#" onclick="$c.httpSessionStore();"><div class="session_store"></div><span>会话存储</span></a>
                </li>
            </ul>
        </div>
        <div class="config_category">
            <div class="category_title">系统服务</div>
            <ul>
                <li>
                    <a href="#" onclick="$c.muxConfig();"><div class="mux"></div><span>多路复用</span></a>
                </li>
                <li>
                    <a href="#" onclick="$c.transactionService();"><div class="transction"></div><span>事务服务</span></a>
                </li>
                <li>
                    <a href="#" onclick="$c.jdbcService();"><div class="jdbc"></div><span>JDBC服务</span></a>
                </li>
                <li>
                    <a href="#" onclick="$c.deployService();"><div class="deploy"></div><span>部署服务</span></a>
                </li>
                <li>
                    <a href="#" onclick="$c.securityService();"><div class="security"></div><span>安全服务</span></a>
                </li>
                <li>
                    <a href="#" onclick="$c.ejbService();"><div class="ejb_service"></div><span>EJB服务</span></a>
                </li>
                <li>
                    <a href="#" onclick="$c.ejbTimer();"><div class="ejb_timmer"></div><span>EJB定时器</span></a>
                </li>
            </ul>
        </div>
        <div class="config_category">
            <div class="category_title">高级服务</div>
            <ul>
                <li class="${ajpCfg.stateString}" id="state_ajp">
                    <a href="#" onclick="$c.ajpConfig();"><div class="ajp"></div><span>AJP服务</span></a>
                </li>
                <li class="${acpCfg.stateString}" id="state_acp">
                    <a href="#" onclick="$c.acpConfig();"><div class="acp"></div><span>ACP服务</span></a>
                </li>
                <li class="${classloaderCfg.stateString}" id="state_classloader">
                    <a href="#" onclick="$c.classloaderConfig();"><div class="classloader"></div><span>类装载查看</span></a>
                </li>
                <li class="${jdbcMonitorCfg.stateString}" id="state_jdbc">
                    <a href="#" onclick="$c.jdbcMonitorConfig();"><div class="jdbc_monitor"></div><span>JDBC监控</span></a>
                </li>
                <li class="${jmsCfg.stateString}" id="state_jms">
                    <a href="#" onclick="$c.jmsServerConfig();"><div class="jms_service"></div><span>JMS服务</span></a>
                </li>
            </ul>
        </div>
        <div class="config_category">
            <div class="category_title">线程池服务</div>
            <ul>
                <li class="${default.stateString}" id="state_default">
                    <a href="#" onclick="$c.defaultHandler();"><div class="default_pool"></div><span>Default</span></a>
                </li>
                <li>
                    <a href="#" onclick="$c.httpHandler();"><div class="httphandler"></div><span>HTTPHandler</span></a>
                </li>
                <li class="${muxhandler.stateString}" id="state_MuxHandler">
                    <a href="#" onclick="$c.muxHandler();"><div class="muxhandler"></div><span>MuxHandler</span></a>
                </li>
                <c:if test="${jmsType eq 'AAS'}">
                <li class="${jmshandler.stateString}" id="state_JMSHandler">
                    <a href="#" onclick="$c.jmsHandler();"><div class="jmshandler"></div><span>JMSHandler</span></a>
                </li>
                </c:if>
                <c:if test="${jmsType eq 'MQ'}">
                <li class="${mqhandler.stateString}" id="state_MQHandler">
                    <a href="#" onclick="$c.mqHandler();"><div class="jmshandler"></div><span>MQHandler</span></a>
                </li>
                </c:if>
                <li class="${orbworker.stateString}" id="state_ORBWorker">
                    <a href="#" onclick="$c.orbHandler();"><div class="orbworker"></div><span>ORBWorker</span></a>
                </li>
            </ul>
        </div>
    </div>
</body>
</html>
