<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />

<script>
</script>
<style type="text/css">
	td.logtitle {
		color: #316AC5;
		line-height: 1.5em;
		padding-left: 5px;
		font-size:12px;
		width: 120px;
	}
</style>
<div style="padding: 1px 1px; width: 100%; overflow: hidden; background-color: #FFFFFF;">
	<form id="asconfig_jdbcTracer_param_form" name="asconfig_jdbcTracer_param_form">
        <table class="">
            <tr>
                <td class="logtitle">启用JDBCTracer服务:</td>
                <td><input type="checkbox" id="jdbcTracerEnabled"  name="jdbcTracerEnabled" ${jdbcTracerServiceConfig.jdbcTracerEnabled ? ' checked="checked"' : ' ' } onclick="selectJDBCTracerCheckbox(this.checked);"/></td>
            </tr>
            <tr>
                <td class="logtitle">数据源语句跟踪:</td>
                <td><input type="checkbox" id="traceAllow" name="traceAllow" ${jdbcTracerServiceConfig.traceAllow ? ' checked="checked"' : ' ' }  ${jdbcTracerServiceConfig.jdbcTracerEnabled ? ' ' : ' disabled="disabled" ' } onclick="selectTraceAllowCheckbox(this.checked);"  /></td>
            </tr>
            <tr>
                <td class="logtitle">跟踪数据源堆栈:</td>
                <td><input type="checkbox" id="stackTraceAllow" name="stackTraceAllow" ${jdbcTracerServiceConfig.stackTraceAllow ? ' checked="checked"' : ' ' } ${jdbcTracerServiceConfig.traceAllow ? ' ' : ' disabled="disabled" ' } /></td>
            </tr>     
            <tr>
                <td class="logtitle">启用泄露检查:</td>
                <td><input type="checkbox" id="jdbcAbandonEnabled"  name="jdbcAbandonEnabled" ${jdbcTracerServiceConfig.jdbcAbandonEnabled ? ' checked="checked"' : ' ' } onclick="selectJDBCAbandonCheckbox(this.checked);"/></td>
            </tr>
            <tr>
                <td class="logtitle">启用泄露回收:</td>
                <td><input type="checkbox" id="jdbcReapEnabled"  name="jdbcReapEnabled" ${jdbcTracerServiceConfig.jdbcReapEnabled ? ' checked="checked"' : ' ' } onclick="selectJDBCReapCheckbox(this.checked);"/></td>
            </tr> 
             <tr>
                <td class="logtitle">泄露超时时间:</td>
                <td><input type="text" id="jdbcAbandonTimeout"  name="jdbcAbandonTimeout" value="${jdbcTracerServiceConfig.jdbcAbandonTimeout}"/></td>
            </tr>
            <tr>
                <td class="logtitle">连接最长寿命:</td>
                <td><input type="text" id="jdbcMaxDuration"  name="jdbcMaxDuration" value="${jdbcTracerServiceConfig.jdbcMaxDuration}"/></td>
            </tr>    
            <tr>
                <td class="logtitle">运行状态:</td>
                <td>
	               	<c:choose>
						<c:when test='${jdbcTracerServiceConfig.stateString eq "Running"}'>
							<span style="color:green">${jdbcTracerServiceConfig.stateString}</span>
						</c:when>
						<c:otherwise>
							<span style="color:red">${jdbcTracerServiceConfig.stateString}</span>
						</c:otherwise>
					</c:choose>
                </td>
            </tr>
        </table>
    </form>
</div>
<script type="text/javascript">

	function saveJDBCTracerConfig(Obj){
		var flag = validateForm();
		if(flag){
	  		$.ajax({
				type : "post",
				async:false,
				dataType : "text",
				url :'${pageContext.request.contextPath}/protect/aasconfig/advance/updateJDBCTracer',
				data : AASMonitor.FormToJSON.formToJSON($('#asconfig_jdbcTracer_param_form')),
				error: function(){
					showMsgTip("请求错误,请重新提交!","error");
				},
				complete : function() {
					changeServerState('JDBCTRACER');
				},
				success : function(data) {
					if(data=="success"){
						showMsgTip("配置JDBC监控成功！重启后生效！","success");
					}else{
						showMsgTip("配置JDBC监控失败！","warning");
					}
					Obj.omDialog('destroy');
					Obj.remove();
				}
			});
		} else {
			return false;
		}
	}
	
	function validateForm(){
		var flag = $("#asconfig_jdbcTracer_param_form").validate({
			rules : {
				jdbcAbandonTimeout: {
	         		 required : true,
	         		 isInteger  : true,
	         		 isNum : true
	                },
	            jdbcMaxDuration: {
		         	required : true,
		         	isInteger  : true,
		         	isNum : true
		        },
			},
			messages : {
				jdbcAbandonTimeout: {
	         		 required : "请输入有效的整数",
	         		 isInteger  : "请输入有效的整数",
	         		 isNum: "请输入大于等于0的数字"
	                },
	            jdbcMaxDuration: {
		         	required : "请输入有效的整数",
		         	isInteger  : "请输入有效的整数",
		         	isNum: "请输入大于等于0的数字"
		        },
			},
			errorPlacement : function(error, element) {
                if(error.html()){
                    $(element).parents().map(function(){
                        if(this.tagName.toLowerCase()=='td'){
                            var attentionElement = $(this).next().children('.errorMsg').eq(0);
    	                    attentionElement.html(error);
                        }
                    });
                }
	        },

            showErrors: function(errorMap, errorList) {
                if(errorList && errorList.length > 0){
                    $.each(errorList,function(index,obj){
                        var msg = this.message;
                        $(obj.element).parents().map(function(){
	                        if(this.tagName.toLowerCase()=='td'){
	                            var attentionElement = $(this).next().children('.errorMsg').eq(0);
	    	                    attentionElement.html(msg);
	                        }
	                    });
	                   });
                }else{
                    $(this.currentElements).parents().map(function(){
                        if(this.tagName.toLowerCase()=='td'){
                            $(this).next().children('.errorMsg').eq(0).hide();
                        }
                    });
                }
                this.defaultShowErrors();
            }
		}).form();		
		return flag;
	}
	
	function selectJDBCAbandonCheckbox(checkFlag) {
		if(checkFlag){
			$("[id=jdbcAbandonEnabled]:checkbox").attr("checked", true);
		}else{
			$("[id=jdbcAbandonEnabled]:checkbox").attr("checked",false);
		}
	}
	
    function selectJDBCReapCheckbox(checkFlag) {
    	if(checkFlag){
			$("[id=jdbcReapEnabled]:checkbox").attr("checked", true);
		}else{
			$("[id=jdbcReapEnabled]:checkbox").attr("disabled",false);
		}
	}
	
	function selectTraceAllowCheckbox(checkFlag){
		if(checkFlag){
			$("[id=traceAllow]:checkbox").attr("checked", true);
			$("[id=stackTraceAllow]:checkbox").attr("disabled",false);
		}else{
			$("[id=stackTraceAllow]:checkbox").attr("disabled",true);
		}
	}	
	function selectJDBCTracerCheckbox(checkFlag){
		if(checkFlag){
			$("[id=jdbcTracerEnabled]:checkbox").attr("checked", true);
			$("[id=traceAllow]:checkbox").attr("disabled",false);
			$("[id=stackTraceAllow]:checkbox").attr("disabled",false);
		}else{
			$("[id=traceAllow]:checkbox").attr("disabled",true);
			$("[id=stackTraceAllow]:checkbox").attr("disabled",true);
		}
	}
	
	function changeServerState(serverType){
		$.post( "${pageContext.request.contextPath}/protect/aasconfig/advance/getServerState",{serverType:serverType},
		function(data,status){
			if(data != '' && 'success' == status){
				$('#state_jdbc').attr("class", data);
			}
		});
	}	
</script>
	           
