<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />

<script>
</script>
<style type="text/css">
	td.logtitle {
		color: #316AC5;
		line-height: 1.5em;
		padding-left: 5px;
		font-size:12px;
		width: 75px;
	}
	input.loginput{
		width: 160px;
		float: left;
		text-align: left;
	}

		
</style>
<div style="padding: 1px 1px; width: 100%;  overflow: hidden; background-color: #FFFFFF;">
	<form id="asconfig_jms_param_form" name="asconfig_jms_param_form">
        <table class="">
            <tr>
                <td class="logtitle">本地路由名:</td>
                <td><input type="text" class="loginput" id="routerName" name="routerName" value="${jmsServiceConfig.routerName}" readonly="readonly"/></td>
            </tr>
            <tr>
                <td class="logtitle">远程路由:</td>
                <td><input type="text" class="loginput" id="remoteRouters" name="remoteRouters" value="${jmsServiceConfig.remoteRouters}"/></td>
            </tr>
             <c:if test="${jmsType eq 'AAS'}">
              <tr>
                <td class="logtitle">存储目录:</td>
                <td><input type="text" class="loginput" id="storeDirectory" name="storeDirectory" value="${jmsServiceConfig.storeDirectory}"/><span class="color_red">*</span></td>
            </tr>
            </c:if>
        </table>
    </form>
    <div style="margin: 0 10px;"><hr style="height:1px;border:none; border-top:1px solid #99BBE8;}" /></div>
	<form id="asconfig_jms_opt_form" name="asconfig_acp_param_form">
        <div style="padding: 5px 1px;">
            <div id="startJMS_div" style="height: 22px;" ><a href="#" onclick="operaterJms('start');" style="text-decoration: none; cursor:pointer; ">
            	<img alt="" src="${resBase}/images/start.png" border="0px" hspace="5" align="left">启动 JMS 服务
            </a></div>
            <div id="stopJMS_div" style="height: 22px;" ><a href="#" onclick="operaterJms('stop');" style="text-decoration: none; cursor:pointer; ">
            	<img alt="" src="${resBase}/images/stop.png" border="0px" hspace="5" align="left">停止 JMS 服务
            </a></div>
            <div id="restartJMS_div" style="height: 22px;" ><a href="#" onclick="operaterJms('restart');" style="text-decoration: none; cursor:pointer; ">
            	<img alt="" src="${resBase}/images/restart.png" border="0px" hspace="5" align="left">重启 JMS 服务
            </a></div>
            <div style="height: 22px; margin-top:10px; padding-left: 5px;"  id="jmsState" >
	               	<c:choose>
						<c:when test='${jmsServiceConfig.stateString eq "Running"}'>
							运行状态:<span style="color:green">${jmsServiceConfig.stateString}</span>
						</c:when>
						<c:otherwise>
							运行状态:<span style="color:red">${jmsServiceConfig.stateString}</span>
						</c:otherwise>
					</c:choose>            
            </div>
        </div>
    </form>
    
</div>
<script type="text/javascript">

	$(function() {
		setState("${jmsServiceConfig.stateString}");
	});
	
	function setState(state){
		if("Running" == state){
			$("#startJMS_div").css("display","none");
			$("#stopJMS_div").css("display","block");
			$("#restartJMS_div").css("display","block");
		}else{
			$("#startJMS_div").css("display","block");
			$("#stopJMS_div").css("display","none");
			$("#restartJMS_div").css("display","none");
		}
	}

	function saveJMSServerConfig(Obj){
        var flag = $("#asconfig_jms_param_form").validate().form();          
		if(flag){
	  		$.ajax({
				type : "post",
				async:false,
				dataType : "text",
				url :'${pageContext.request.contextPath}/protect/aasconfig/advance/updateJMSServer',
				data : AASMonitor.FormToJSON.formToJSON($('#asconfig_jms_param_form')),
				error: function(){
					showMsgTip("请求错误,请重新提交!","error");
				},
				success : function(data) {
					if(data=="success"){
						showMsgTip("配置JMS服务成功！重启后生效!","success");
					}else{
						showMsgTip(data,"warning");
					}
					Obj.omDialog('destroy');
					Obj.remove();
				}
			});			
		}else{
			return false;
		}
	}
	
	function validateForm(){
		var flag = $('#asconfig_jms_param_form').validate({
		    validateOnEmpty : true,
		    rules : {
		    	storeDirectory : {
		            required : true
		        }
		    },
		    messages : {
		    	storeDirectory : {
		            required : '存储目录为必填项，默认为store/jms'
		        }
		    },
		    showErrors: function(errorMap, errorList) {
		        var next = $(this.currentElements).next();
		        while(next.hasClass('errorMsg')) {
		            next.remove();
		            next = $(this.currentElements).next();
		        }
		    	alert("validateForm");
		        $(this.currentElements).removeClass('error');
		        $(this.currentElements).unbind('mouseover').unbind('mouseout');
		        if(errorList && errorList.length > 0){
		            $.each(errorList, function(index, obj){
		                $(obj.element).addClass('error');
		                var msg = this.message;
		                var em = $('<span class="errorMsg">{0}</span>'.format(msg));
		                $(obj.element).after(em);
		                $(obj.element).mouseover(function() {
		                    em.show();
		                }).mouseout(function() {
		                    em.hide();
		                });
		            });
		        }
		    }
		}).form();
		return flag;
	}
	
	function operaterJms(type){
		var urlStr = '${pageContext.request.contextPath}/protect/aasconfig/advance/';
		var msg = '操作';
		if("start" == type){
			urlStr += 'startJms';
			msg = '启动JMS成功！';
		}else if("stop" == type){
			urlStr += 'shutDownJms';
			msg = '停止JMS成功！';
		}else if("restart" == type){
			urlStr += 'restartJms';
			msg = '重启JMS成功！';
		}
		$.ajax({
			type : "post",
			async:false,
			dataType : "text",
			url :urlStr,
			error: function(){
				showMsgTip("请求错误,请重新提交!","error");
			},
			complete : function() {
				changeServerState('JMS');
			},
			success : function(data) {
				if(data=="success"){
					showMsgTip(msg,"success");
					var state = "";
					if("stop" != type){
						state = "Running";
						$("#jmsState").html("运行状态:<span style='color:green'>Running</span>");
					}else{
						$("#jmsState").html("运行状态:<span style='color:red'>Stopped</span>");
					}
					setState(state);
				}else{
					showMsgTip(data,"warning");
				}
			}
		});
	}
	
	
	function changeServerState(serverType){
		$.post( "${pageContext.request.contextPath}/protect/aasconfig/advance/getServerState",{serverType:serverType},
		function(data,status){
			if(data != '' && 'success' == status){
				$('#state_jms').attr("class", data);
			}
		});
	}	
</script>
