<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<form id="asconfig_securityHandler_form" name="asconfig_securityHandler_form">
	<table align="center">
		<tr>
			<td>开启Kerberos：</td>
			<td><input type="checkbox" class="f2j" 
				name="krb5Enabled" id="krb5Enabled"
				 ${model.krb5Enabled ?'checked' :''} 
				></td>
		</tr>
		<tr>
			<td>Kerberos用户:</td>
			<td><input type="text" class="f2j" name="krb5Principal"
				id="krb5Principal" value="${model.krb5Principal }">
				<span style="color:red">*</span>
				</td>
		</tr>
		<tr>
			<td>Kerberos密码:</td>
			<td><input type="password" class="f2j" name="krb5Password"
				id="krb5Password" value="${model.krb5Password }" autocomplete="off"/>
				<span style="color:red">*</span>
				</td>
		</tr>
		<tr>
			<td>运行状态:</td>
			<td>
				<c:choose>
					<c:when test='${model.stateString eq "Running"}'>
						<span style="color:green">${model.stateString}</span>
					</c:when>
					<c:otherwise>
						<span style="color:red">${model.stateString}</span>
					</c:otherwise>
				</c:choose>
			</td>
		</tr>
	</table>
</form>
<script type="text/javascript">
	
	function securityHandler_Init(){
		
		$('#asconfig_securityHandler_form').validate( {
			validateOnEmpty : true,
			rules : {
				krb5Principal : {
					required : true,
				},
				krb5Password : {
					required : true,
				}
			},
			messages : {
				krb5Principal : {
					required : '值不能为空!'
				},
				krb5Password : {
					required : '值不能为空!'
				}
			},
			showErrors : function(errorMap, errorList) {
				var next = $(this.currentElements).next();
				while (next.hasClass('errorMsg')) {
					next.remove();
					next = $(this.currentElements).next();
				}
				$(this.currentElements).removeClass('error');
				$(this.currentElements).unbind('mouseover').unbind(
						'mouseout');
				if (errorList && errorList.length > 0) {
					$.each(errorList, function(index, obj) {
						$(obj.element).addClass('error');
						var msg = this.message;
						var em = $('<span class="errorMsg">{0}</span>'
								.format(msg));
						$(obj.element).after(em);
						$(obj.element).mouseover(function() {
							em.show();
						}).mouseout(function() {
							em.hide();
						});
					});
				}
			}
		});
		
	}
</script>
