<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<style type="text/css">
span.color_red {
	color: red;
}
</style>
<form id="system_server_transaction_config">
<table>
	<tr>
		<td>默认超时时间(秒):</td>
		<td><input type="text" id="defaultOvertime" name="defaultOvertime" value="${model.defaultOvertime}"/><span class="color_red">*</span></td>
	</tr>
	<tr>
		<td>重试超时时间(秒):</td>
		<td><input type="text" name="retryOvertime" value="${model.retryOvertime}"/><span class="color_red">*</span></td>
	</tr>
	<tr>
		<td>重试时间间隔(秒):</td>
		<td><input type="text" name="retryOvertimeInterval" value="${model.retryOvertimeInterval}"/><span class="color_red">*</span></td>
	</tr>
	<tr>
		<td>事务标识:</td>
		<td><input type="text" name="transactionMark" value="${model.transactionMark}"/><span class="color_red">*</span></td>
	</tr>
	<tr>
		<td>启发式决定:</td>
		<td>
			<select name="inspireDesicion" id="inspireDesicion" style="width:140px">
					<c:choose>
						<c:when test='${model.inspireDesicion eq "rollback"}'>
							<option value="rollback" selected="selected">回滚</option>
							<option value="commit"  >提交</option>
						</c:when>
						<c:otherwise>
							<option value="rollback" >回滚</option>
							<option value="commit" selected="selected">提交</option>
						</c:otherwise>
					</c:choose>
			</select>
		</td>
	</tr>
	<tr>
		<td>开启事务日志:</td>
		<td>
		<input id="openTransactionLog" type="checkbox" name="openTransactionLog" ${model.openTransactionLog ? ' checked="checked"' : ' ' }/>
		</td>
	</tr>
	<tr>
		<td>运行状态:</td>
		<td>
			<c:choose>
			<c:when test='${model.runningState eq "Running"}'>
				<span style="color: green">${model.runningState}</span>
			</c:when>
			<c:otherwise>
				<span style="color: red">${model.runningState}</span>
			</c:otherwise>
			</c:choose>
		</td>
	</tr>
</table>
</form>

<script type="text/javascript">
	function transaction_Init(){
		$("#system_server_transaction_config").validate({
	    	rules : {
	    		defaultOvertime : {
	    			required : true,
	       		 	isInteger  : true
	              },
	              retryOvertime : {
	            	required : true,
	       		 	isInteger  : true
	              },
	              retryOvertimeInterval : {
	            	required : true,
	             	isInteger  : true
	              },
	              transactionMark : {
	              	required : true
	              },
	              inspireDesicion : {
	              	required : true
	              }
	          },
	          messages : {
	        	  defaultOvertime : {
	        		required : "默认超时时间不能为空",
	       		  	isInteger : "请输入有效的整数"
	              },
	           	  retryOvertime : {
	           		required : "重试超时时间不能为空",
	           	  	isInteger : "请输入有效的整数"
	              },
	              retryOvertimeInterval : {
	                required : "重试时间间隔不能为空",
	                isInteger : "请输入有效的整数"
	              },
	              transactionMark : {
	                  required : "事务标识不能为空"
	              },
	              inspireDesicion : {
	                  required : "启发式决定不能为空"
	              }
	          },
	          showErrors: function(errorMap, errorList) {
	              var next = $(this.currentElements).next();
	              while(next.hasClass('errorMsg')) {
	                  next.remove();
	                  next = $(this.currentElements).next();
	              }
	              $(this.currentElements).removeClass('error');
	              $(this.currentElements).unbind('mouseover').unbind('mouseout');
	
	              if(errorList && errorList.length > 0){
	                  $.each(errorList, function(index, obj){
	                      $(obj.element).addClass('error');
	                      var msg = this.message;
	                      var em = $('<span class="errorMsg">{0}</span>'.format(msg));
	                      $(obj.element).after(em);
	                      $(obj.element).mouseover(function() {
	                          em.show();
	                      }).mouseout(function() {
	                          em.hide();
	                      });
	                  });
	              }
	
	          }
	      });
	}
</script>
