<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>Apusic应用服务器数据源管理</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="baseUrl" value="${contextPath}/protect/datasource" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/aes.js"></script>
<script type="text/javascript" src="${resBase}/scripts/pad-zeropadding-min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-rules.js"></script>
<script type="text/javascript" src="${resBase}/scripts/lib/underscore.js"></script>
<script type="text/javascript" src="${resBase}/scripts/aas-core.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/form.js"></script>
<script type="text/javascript" src="${resBase}/scripts/server_file_selector.js"></script>
<script type="text/javascript" src="${resBase}/scripts/createdatasource.js"></script>
<script type="text/javascript" src="${resBase}/scripts/datasource.js"></script>
<link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/selector.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/app.css" />

<script>
	$(function()  {
	    $('#backToListButtonbar').omButtonbar({
	    	btns : [{
	    				label : "返回列表",
	    				id : "button1",
	    				icons : {
							left : '${resBase}/images/service.png'
						},
	    				onClick : function() {
	    					backToList();
	    				}
	    			}]
	    });
	    
		aas.initContext('${contextPath}');
		window.$a = aas.ds;
		$a.baseUrl = '${baseUrl}';
			
		$('#page').omBorderLayout({
			panels : [ {
				id : "north-panel",
				region : "north",
				header : false,
			}, {
				id : "center-panel",
				header : false,
				region : "center"
			} ],
			spacing : 2
		});
		
		configDs_init();
		
		$('#btnConfig').omButton({
	        onClick : function(event){
	        	configDS();
	        }
		});
		$('#btnReset').omButton({});
		
	});

	function backToList() {
		location.href = "${baseUrl}";
	}

	function removeRow(n, cls) {
		$(n).parents('tr.' + cls).remove();
	}

	function moveDown(n) {
		var r = $(n).parents('tr.dpr');
		if (r.next().hasClass('dpr')) {
			r.next().after(r.clone());
			r.remove();
		}
	}

	function moveUp(n) {
		var r = $(n).parents('tr.dpr');
		if (r.prev().hasClass('dpr')) {
			r.prev().before(r.clone());
			r.remove();
		}
	}

	function addDriverPath() {
		var tpl = '<tr class="dpr">'
				+ '<td><input class="driver_path f2j"  name="driverClassPath" value="{0}" readonly="true" title="{0}" /></td>'
				+ '<td width="130px">'
				+ '<a href="#" onclick="moveUp(this);"><span>上移</span></a> '
				+ '<a style="margin-left:5px;" href="#" onclick="moveDown(this);"><span>下移</span></a> '
				+ '<a style="margin-left:5px;" href="#" onclick="removeRow(this,\'dpr\');"><span>删除</span></a>'
				+ '</td>' + '</tr>';
		new aas.utils.ServerFileSelector({
			suffix : '.jar',
			callback : function(data) {
				$('#driver_cls_tbl').append(tpl.format(data));
			}
		});
	}
	var cpIndex = -1;
	function addProperty(initIndex) {
		if (cpIndex < 0) {
			cpIndex = initIndex;
		}
		cpIndex++;
		var tpl = '<tr class="cpr">'
				+ '<td><input type="text" class="conn_prop_update" name="pName{0}" /></td>'
				+ '<td><input type="text" class="conn_prop_update" name="pValue{0}" /></td>'
				+ '<td>&nbsp;<a href="#" onclick="removeRow(this, \'cpr\');">删除</a></td>'
				+ '</tr>';
		$('#conn_prop_tbl').append(tpl.format(cpIndex));
	}
	function dispalyLoadingDiv() {
		$('#loadingDiv').show();
	}
	
	function configDS(){
	    if( $("#datasourceconfig").validate().form()){
	    	/* 表单提交之前 加密 password字段 */
			var key = document.getElementById("configKey").value;
			key = CryptoJS.enc.Utf8.parse(key);
			var iv = CryptoJS.enc.Utf8.parse(key);
			var pwd = document.getElementById("password").value;
			var encryptedPwd = CryptoJS.AES.encrypt(pwd, key, {
				iv : iv,
				mode : CryptoJS.mode.CBC,
				padding : CryptoJS.pad.ZeroPadding
			})
			document.getElementById("password").value = encryptedPwd;
			document.getElementById("configKey").value = "";
            $("#datasourceconfig").submit();
            $("#createloadingDiv").show();
            $("#createDSButton").attr("disabled","disabled");
        }else{
            return false;
        }
	}	
	
	function configDs_init(){
		$("#datasourceconfig").validate(
			{
				validateOnEmpty : true,
				rules : { 
					jndiName : { required : true },
					driverClassName : { required : true },
					userName : { required : true },
					password : { required : true },
					connectionURL : { required : true },
					
					maxPoolSize : { isInteger : true },
					maxFreePoolSize : { isInteger : true },
					minFreePoolSize : { isInteger : true },
					idleTimeout : { isInteger : true },
					maxWaitTime : { isInteger : true },
					minWaitTime : { isInteger : true },
					initialPoolSize : { isInteger : true },
					stmtCacheSize : { isInteger : true },
					preFetchSize : { isInteger : true }
				},
				messages : {
					jndiName : {required : 'jndiName不能为空' },
					driverClassName : {required : '驱动类不能为空' },
					userName : { required : '用户名不能为空' },
					password : { required : "请输入密码" },
					connectionURL : { required : "URL不能为空" },
					
					maxPoolSize : { isInteger : "请输入有效数字" },
					maxFreePoolSize : { isInteger : "请输入有效数字" },
					minFreePoolSize : { isInteger : "请输入有效数字" },
					idleTimeout : { isInteger : "请输入有效数字" },
					maxWaitTime : { isInteger : "请输入有效数字" },
					minWaitTime : { isInteger : "请输入有效数字" },
					initialPoolSize : { isInteger : "请输入有效数字" },
					stmtCacheSize : { isInteger : "请输入有效数字" },
					preFetchSize : { isInteger : "请输入有效数字" }
				},
				showErrors : function(errorMap, errorList) {
					var next = $(this.currentElements).next();
					while (next.hasClass('errorMsg')) {
						next.remove();
						next = $(this.currentElements).next();
					}
					$(this.currentElements).removeClass('error');
					$(this.currentElements).unbind('mouseover').unbind(
							'mouseout');
					if (errorList && errorList.length > 0) {
						$.each(errorList, function(index, obj) {
							$(obj.element).addClass('error');
							var msg = this.message;
							var em = $('<span class="errorMsg">{0}</span>'
									.format(msg));
							$(obj.element).after(em);
							$(obj.element).mouseover(function() {
								em.show();
							}).mouseout(function() {
								em.hide();
							});
						});
					}
				}
			});
		}
</script>
<%
	java.security.SecureRandom random = new java.security.SecureRandom();
	String key = String.valueOf(random.nextInt());
	int tmp = 16-key.length();
	for(int i=0;i<tmp;i++) {
		key +="0";
	}
	session.setAttribute("configKey", key);
%>
<style type="text/css">
	.om-panel-noheader {
		border: 0px;
	}
	table tr {
		line-height:25px;
	}
	.om-buttonbar {
		margin: 8px 8px 0px 8px;
	}
	
	td.basicTitle {
		width: 65px;
		font-size:12px;
		font-family: 新宋体;
		color: #333;
	}
	td.basicText {
		width: 190px;
		padding-right: 5px;
	}
	input.basicInput{
		width: 160px;
		margin-right: 1px;
	}	
	
	td.advTitle {
		width: 110px;
		font-size:12px;
		font-family: 新宋体;
		color: #333;
	}
	td.advText {
		width: 160px;
		padding-right: 5px;
	}
	input.advInput{
		width: 140px;
		margin-right: 1px;
	}	
	
</style>
</head>
<body>
	<div id="page" class="app_page">
		<div id="north-panel">
			<div id="backToListButtonbar"></div>
		</div>

		<div id="center-panel">
			<div class="app_container">
				<div class="app_container_explain">
					<div>
						<center>
							<strong>说明</strong>
						</center>
						<ul>
							<li>主属性：填写JNDI名称，驱动类名，数据空用户名，密码及连接数据库URL。</li>
							<li>高级属性-连接池： 填写连接池最大连接数，最大空闲连接数，最小空闲连接数，闲置时间，最大等待时间，最小等待时间，初始连接数，语句缓存数，结果集预存大小，重用前测试及SQL测试语句等。</li>
							<li>高级属性-类路径：驱动类所在路径，可以新增，删除，上下移动。</li>
							<li>高级属性-驱动属性：根据需要可以新增、删除、修改驱动属性。</li>
							</ul>
					</div>
				</div>
				<div class="app_container_main">
					<div class="app_container_main_content">
						<!-- start -->
						<form id="datasourceconfig"
							action="${contextPath}/protect/datasource/updateDataSource" method="post">
						<input type="hidden" name="name" id="name" value="${ds.name}">
						
						<div class="title">
							<strong>主属性</strong>
						</div>
						<hr class="app_division_line" />

							<div id="createloadingDiv"
								style="position: absolute; z-index: 2; width: 100px; height: 30px; position: absolute; top: 37%; left: 40%; color: red; display: none;">
								<img src="${resBase}/images/loading.gif" /> <span
									style="font-size: 15px;">处理中...</span>
							</div>
							<input id="contextPath" value="${contextPath}" type="hidden" />
							<input id="resBase" value="${resBase}" type="hidden" />
								<table style="margin-left: 15px;">
									<tr>
										<td class="basicTitle">名称：</td>
										<td class="basicText"> 
											<input class="basicInput" type="text"  value="${ds.name}" disabled="disabled" />
											<span class="color_red">*</span>
											</td>
											
										<td class="basicTitle">JNDI：</td>
										<td class="basicText">
											<input class="basicInput" type="text" name="jndiName"  value="${ds.jndiName}" id="jndiName" />&nbsp;<span class="color_red">*</span>
										</td>
										<td class="basicTitle">驱动类名：</td>
										<td class="basicText">
											<input class="basicInput" type="text" id="driverClassName" name="driverClassName" value="${ds.driverClassName}"/>&nbsp;<span class="color_red">*</span>
										</td>
									</tr>
									
									<tr>
										<td class="basicTitle">用户名：</td>
										<td class="basicText">
											<input class="basicInput" type="text" name="userName" value="${ds.userName}" />&nbsp;<span class="color_red">*</span>
										</td>
										<td class="basicTitle">密码：</td>
										<td class="basicText">
											<input type="hidden" id="configKey" value="${configKey}"/>
											<input class="basicInput" type="password" id="password" name="password"  value="${ds.password}" autocomplete="off"/>&nbsp;<span class="color_red">*</span>
										</td>
										<td class="basicTitle">URL：</td>
										<td class="basicText">
											<input class="basicInput" type="text" name="connectionURL" id="connectionURL"  value="${ds.connectionURL}" />&nbsp;<span class="color_red">*</span>
										</td>
									</tr>
								</table>
							
							<div class="title">
							<strong>高级属性</strong>
							</div>
							<hr class="app_division_line" />
							
							<fieldset style="margin-left: 15px;">
								<legend>
									连接池
								</legend>
									<table class="ds_cfg_tbl" cellpadding="0" cellspacing="0">
					                    <tr>
					                        <td class="advTitle">最大连接数：</td>
					                        <td class="advText"><input class="advInput" type="text" id="maxPoolSize" name="maxPoolSize"  value="${ds.maxPoolSize}" /></td>
					                        <td class="advTitle">最大空闲连接数：</td>
					                        <td class="advText"><input class="advInput" type="text" id="maxFreePoolSize" name="maxFreePoolSize"  value="${ds.maxFreePoolSize}" /></td>
					                        <td class="advTitle">最小空闲连接数：</td>
					                        <td class="advText"><input class="advInput" type="text" id="minFreePoolSize" name="minFreePoolSize"  value="${ds.minFreePoolSize}" /></td>
					                    </tr>
					                    <tr>
					                        <td class="advTitle">闲置时间(秒)：</td>
					                        <td class="advText"><input class="advInput" type="text" id="idleTimeout" name="idleTimeout"  value="${ds.idleTimeout}" /></td>
					                        <td class="advTitle">最大等待时间(秒)：</td>
					                        <td class="advText"><input class="advInput" type="text" id="maxWaitTime" name="maxWaitTime"  value="${ds.maxWaitTime}" /></td>
					                        <td class="advTitle">最小等待时间(秒)：</td>
					                        <td class="advText"><input class="advInput" type="text" id="minWaitTime" name="minWaitTime"  value="${ds.minWaitTime}" /></td>
					                    </tr>
					                    <tr>
					                        <td class="advTitle">初始连接数：</td>
					                        <td class="advText"><input class="advInput" type="text" id="initialPoolSize"  name="initialPoolSize"  value="${ds.initialPoolSize}" /></td>
					                        <td class="advTitle">语句缓存数:</td>
					                        <td class="advText"><input class="advInput" type="text" id="stmtCacheSize" name="stmtCacheSize"  value="${ds.stmtCacheSize}" /></td>
					                        <td class="advTitle">结果集预存大小：</td>
					                        <td class="advText"><input class="advInput" type="text" id="preFetchSize" name="preFetchSize"  value="${ds.preFetchSize}" /></td>
					                    </tr>
					                    <tr>
					                        <td class="advTitle">重用前测试：</td>
					                        <td class="advText"><input type="checkbox" id="testBeforeReusedFld" name="testBeforeReused" ${ds.testBeforeReused ? 'checked="checked"' : ''} /></td>
					                        <td class="advTitle">支持事务连接：</td>
					                        <td class="advText"><input type="checkbox" id="supprotJTA" name="supprotJTA" ${ds.supprotJTA ? 'checked="checked"' : ''} /></td>
					                    </tr>
					                    <tr>
					                        <td class="advTitle">SQL测试语句：</td>
					                        <td colspan="4" width="500" ><input type="text" id="testCommand"  name="testCommand" value="${ds.testCommand}" style="width: 500px;"/></td>
					                        <td class="advText"><a href="#" onclick="$a.testDS('${ds.name}', $('#testCommand').val());">测试SQL</a></td>
					                    </tr>
				                </table>
							</fieldset>
							
						  <fieldset style="margin-top: 10px; margin-left: 15px;">
			                <legend>
			                    <span class="mr_10">类路径</span>
			                    <a href="#" onclick="addDriverPath();">新增</a>
			                </legend>
			                <div style="height: 60px; overflow: auto">
			                <table id="driver_cls_tbl" class="ds_cfg_tbl" cellpadding="0" cellspacing="0">
			                    <c:forEach items="${drps}" var="dp">
			                        <tr class="dpr">
			                          <td><input class="driver_path" name="driverClassPath" value="${dp}" readonly="readonly" title="${dp}" /></td>
			                          <td width="110px">
			                              <a href="#" onclick="moveUp(this);">上移</a>
			                              <a style="margin-left:5px;" href="#" onclick="moveDown(this);">下移</a>
			                              <a style="margin-left:5px;" onclick="removeRow(this, 'dpr');">删除</a>
			                          </td>
			                      </tr>
			                    </c:forEach>
			                </table>
			                </div>
			            </fieldset>
							
							<table cellpadding="0" cellspacing="0" style="width: 100%; ">
				                <tr>
				                    <td width="44%"  valign="top">
									<fieldset  style="height:140px; margin-left: 15px;">
				                            <legend>
				                                <span class="mr_10">驱动属性</span>
				                                <a href="#" onclick="addProperty(${ds.connectionProperties.size()});">新增</a>
				                            </legend>

										<div style="height: 120px; overflow: auto;">
				                            <table id="conn_prop_tbl" class="ds_cfg_tbl" cellpadding="0" cellspacing="0">
				                                <thead>
				                                    <tr>
				                                        <th width="40">属性名</th>
				                                        <th width="40">属性值</th>
				                                        <th width="40">操作</th>
				                                    </tr>
				                                </thead>
				                                <tbody>
				                                    <c:forEach items="${ds.filteredProperties}" var="cp" varStatus="vs">
				                                        <tr class="cpr">
				                                          <td><input type="text"  name="pName${vs.index}" value="${cp.key}" /></td>
				                                          <td><input type="text"  name="pValue${vs.index}" value="${cp.value}" /></td>
				                                          <td>
				                                              <a href="#" onclick="removeRow(this, 'cpr');">删除</a>
				                                          </td>
				                                      </tr>
				                                    </c:forEach>
				                                </tbody>
				                            </table>
				                           </div>
				                        </fieldset>
				                    </td>
				                    <td width="28%" valign="top">
				                        <fieldset  style="height:140px;overflow: auto;">
				                            <legend>
				                                <span class="mr_10">远程用户访问列表</span>
				                            </legend>
				                            <ul class="security_principal">
				                                <c:forEach items="${users}" var="u">
				                                    <li>
				                                        <input type="checkbox" name="users" value="${u}" ${ds.userACL.contains(u) ? 'checked="checked"' : ''} /><label>${u}</label>
				                                    </li>
				                                </c:forEach>
				                            </ul>
				                        </fieldset>
				                    </td>
				                    <td width="28%" valign="top">
				                        <fieldset  style="height:140px;overflow: auto;">
				                            <legend>
				                                <span class="mr_10">远程组访问列</span>
				                            </legend>
				                            <ul class="security_principal">
				                                <c:forEach items="${groups}" var="g">
				                                    <li>
				                                        <input type="checkbox" name="groups" value="${g}" ${ds.groupACL.contains(g) ? 'checked="checked"' : ''} /><label>${g}</label>
				                                    </li>
				                                </c:forEach>
						                 </ul>
				                        </fieldset>
				                    </td>
				                </tr>
				            </table>

							<div style="text-align: left; margin-top: 20px; padding-left: 130px;">
								&nbsp; <input type="button" value="保存" id="btnConfig">  
								&nbsp; &nbsp;<input type="reset" value="重置" id="btnReset">
							</div>
						</form>
						<!-- end -->
						
					</div>
				</div>
			</div>
		</div>
	</div>
</body>
</html>
