<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>Apusic应用服务器数据源管理</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="baseUrl" value="${contextPath}/protect/datasource" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/lib/underscore.js"></script>
<script type="text/javascript" src="${resBase}/scripts/aas-core.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/form.js"></script>
<script type="text/javascript" src="${resBase}/scripts/server_file_selector.js"></script>
<script type="text/javascript" src="${resBase}/scripts/createdatasource.js"></script>

<link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/selector.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/app.css" />

<script>
	$(function()  {
	    $('#backToListButtonbar').omButtonbar({
	    	btns : [{
	    				label : "返回列表",
	    				id : "button1",
	    				icons : {
							left : '${resBase}/images/service.png'
						},
	    				onClick : function() {
	    					backToList();
	    				}
	    			}]
	    });
	    
		aas.initContext('${contextPath}');
		$('#page').omBorderLayout({
			panels : [ {
				id : "north-panel",
				region : "north",
				header : false,
			}, {
				id : "center-panel",
				header : false,
				region : "center"
			} ],
			spacing : 2
		});

		createDs_Init();
		
		$('#btnDeploy').omButton({
	        onClick : function(event){
	        	createDS();
	        }
		});
		$('#btnReset').omButton({});
		
	});

	function backToList() {
		location.href = "${baseUrl}";
	}

	function createDs_Init() {
		$('#dbtype').omCombo({
			width : 140,
			editable : false,
			disabled : false,
			emptyText : '请选择数据库类型',
			dataSource : [ {
				text : 'MSSQLServer',
				value : 'ms'
			}, {
				text : 'Oracle',
				value : 'oa'
			}, {
				text : 'DB2',
				value : 'db'
			}, {
				text : 'MySql',
				value : 'mysql'
			}, {
				text : '达梦',
				value : 'dm'
			}, {
				text : '人大金仓',
				value : 'kingbase'
			}, {
				text : '神舟',
				value : 'oscar'
			}, {
				text : 'other',
				value : 'other'
			} ],
			onValueChange : function(target, newValue, oldValue, event) {
				getType(newValue);
				getPort(newValue);
			}
		});

		$('#drivertype').omCombo({
			width : 340,
			editable : false,
			disabled : false,
			emptyText : '请选择驱动类型',
			onValueChange : function(target, newValue, oldValue, event) {
				getUrl(newValue);
				getDriverName(newValue);
				changeURL();
			}
		});
		
		$("#datasourceconfig").validate(
			{
					validateOnEmpty : true,
					rules : {
						name : {
							required : true
						},
						jndiName : {
							required : true
						},
						dbname : {
							required : true
						},
						host : {
							required : true
						},
						password : {
							required : true
						},
						repassword : {
							required : true,
							equalTo : "#password"
						},
						dport : {
							required : true
						},
						userName : {
							required : true
						},
						connectionURL : {
							required : true
						},
						driverClassName : {
							required : true
						}
					},
					messages : {
						name : {
							required : '名称不能为空'
						},
						jndiName : {
							required : 'jndiName不能为空'
						},
						dbname : {
							required : '数据库不能为空'
						},
						host : {
							required : '主机名称不能为空'
						},
						password : {
							required : "请输入密码"
						},
						repassword : {
							required : "确认密码不能为空",
							equalTo : "两次密码输入不一致"
						},
						dport : {
							required : '端口不能为空'
						},
						userName : {
							required : '用户名不能为空'
						},
						connectionURL : {
							required : 'URL不能为空'
						},
						driverClassName : {
							required : '驱动类不能为空'
						}
					},
					showErrors : function(errorMap, errorList) {
						var next = $(this.currentElements).next();
						while (next.hasClass('errorMsg')) {
							next.remove();
							next = $(this.currentElements).next();
						}
						$(this.currentElements).removeClass('error');
						$(this.currentElements).unbind('mouseover').unbind(
								'mouseout');
						if (errorList && errorList.length > 0) {
							$.each(errorList, function(index, obj) {
								$(obj.element).addClass('error');
								var msg = this.message;
								var em = $('<span class="errorMsg">{0}</span>'
										.format(msg));
								$(obj.element).after(em);
								$(obj.element).mouseover(function() {
									em.show();
								}).mouseout(function() {
									em.hide();
								});
							});
						}
					}
				});
	}

	function removeRow(n, cls) {
		$(n).parents('tr.' + cls).remove();
	}

	function moveDown(n) {
		var r = $(n).parents('tr.dpr');
		if (r.next().hasClass('dpr')) {
			r.next().after(r.clone());
			r.remove();
		}
	}

	function moveUp(n) {
		var r = $(n).parents('tr.dpr');
		if (r.prev().hasClass('dpr')) {
			r.prev().before(r.clone());
			r.remove();
		}
	}

	function addDriverPath() {
		var tpl = '<tr class="dpr">'
				+ '<td><input class="driver_path f2j"  name="driverClassPath" value="{0}" readonly="true" title="{0}" /></td>'
				+ '<td width="130px">'
				+ '<a href="#" onclick="moveUp(this);"><span>上移</span></a> '
				+ '<a style="margin-left:5px;" href="#" onclick="moveDown(this);"><span>下移</span></a> '
				+ '<a style="margin-left:5px;" href="#" onclick="removeRow(this,\'dpr\');"><span>删除</span></a>'
				+ '</td>' + '</tr>';
		new aas.utils.ServerFileSelector({
			suffix : '.jar',
			allowFolder : false,
			callback : function(data) {
				$('#driver_cls_tbl').append(tpl.format(data));
			}
		});
	}
	var cpIndex = -1;
	function addProperty(initIndex) {
		if (cpIndex < 0) {
			cpIndex = initIndex;
		}
		cpIndex++;
		var tpl = '<tr class="cpr">'
				+ '<td><input type="text" class="conn_prop_update" name="pName{0}" /></td>'
				+ '<td><input type="text" class="conn_prop_update" name="pValue{0}" /></td>'
				+ '<td><a href="#" onclick="removeRow(this, \'cpr\');">删除</a></td>'
				+ '</tr>';
		$('#conn_prop_tbl').append(tpl.format(cpIndex));
	}
	function dispalyLoadingDiv() {
		$('#loadingDiv').show();
	}
	
	function createDS(){
	    if($("#datasourceconfig").validate().form()){
            $("#datasourceconfig").submit();
            $("#createloadingDiv").show();
            $("#createDSButton").attr("disabled","disabled");
        }else{
            return false;
        }
	}	
</script>
<style type="text/css">
	.om-panel-noheader {
		border: 0px;
	}
	.app_config_tbl tr {
		line-height:25px;
	}
	.om-buttonbar {
		margin: 8px 8px 0px 8px;
	}
	table tr {
		line-height:25px;
	}
	td.basicTitle {
		width: 80px;
		font-size:12px;
		font-family: 新宋体;
		color: #333;
	}
	td.basicText {
		width: 200px;
		padding-right: 5px;
	}
	input.basicInput{
		width: 140px;
		margin-right: 1px;
	}
	
	
	td.connTitle {
		width: 65px;
		font-size:12px;
		font-family: 新宋体;
		color: #333;
	}
	td.connText {
		width: 180px;
		padding-right: 5px;
	}
	input.connInput{
		width: 140px;
		margin-right: 1px;
	}
</style>
</head>
<body>
	<div id="page" class="app_page">
		<div id="north-panel">
			<div id="backToListButtonbar"></div>
		</div>

		<div id="center-panel">
			<div class="app_container">
				<div class="app_container_explain">
					<div>
						<center>
							<strong>说明</strong>
						</center>
						<ul>
							<li>基本信息：填写的数据源的名称，选择数据库类型以及驱动。</li>
							<li>连接属性： 填写的数据源的数据库信息，包括数据库名，主机，端口，用户名及密码等。</li>
							<li>驱动属性：选择数据源所需要的驱动类。</li>
						</ul>
					</div>
				</div>
				<div class="app_container_main">
					<div class="app_container_main_content">
						<!-- start -->
						<form id="datasourceconfig"
							action="${contextPath}/protect/datasource/createDataSource"
							method="post">
					
						<div class="title">
							<strong>基本属性</strong>
						</div>
						<hr class="app_division_line" />
					
							<div id="createloadingDiv"
								style="position: absolute; z-index: 2; width: 100px; height: 30px; position: absolute; top: 37%; left: 40%; color: red; display: none;">
								<img src="${resBase}/images/loading.gif" /> <span
									style="font-size: 15px;">处理中...</span>
							</div>
							<input id="contextPath" value="${contextPath}" type="hidden" />
							<input id="resBase" value="${resBase}" type="hidden" />
						
							<table style="margin-left: 15px;">
								<tr>
									<td class="basicTitle">名称：</td>
									<td class="basicText"> 
										<input class="basicInput" type="text" name="name" id="name" onkeyup="changeJndi();" />&nbsp;<span class="color_red">*</span>
									</td>
									<td class="basicTitle"  >JNDI：</td>
									<td style="width: 360px;" >
										<input style="width: 335px; margin-right: 1px;" type="text" name="jndiName"  value="jdbc/" id="jndiName" />&nbsp;<span class="color_red">*</span>
									</td>
								</tr>
								<tr>
									<td class="basicTitle">数据库类型：</td>
									<td class="basicText">
										<input class="basicInput" type="text" id="dbtype" name="dbtype"  />
									</td>
									<td class="basicTitle">驱动类型：</td>
									<td style="width: 360px;">
										<input type="text" id="drivertype" name="drivertype"  />
									</td>
								</tr>
							</table>

							<div class="title">
								<strong>连接属性</strong>
							</div>
							<hr class="app_division_line" />
								
								<table style="margin-left: 15px;">
									<tr>
										<td class="connTitle">主机：</td>
										<td class="connText">
											<input class="basicInput" type="text" name="host"  id="host" onkeyup="changeURL();" />&nbsp;<span class="color_red">*</span></td>
										<td class="connTitle">端口：</td>
										<td class="connText">
											<input class="basicInput" type="text" name="port" id="dport" onkeyup="changeURL();" value="0" />&nbsp;<span class="color_red">*</span>
										</td>
										
										<td class="connTitle">数据库名：</td>
										<td class="connText">
											<input class="basicInput" type="text" name="dbname" id="dbname" onkeyup="changeURL();" />&nbsp;<span class="color_red">*</span>
										</td>
										
									</tr>
									<tr>
										<td class="connTitle">用户名：</td>
										<td class="connText">
											<input class="basicInput" type="text" name="userName"  />&nbsp;<span class="color_red">*</span>
										</td>
										<td class="connTitle">密码：</td>
										<td class="connText">
											<input class="basicInput" type="password" id="password" name="password" autocomplete="off"/>&nbsp;<span class="color_red">*</span>
										</td>
										<td class="connTitle">确认密码：</td>
										<td class="connText">
											<input class="basicInput" type="password" id="repassword" name="repassword" autocomplete="off"/>&nbsp;<span class="color_red">*</span>
										</td>
									</tr>
								</table>

								<div class="title">
								<strong>驱动属性</strong>
							</div>
							<hr class="app_division_line" />
								<table style="margin-left: 15px;">
									<tr>
										<td class="connTitle">URL：</td>
										<td style="width: 435px; padding-right: 5px; ">
											<input type="text" name="connectionURL" id="connectionURL"  style="width: 393px; margin-right: 1px;" />&nbsp;
											<span class="color_red">*</span>
										</td>
									</tr>
									<tr>
										<td class="connTitle">驱动类：</td>
										<td style="width: 435px; padding-right: 5px; ">
											<input type="text" id="driverClassName" name="driverClassName" style="width: 393px; margin-right: 1px;" />&nbsp;
											<span class="color_red">*</span>
										</td>
									</tr>
									<tr>
										<td class="connTitle">SQL测试语句：</td>
										<td style="width: 435px; padding-right: 5px; ">
											<input type="text" id="testCommand" name="testCommand" style="width: 393px; margin-right: 1px;" />&nbsp;
										</td>
									</tr>
								</table>

							<fieldset style="margin: 10px 15px 15px 5px;">
								<legend>
									<span class="mr_10">类路径</span> <a href="#"
										onclick="addDriverPath();">新增</a>
								</legend>
								  <div style="height: 60px; overflow: auto">
									<table id="driver_cls_tbl" cellpadding="0" cellspacing="0">
									</table>
								</div>
							</fieldset>
							<fieldset style="margin: 10px 15px 15px 5px;">
								<legend>
									<span class="mr_10">驱动属性</span> <a href="#"
										onclick="addDriverAtt();">新增</a> <a href="#"
										onclick="advanceDriverAtt();">高级</a>
								</legend>
								<div style="height: 120px; overflow: auto">
									<table id="conn_prop_tbl" cellpadding="0" cellspacing="0" style="margin-top: 5px;">
										<thead>
											<tr>
												<th width="60" height="20">属性名</th>
												<th width="60" height="20">属性值</th>
												<th width="60" height="20">操作</th>
											</tr>
										</thead>
										<tbody id="conn_prop_value">
										</tbody>
									</table>
								</div>
							</fieldset>

							<div style="text-align: left; margin-top: 20px; padding-left: 130px;">
								&nbsp; <input type="button" value="完成" id="btnDeploy"> 
								&nbsp; &nbsp; <input type="reset" value="重置" id="btnReset">
							</div>

						</form>

						<!-- end -->
					</div>

				</div>
			</div>
		</div>
	</div>
</body>
</html>
