<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>数据源</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<c:set var="baseUrl" value="${contextPath}/protect/datasource" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<%@ include file="/WEB-INF/common-monitor/jqplot-js.jsp"%>
<script type="text/javascript" src="${resBase}/scripts/om-rules.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript"
	src="${resBase}/scripts/lib/underscore.js"></script>
<script type="text/javascript" src="${resBase}/scripts/aas-core.js"></script>
<script type="text/javascript" src="${resBase}/scripts/form.js"></script>
<script type="text/javascript"
	src="${resBase}/scripts/server_file_selector.js"></script>
<script type="text/javascript" src="${resBase}/scripts/datasource.js"></script>
<link rel="stylesheet" type="text/css"
	href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css"
	href="${resBase}/css/selector.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/app.css" />
<link rel="stylesheet" type="text/css"
	href="${resBase}/css/datasource.css" />
<%@ include file="/WEB-INF/common-monitor/jqplot-css.jsp"%>
<%
    response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Cache-Control", "no-store");
	response.setDateHeader("Expires", 0);
	response.setHeader("Pragma", "no-cache");
%>
<script>
    var datasourceInterval;
	$(function() {

        clearDatasourceSearch();

        datasourceInterval = setInterval("datasourceIndex()", 30000);

		$('#addDSButtonbar').omButtonbar({
			btns : [ {
				label : "添加数据源",
				id : "button1",
				icons : {
					left : '${resBase}/images/add.png'
				},
				onClick : function() {
					create();
				}
			}, {
                separtor : true
            }, {
                label : "测试数据源",
                id : "button2",
                icons : {
                    left : '${resBase}/images/refresh.png'
                },
                onClick : function() {
                    refresh();
                }
            }, {
                separtor : true
            }, {
                    label : "设置刷新时间",
                    id : "button3",
                    icons : {
                        left : '${resBase}/images/nav/common.png'
                    },
                    onClick : function() {
                        clearDatasourceSearch();
                        $.ajax({
                            url: '${baseUrl}/refreshTimeIndex',
                            success:function(data){
                                var d = $("<div style='display:none;background-color: #FFFFFF;' />").appendTo($(document.body));
                                d.html(data).omDialog({
                                    autoOpen : true,
                                    closeOnEscape : false,
                                    height : 120,
                                    width : 360,
                                    modal : true,
                                    title : '设置刷新时间',
                                    buttons : [ {
                                        text : "保存",
                                        click : function() {
                                            if(!$('#datasource_refresh_config').valid()){
                                                return false ;
                                            }else{
                                                $.ajax({
                                                    url : '${baseUrl}/refreshTime',
                                                    type: 'post',
                                                    dataType: 'json',
                                                    data : {"datasourceRefreshTime": $('#datasource_refresh_config').find("input[name='refreshTime']").val()},
                                                    success : function(data) {
                                                        if ('success' == data.status) {
                                                            showMsgTip("刷新时间设置成功!","success");
                                                            d.omDialog('close');
                                                            d.omDialog('destroy');
                                                            d.remove();
                                                        } else {
                                                            showMsgTip(data.content, "error");
                                                            // d.omDialog('close');
                                                        }
                                                    },
                                                    error : function() {
                                                        showMsgTip("请求错误,请重新提交!","error");
                                                        d.omDialog('close');
                                                    }
                                                });
                                            }
                                        }
                                    }, {
                                        text : "取消",
                                        click : function() {
                                            d.omDialog('destroy');
                                            d.remove();
                                            datasourceIndex();
                                        }
                                    } ],
                                    onOpen:function(){
                                    },
                                    onClose: function() {
                                        datasourceIndex();
                                    }
                                });
                            }
                        });
                    }
                }
            ]
		});

		aas.initContext('${contextPath}');
		window.$a = aas.ds;
		$a.baseUrl = '${baseUrl}';

		if ('${dsName}'.length > 0) {
			AASMonitor.info('{1}数据源[{0}]成功！'
					.format('${dsName}', '${operation}'));
		}
		var mess = '${fn:escapeXml(errorMsg)}';
		if (mess!= null && mess != '') {
			AASMonitor.error(mess);
		}
	});

    function showMsgTip(msg,type) {
        $.omMessageTip.show({
            type : type,
            title : '提示信息',
            content : msg,
            timeout : 3000
        });
    }

	function create() {
        clearDatasourceSearch();
		location.href = "${baseUrl}/create";
	}
	function config(dsName) {
        clearDatasourceSearch();
		location.href = "${baseUrl}/config?dsName=" + dsName;
	}

    function refresh() {
        $.ajax({
            url : '${baseUrl}/testAllDS',
            data : {},
            success : function() {
                showMsgTip("测试完成", "success");
                setTimeout(datasourceIndex, 2000);

            }
        });
    }

    function clearDatasourceSearch() {
        if(datasourceInterval) {
            clearInterval(datasourceInterval);
        }
    }

    function datasourceIndex() {
        $("#west-panel", parent.document).find(".menu-middle").find(".datasource").trigger("click");
    }
</script>
</head>
<body style="width: 100%; height: 100%;">
	<div style="margin: 0px; padding: 0px;">
		<div style="padding: 8px; height: 100%; overflow: hidden;">
			<input type="hidden" id="contextPath" value="${contextPath}" />
			<div id="addDSButtonbar"></div>

			<c:choose>
				<c:when test="${dsconfigs.isEmpty()}">
					<div
						style="border: 1px solid #BCC5D2; border-top: 0; padding: 15px; color: #1C1C1C;">
						<span>尚未配置数据源</span>
					</div>
				</c:when>
				<c:otherwise>
					<div style="border: 1px solid #BCC5D2; border-top: 0;">
						<c:forEach items="${dsconfigs}" var="ds">
							<div class="app-item">
								<div class="app ds-${fn:escapeXml(ds.stateString)}">
									<table cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td valign="top">
												<div class="description">
													<span>名称：</span><span>${fn:escapeXml(ds.name)}</span> <span
														style="margin-left: 20px">JNDI名称：</span><span>${fn:escapeXml(ds.jndiName)}</span>
													<span style="margin-left: 20px">状态：</span><span
														class="state-${ds.stateString}">${ds.stateString.equals('Running')
														? '启动' : '停止'}</span>
												</div>
											</td>
											<td valign="top" width="200px;">
												<div class="inner-toolbar">
													<a href="#" onclick="config('${fn:escapeXml(ds.name)}');"><span>参数配置</span></a>
													<span class="ml_10 mr_10">|</span> <a href="#"
														onclick="$a.showTestDSDialog('${fn:escapeXml(ds.name)}');"><span>测试数据源</span></a>
												</div>
											</td>
										</tr>
										<tr>
											<td colspan="2">
												<div class="description">
													<span>URL：</span><span>${fn:escapeXml(ds.connectionURL)}</span>
												</div>
											</td>
										</tr>
										<tr>
											<td colspan="2">
												<div class="testCommandState">
													<c:choose>
														<c:when test="${ds.testCommandState.equals('success')}">
															<span>连通性：</span><span style="color: #259920">成功</span>
														</c:when>
														<c:when test="${ds.testCommandState.equals('failure')}">
															<span>连通性：</span><span style="color: #CC0000">失败</span>
														</c:when>
														<c:otherwise>
															<span>连通性：</span><span style="color: #236fcc">未知（可能未设置检测SQL语句）</span>
														</c:otherwise>
													</c:choose>
												</div>
											</td>
										</tr>
										<tr>
											<td colspan="2">
												<div class="inner-toolbar">
													<a href="#" onclick="$a.monitorDatasource('${ds.name}');">监控数据源</a>
													<span class="ml_10 mr_10">|</span>
													<c:choose>
														<c:when test="${ds.stateString.equals('Running')}">
															<a href="${baseUrl}/stopDS?dsName=${ds.name}"
																onclick="return window.confirm('确定要停止数据源吗？停止后不可使用此数据源！');"><span>停止数据源</span></a>
														</c:when>
														<c:otherwise>
															<a href="${baseUrl}/startDS?dsName=${ds.name}"
																onclick="dispalyLoadingDiv(); "><span>启动数据源</span></a>
														</c:otherwise>
													</c:choose>
													<span class="ml_10 mr_10">|</span> <a class="undeploy"
														href="${baseUrl}/removeDS?dsName=${ds.name}"
														onclick="return window.confirm('确定要卸载数据源吗？卸载后不可恢复！');">卸载</a>
												</div>
											</td>
										</tr>
									</table>
								</div>
								<hr class="app_division_line" />
							</div>

						</c:forEach>
					</div>
				</c:otherwise>
			</c:choose>
			<div id="dialogDiv" style="display: none;"></div>
			<div id="loadingDiv"
				style="position: absolute; z-index: 2; width: 100px; height: 30px; position: absolute; top: 37%; left: 40%; color: red; display: none;">
				<img src="${resBase}/images/loading.gif" /> <span
					style="font-size: 15px;">处理中...</span>
			</div>
		</div>
	</div>
</body>
</html>
