<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>JMS queue Page</title>
<c:set var="resBase" value="${pageContext.request.contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-rules.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/form.js"></script>
<script type="text/javascript" src="${resBase}/scripts/navmenu.js"></script>

<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/om-ui/om-apusic.css" />
<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/common.css" />
<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/main.css" />

</head>
<body>
		队列名称：<input type="text" id="queryName"> 状态： <select style="width:80px"
			id="queryState">
			<option value="All">全部</option>
			<option value="Running">运行</option>
			<option value="Stopped">停止</option>
		</select>
		<input type="button" onclick="query()" id="searchBtn" value="查询">
	<div id="buttonbar" style="margin-top: 5px;"></div>
    <div id="dialog-confirm" title="确认" style="display: none;">
	        确认要删除？
     </div>
	<table id="queueGrid"></table>
</body>
<script type="text/javascript">
	var jmsQueueBaseUrl = "${pageContext.request.contextPath}/protect/jms/queue";
	$(document).ready(function() {
		 $('#buttonbar').omButtonbar({
	         	width : '100%',
	         	btns : [{label:"启动",
	         		     id:"start" ,
	         		     icons : {left : '${resBase}/images/start.png'},
	         	 		 onClick:function(){start();}
	         			},
	         	        {label:"停止",
	         			 id:"stop",
	         			 icons : {left : '${resBase}/images/stop.png'},
	         	 		 onClick:function(){stop();}
	         	        },
	         	       {label:"重启",
	            			 id:"restart",
	            			 icons : {left : '${resBase}/images/restart.png'},
	            	 		 onClick:function(){restart();}
	            	    },
	         	       {label:"新增",
	            		     id:"add" ,
	            		     icons : {left : '${resBase}/images/add.png'},
	            	 		 onClick:function(){toModifyRow('');}
	            		},
	            	    {label:"删除",
	            			 id:"del",
	            			 icons : {left : '${resBase}/images/delete.png'},
	            	 		 onClick:function(){del();}
	            	    },
	            	    {label:"刷新",
	            			 id:"refresh",
	            			 icons : {left : '${resBase}/images/refresh.png'},
	            	 		 onClick:function(){query();}
	            	    }
	         		]
	        	 });
		
		$('#queueGrid').omGrid({
			limit : 20,
			width : '100%',
			height : 500,
			autoFit : true,
			showIndex : false,
			singleSelect : false,
			autoFit:true,
			colModel : [
					{
						header : '队列名称',
						name : 'name',
						width : 150,
						align : 'left',
						sort : 'clientSide'
					},
					{
						header : 'JNDI名称',
						name : 'jndiName',
						width : 150,
						align : 'left',
						sort : 'clientSide'
					},
					{
						header : '状态',
						name : 'stateString',
						width : 80,
						align : 'center',
						sort : 'clientSide',
						renderer : function(colValue, rowData,
								rowIndex) {
							if ("Running" == rowData.stateString) {
								return "<label style='color:green'>"+ rowData.stateString+ "</label>";
							} else {
								return "<label style='color:red'>"+ rowData.stateString+ "</label>";
							}
						}
					},
					{
						header : '缓存数',
						name : 'cacheSize',
						width : 100,
						align : 'center',
						sort : 'clientSide'
					},
					{
						header : '过期检查间隔(秒)',
						name : 'expiryCheckInterval',
						width : 100,
						align : 'center',
						sort : 'clientSide'
					},
					{
						header : '描述',
						name : 'description',
						width : 'autoExpand',
						align : 'center'
					},
					{
						header : '编辑',
						name : 'kkkkkkk',
						width : 120,
						align : 'center',
						renderer : function(colValue, rowData,rowIndex) {
							var result = "<a href='#' onclick=\"toModifyRow('" + rowData.name + "')\" title='设置属性'><img style='border:0'  src='${resBase}/images/setting.png'></a>";
							result = result +"&nbsp;&nbsp;<a href='#' onclick=\"deleteClick('" + rowData.name + "')\" title='删除'><img style='border:0'  src='${resBase}/images/delete.png'></a>";  
							return result;
							
							
						}
					},
					{
						header : '操作',
						name : 'tttttttt',
						width : 80,
						align : 'center',
						renderer : function(colValue, rowData,rowIndex) {
							var result = "";
							if ("Running" == rowData.stateString) {
								result = "<a href='#' onclick=\"stopRow('" + rowData.name + "')\" title='停止'><img style='border:0'  src='${resBase}/images/stop.png'></a>";
							} else {
								result = "<a href='#' onclick=\"startRow('" + rowData.name + "')\" title='启动'><img style='border:0'  src='${resBase}/images/start.png'></a>";
							}
							result =  result+ "&nbsp;&nbsp;<a href='#' onclick=\"restartRow('" + rowData.name + "')\" title='重启'><img style='border:0'  src='${resBase}/images/restart.png'></a>";
							return result;
						}
					} ],
			dataSource : jmsQueueBaseUrl+'/list'
		});
		$('#queueGrid').omGrid({width : '100%'});
	});

	function query() {
		var queryName = $("#queryName").val();
		var state = $("#queryState").val();
		var url = jmsQueueBaseUrl+'/list?name='+ queryName + "&state=" + state;
		$('#queueGrid').omGrid('setData', url);
	}

	function toModifyRow(value) {
		var url = jmsQueueBaseUrl+"/getModel";
		$.ajax({
			url : url,
			data : {
				name : value
			},
			success : function(data) {
				var d = $('<div />').appendTo($(document.body));
				d.html(data).omDialog({
					autoOpen : true,
					closeOnEscape : false,
					height : 250,
					width : 365,
					modal : true,
					title : 'JMS队列设置',
					onOpen:function(){
                        defaultHandler_Init();
                    },
					onClose : function() {
						d.omDialog('destroy');
						d.remove();
					},
					buttons : [ {
						text : "保存",
						click : function() {
							save(d);
						}
					}, {
						text : "取消",
						click : function() {
							d.omDialog('destroy');
							d.remove();
						}
					} ]

				});
			}
		});
	}
	
	function defaultHandler_Init(){
		$("#name").change(function(){
			if(this.value!=''){
				$("#jndiName").val("jms/"+this.value);
			}else{
				$("#jndiName").val("jms/");
			}
		});
		
		$('#Jms_queue_param_form').validate({
		    validateOnEmpty : true,
		    rules : {
		    	name : {
		            required : true
		        },
		        jndiName : {
		        	required : true
		        },
		        cacheSize : {
		        	required : true,
		        	isInteger : true
		        },
		        expiryCheckInterval : {
		        	required : true,
		        	isInteger : true
		        }
		        
		    },
		    messages : {
		    	name : {
		            required : '值不能为空!'
		        },
		        jndiName : {
		        	 required : '值不能为空!'
		        },
		        cacheSize : {
		         	required : "值不能为空!",
		         	isInteger : '请输入整数!'
		         },
		        expiryCheckInterval : {
		         	required : "值不能为空!",
		         	isInteger : '请输入整数!'
		         }
		    },
		    showErrors: function(errorMap, errorList) {
		        var next = $(this.currentElements).next();
		        while(next.hasClass('errorMsg')) {
		            next.remove();
		            next = $(this.currentElements).next();
		        }
		        $(this.currentElements).removeClass('error');
		        $(this.currentElements).unbind('mouseover').unbind('mouseout');
		        if(errorList && errorList.length > 0){
		            $.each(errorList, function(index, obj){
		                $(obj.element).addClass('error');
		                var msg = this.message;
		                var em = $('<span class="errorMsg">{0}</span>'.format(msg));
		                $(obj.element).after(em);
		                $(obj.element).mouseover(function() {
		                    em.show();
		                }).mouseout(function() {
		                    em.hide();
		                });
		            });
		        }
		    }
		});
	}
	
	function save(d) {
		var  validataRes = $("#Jms_queue_param_form").validate().form();
		if (!validataRes) {
			return false;
		} else {
			$.ajax({
				type : "post",
				async:false,
				dataType : "json",
				url : jmsQueueBaseUrl+"/save",
				data :AASMonitor.FormToJSON.formToJSON($('#Jms_queue_param_form')),
				complete : function() {
				},
				error: function(){
					showErrorTip("更新失败！");
				},
				success : function(data) {
					if(data.state=="success"){
						$('#queueGrid').omGrid("reload");
					}
					showMsgTip(data.desc,data.state);
					d.omDialog('destroy');
					d.remove();
				}
			});
		}
	}

	function stop() {
		var selecteds = $('#queueGrid').omGrid("getSelections", true);
		if (selecteds.length <= 0) {
			showSelectAlert();
			return;
		}
		var names = "";
		$(selecteds).each(function(index, item) {
			names += item.name + ",";
		});
		if (names.length > 0) {
			names = names.substring(0, names.length - 1);
		}
		stopRow(names);
	}

	function restart() {
		var selecteds = $('#queueGrid').omGrid("getSelections", true);
		if (selecteds.length <= 0) {
			showSelectAlert();
			return;
		}
		var names = "";
		$(selecteds).each(function(index, item) {
			names += item.name + ",";
		});
		if (names.length > 0) {
			names = names.substring(0, names.length - 1);
		}
		restartRow(names);
	}
	
	function start() {
		var selecteds = $('#queueGrid').omGrid("getSelections", true);
		if (selecteds.length <= 0) {
			showSelectAlert();
			return;
		}
		var names = "";
		$(selecteds).each(function(index, item) {
			names += item.name + ",";
		});
		if (names.length > 0) {
			names = names.substring(0, names.length - 1);
		}
		startRow(names);
	}
	
	function del() {
		var selecteds = $('#queueGrid').omGrid("getSelections", true);
		if (selecteds.length <= 0) {
			showSelectAlert();
			return;
		}
		var names = "";
		$(selecteds).each(function(index, item) {
			names += item.name + ",";
		});
		if (names.length > 0) {
			names = names.substring(0, names.length - 1);
		}
		deleteClick(names);
	}

	function delRow(value) {
		handleRows(jmsQueueBaseUrl+"/del",value);
	}

	function startRow(value) {
		handleRows(jmsQueueBaseUrl+"/start",value);
	}

	function stopRow(value) {
		handleRows(jmsQueueBaseUrl+"/stop",value);
	}

	function restartRow(value) {
		handleRows(jmsQueueBaseUrl+"/restart",value);
	}

	function handleRows(url,value){
		$.ajax({
			type : "post",
			async:false,
			dataType : "json",
			url : url,
			data : {
				names : value
			},
			error: function(){
				showErrorTip("更新失败！");
			},
			success : function(data) {
				if(data.state=="success"){
					$('#queueGrid').omGrid("reload");
				}
				showMsgTip(data.desc,data.state);
			}
		});
	}

	function deleteClick(name) {
		$("#dialog-confirm").text("确认要删除："+name+" ？");
	    $( "#dialog-confirm" ).omDialog({
	        autoOpen : false, 
	        resizable: false,
	        height:140,
	        modal: false,
	        buttons: [{
	            text : "确认", 
	            click : function () {
	                $("#dialog-confirm" ).omDialog("close");
	                delRow(name);
	            }
	        }, {
	            text : "取消", 
	            click : function () {
	                $("#dialog-confirm" ).omDialog("close");
	            }
	        }]
	    });
	
	    $( "#dialog-confirm" ).omDialog("open");
	}	
	
	function showMsgTip(msg,type) {     
	    $.omMessageTip.show({
	        type : type,
	        title : '提示信息',
	        content : msg,
	        timeout : 3000
	    });
	}

	function showErrorTip(msg) {
		$.omMessageTip.show({
			type : 'error',
			title : '失败',
			content : msg,
			timeout : 3000
		});
	}

	function showSelectAlert(){
		$.omMessageBox.alert({
			title : '提示',
			content : '请选择记录！'
		});
	}
</script>
</html>