<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>JNDI信息</title>
<c:set var="resBase" value="${pageContext.request.contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/navmenu.js"></script>

<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/om-ui/om-apusic.css" />
<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/common.css" />
<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/main.css" />
<style type="text/css">
.jndi-value {
	
}

.jndi-key {
	color: #8E8E8E;
}

.jndi-value td span {
	color: #4A4AFF;
	display: inline-block;
	margin-left: 10px;
}

.jndi-key td label {
	margin-left: 20px;
}

.om-panel-header {
	margin: 8px 0 -8px 8px;
}

.om-borderlayout .om-borderlayout-region-body {
	margin: 8px 0 8px 8px;
}
</style>
</head>

<body>
	<div id="west-panel">
		<ul id="mytree"></ul>
	</div>
	<div id="center-panel">
		<div>
			<fieldset>
				<legend>详细信息</legend>

				<table id="j_id6" style="table-layout: fixed">
					<tbody>
						<tr class="jndi-key">
							<td colspan="1" rowspan="1"><label id="j_id8">JNDI
									Name:</label></td>
						</tr>
						<tr class="jndi-value">
							<td colspan="1" rowspan="1"><span id="jndiName"
								style="margin-left: 60px; margin-bottom: 10px;"></span></td>
						</tr>
						<tr class="jndi-key">
							<td colspan="1" rowspan="1"><label id="j_id11">Bind
									Object Class:</label></td>
						</tr>
						<tr class="jndi-value">
							<td colspan="1" rowspan="1"><span id="bindObjectClass"
								style="margin-left: 60px; margin-bottom: 10px;"></span></td>
						</tr>
						<tr class="jndi-key">
							<td colspan="1" rowspan="1"><label id="j_id14">Bind
									Object Hash Code:</label></td>
						</tr>
						<tr class="jndi-value">
							<td colspan="1" rowspan="1"><span id="bindObjectHashCode"
								style="margin-left: 60px; margin-bottom: 10px;"></span></td>
						</tr>
						<tr class="jndi-key">
							<td colspan="1" style="" rowspan="1"><label id="j_id17">Bind
									Object To String:</label></td>
						</tr>
						<tr class="jndi-value">
							<td colspan="1" rowspan="1"><span id="bindObjectToString"
								style="margin-left: 60px; margin-right: 20px; margin-bottom: 10px; word-break: break-all;"></span></td>
						</tr>
					</tbody>
				</table>
			</fieldset>
		</div>
	</div>
</body>
<script type="text/javascript">
	$(document).ready(function() {
		var element = $('body').omBorderLayout({
			panels : [ {
				id : "center-panel",
				header : false,
				region : "center"
			}, {
				id : "west-panel",
				resizable : false,
				collapsible : true,
				title : "J2EE-Tree",
				region : "west",
				width : 300
			} ]

		});
		loadTree();
	});

	function loadTree() {
		var name = "";
		$.ajax({
			type : "post",
			dataType : "json",
			url : "${pageContext.request.contextPath}/protect/jndi/loadTree",
			data : {
				jndiName : name
			},
			complete : function() {
				//alert("complete");
			},
			success : function(data) {
				$("#mytree").omTree({
					dataSource : data,
					onClick : function(node, event) {
						$("#jndiName").html(node.jndiName);
						$("#bindObjectClass").html(node.objectClassName);
						$("#bindObjectHashCode").html(node.hashCode);
						$("#bindObjectToString").html(node.objectString);
					}
				});
			}
		});
	}
</script>
</html>

