<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>JVM快照</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/monitor/index-panel.js"></script>
<link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/main.css" />
<script>
$(function() {
    var baseUrl = "${pageContext.request.contextPath}/protect/jvm-snap";
    $('#toolbar').omButtonbar({
        width : '100%',
        btns : [{
            label:"线程快照",
            id:"thread-snap" ,
            icons : {
                left : '${resBase}/images/add.png'
            },
            onClick:function(){
                createSnap(1);
            }
        }, {
            separtor : true
        }, {
            label:"堆快照",
            id:"heap-snap",
            icons : {
                left : '${resBase}/images/setting.png'
            },
            onClick:function() {
                createSnap(2);
            }
        }, {
            separtor : true
        }, {
            label:"进程快照",
            id:"process-snap",
            icons : {
                left : '${resBase}/images/setting2.png'
            },
            onClick:function(){
                createSnap(0);
            }
        }, {
            separtor : true
        }, {
            label:"日志快照",
            id:"log-snap",
            icons : {
                left : '${resBase}/images/nav/log-config.png'
            },
            onClick:function(){
                createSnap(4);
            }
        }, {
            separtor : true
        }, {
            label:"配置快照",
            id:"config-snap",
            icons : {
                left : '${resBase}/images/nav/jta.gif'
            },
            onClick:function(){
                createSnap(3);
            }
        }, {
            separtor : true
        }, {
            label:"监控快照",
            id:"monitor-snap",
            icons : {
                left : '${resBase}/images/nav/monitorPreview.png'
            },
            onClick:function(){
                createSnap(5);
            }
        }, {
            separtor : true
        }, {
            label:"删除",
            id:"del",
            icons : {
                left : '${resBase}/images/delete.png'
            },
            onClick:function(){
                deleteSnap();
            }
        }]
    });

    function createSnap(type) {
        $.ajax({
            type : "post",
            async:false,
            dataType : "json",
            url : baseUrl+"/create",
            data : {type : type},
            complete : function() {
            },
            error: function(){
                showErrorTip("生成失败！");
            },
            success : function(data) {
                if(data.status == "200") {
                    showMsgTip("成功生成快照！", "success");
                    $('#jvm-snap-grid').omGrid("reload");
                } else {
                    showErrorTip("生成失败！");
                }
            }
        });
    }

    function deleteSnap() {
        var selecteds = $('#jvm-snap-grid').omGrid("getSelections", true);
        if (selecteds.length <= 0) {
            showSelectAlert();
            return;
        }
        var ids = "";
        $(selecteds).each(function(index, item) {
            ids += item.id + ",";
        });
        if (ids.length > 0) {
            ids = ids.substring(0, ids.length - 1);
        }
        $("#dialog-confirm").text("确认要删除？");
        $( "#dialog-confirm" ).omDialog({
            autoOpen : false,
            resizable: false,
            height:140,
            modal: false,
            buttons: [{
                text : "确认",
                click : function () {
                    $("#dialog-confirm" ).omDialog("close");
                    $.ajax({
                        type : "post",
                        async:false,
                        dataType : "json",
                        url : baseUrl+"/delete",
                        data : {id : ids},
                        complete : function() {
                        },
                        error: function(){
                            showErrorTip("删除失败！");
                        },
                        success : function(data) {
                            if(data.status == "200") {
                                showMsgTip("成功删除快照！", "success");
                                $('#jvm-snap-grid').omGrid("reload");
                            } else {
                                showErrorTip("删除失败！");
                            }
                        }
                    });
                }
            }, {
                text : "取消",
                click : function () {
                    $("#dialog-confirm" ).omDialog("close");
                }
            }]
        });

        $( "#dialog-confirm" ).omDialog("open");
    }

    function showMsgTip(msg,type) {
        var tip = $("<div/>").text(msg).html();
        $.omMessageTip.show({
            type : type,
            title : '提示信息',
            content : tip,
            timeout : 3000
        });
    }

    function showErrorTip(msg) {
        var tip = $("<div/>").text(msg).html();
        $.omMessageTip.show({
            type : 'error',
            title : '失败',
            content : tip,
            timeout : 3000
        });
    }

    function showSelectAlert() {
        $.omMessageBox.alert({
            title : '提示',
            content : '请选择记录！'
        });
    }

    $('#jvm-snap-grid').omGrid({
        limit : 20,
        width : '100%',
        height : 500,
        autoFit : true,
        showIndex : false,
        singleSelect : false,
        colModel : [
            {
                header : '快照名称',
                name : 'name',
                width : 'autoExpand',
                align : 'left'
            },
            {
                header : '快照类型',
                name : 'type',
                width : 150,
                align : 'center',
                renderer : function(colValue, rowData, rowIndex) {
                    var result = "";
                    if ("0" == rowData.type) {
                        result = "进程快照";
                    } else if("1" == rowData.type) {
                        result = "线程快照";
                    } else if("2" == rowData.type) {
                        result = "堆快照";
                    } else if("3" == rowData.type) {
                        result = "配置快照";
                    } else if("4" == rowData.type) {
                        result = "日志快照";
                    } else {
                        result = "监控快照";
                    }
                    return result;
                }
            },
            {
                header : '保存路径',
                name : 'path',
                width : 400,
                align : 'left'
            },
            {
                header : '创建时间',
                name : 'lastModify',
                width : 200,
                align : 'center'
            },
            {
                header : '操作',
                name : '',
                width : 120,
                align : 'center',
                renderer : function(colValue, rowData, rowIndex) {
                    return "<a href='#' onclick=\"snapDownload('" + rowData.id + "', '"+ rowData.type +"')\" title='下载'>下载</a>";
                }
            }
        ],
        dataSource : baseUrl+'/list'
    });
});

function snapDownload(id, type) {
    var baseUrl = "${pageContext.request.contextPath}/protect/jvm-snap";
    $("form[name='download-file']").remove();
    var formHtml = $('<form name="download-file" target="parent._self" rel="noopener noreferrer" action="'+baseUrl+'/download.do" method="POST"><input name="id" value="'+id+'"/></form>');
    formHtml.appendTo("body").submit().remove();
}
</script>
</head>
<body style="width: 100%;">
<div id="toolbar" style="margin-top: 5px;"></div>
<table id="jvm-snap-grid"></table>
<div id="dialog-confirm" title="确认" style="display: none;">
    确认要删除？
</div>
</body>
</html>
