<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>Apusic应用服务器生命周期监听器管理</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="baseUrl" value="${contextPath}/protect/serverLifecycleListener" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/form.js"></script>

<link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/listener.css" />

<script>

    var cIndex = 0;
    var mIndex = 0;
    function createListener() {
        $.ajax({
            url : '${baseUrl}/create',
            success : function(data) {
                var d = $('<div />').appendTo($(document.body));
                d.html(data).omDialog({
                    autoOpen : true,
                    height : 400,
                    width : 500,
                    modal : true,
                    title : '创建监听器',
                    buttons : [ {
                        text : '创建',
                        click : function() {
                            var success = true;
                            $('#listener_form input').each(function() {
                                if ($(this).val() == undefined || $(this).val().trim().length == 0) {
                                    success = false;
                                    AASMonitor.markFldError($(this), '输入项不允许为空！');
                                } else {
                                    AASMonitor.clearFldError($(this));
                                }
                            });
                            if (success) {
                                $('#listener_form').submit();
                            }
                        }
                    }, {
                        text : '取消',
                        click : function() {
                            d.omDialog('close');
                        }
                    } ],
                    onClose : function() {
                        d.omDialog('destroy');
                        d.remove();
                    }
                });
                $('#listener_form input').each(function() {
                    var _el = $(this);
                    _el.keyup(function() {
                        validateNotEmpty(_el);
                    }).blur(function() {
                        validateNotEmpty(_el);
                    });
                });
            }
        });
    }

    function modifyListener(name) {
        $.ajax({
            url : '${baseUrl}/modify',
            data : {
                name : name
            },
            success : function(data) {
                mIndex = -1;
                var d = $('<div />').appendTo($(document.body));
                d.html(data).omDialog({
                    autoOpen : true,
                    height : 400,
                    width : 500,
                    modal : true,
                    title : '修改监听器',
                    buttons : [ {
                        text : '修改',
                        click : function() {
                            var success = true;
                            $('#listener_m_form input').each(function() {
                                if ($(this).val() == undefined || $(this).val().trim().length == 0) {
                                    success = false;
                                    AASMonitor.markFldError($(this), '输入项不允许为空！');
                                } else {
                                    AASMonitor.clearFldError($(this));
                                }
                            });
                            if (success) {
                                $('#listener_m_form').submit();
                            }
                        }
                    }, {
                        text : '取消',
                        click : function() {
                            d.omDialog('close');
                        }
                    } ],
                    onClose : function() {
                        d.omDialog('destroy');
                        d.remove();
                    }
                });
                $('#listener_m_form input').each(function() {
                    var _el = $(this);
                    _el.keyup(function() {
                        validateNotEmpty(_el);
                    }).blur(function() {
                        validateNotEmpty(_el);
                    });
                });
            }
        });
    }

    var tpl = '<tr>' + 
                  '<td><input name="pName{0}" type="text" /></td>' + 
                  '<td><input name="pValue{0}" type="text" /></td>' + 
                  '<td><a onclick="removeAttr(this);">删除</a></td>' + 
              '</tr>';

    function addCAttr() {
        cIndex++;
        var r = $(tpl.format(cIndex));
        r.find('input').each(function() {
            var _el = $(this);
            _el.keyup(function() {
                validateNotEmpty(_el);
            }).blur(function() {
                validateNotEmpty(_el);
            });
        });
        $('#attrTbl tbody').append(r);
    }
    
    function validateNotEmpty(el) {
        if (el.val() == undefined || el.val().trim().length == 0) {
            AASMonitor.markFldError(el, '输入项不能为空！');
        } else {
            AASMonitor.clearFldError(el);
        }
    }

    function addMAttr(initIndex) {
        if (mIndex < 0) {
            mIndex = initIndex;
        }
        mIndex++;
        var r = $(tpl.format(mIndex));
        r.find('input').each(function() {
            var _el = $(this);
            _el.keyup(function() {
                validateNotEmpty(_el);
            }).blur(function() {
                validateNotEmpty(_el);
            });
        });
        $('#attrTbl tbody').append(r);
    }

    function removeAttr(n) {
        $(n).parents('tr').remove();
    }
    
    
    $(function() {
		$('#lifecycleButtonbar').omButtonbar({
			btns : [{
						label : "新增监听器",
						id : "button1",
						icons : {
							left : '${resBase}/images/add.png'
						},
						onClick : function() {
							createListener();
						}
					}]
		});
		
    	var msg = '${optResultMsg}';
    	if(msg != null && msg != ''){
    		if(msg == 'createSuccess'){
    			showErrorTip('新建监听器成功', 'success');
    		}else if(msg == 'createFailed'){
    			showErrorTip('新建监听器失败', 'error');
    		}else if(msg == 'updateSuccess'){
    			showErrorTip('修改监听器成功', 'success');
    		}else if(msg == 'updateFailed'){
    			showErrorTip('修改监听器失败', 'error');
    		}else if(msg == 'removeSuccess'){
    			showErrorTip('删除监听器成功', 'success');
    		}else if(msg == 'removeFailed'){
    			showErrorTip('删除监听器失败', 'error');
    		}
    	}
    });
    
	function showErrorTip(msg,type) {	
		$.omMessageTip.show({
			type : type,
			title : '提示信息',
			content : msg,
			timeout : 4000
		});
	}

	
</script>

</head>
<body>
    
    <div style="padding: 8px; height: 85%;">
    	<div id="lifecycleButtonbar"></div>
        <c:choose>
            <c:when test="${listeners.isEmpty()}">
            	<div style="border: 1px solid #BCC5D2; border-top: 0; padding: 15px; color: #1C1C1C;">
              		<span>尚未配置生命周期监听器</span>
              	</div>
            </c:when>
            <c:otherwise>
                <table class="listener_tbl" cellpadding="0" cellspacing="0">
                    <thead>
                        <tr>
                            <th width="50%">监听器类名</th>
                            <th>监听器属性</th>
                            <th width="100">操作</th>
                        </tr>
                    </thead>
                    <tbody>
                        <c:forEach items="${listeners}" var="lsn" varStatus="vs">
                            <tr class="${vs.index % 2 == 0 ? 'even' : 'odd'}">
                                <td>${lsn.key}</td>
                                <td>
                                    <c:forEach items="${lsn.value}" var="p">
                                        <div>${p.key} = ${p.value}</div>
                                    </c:forEach>
                                </td>
                                <td align="center">
                                    <a class="inline_btn modify" href="#" onclick="modifyListener('${lsn.key}');"><span>修改</span></a>
                                    <a class="inline_btn remove" href="${baseUrl}/removeListener?name=${lsn.key}" onclick="return confirm('确定要删除吗？删除后不可恢复！');"><span>删除</span></a>
                                </td>
                            </tr>
                        </c:forEach>
                    </tbody>
                </table>
            </c:otherwise>
        </c:choose>
    </div>
</body>
</html>
