<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>日志监控</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/lib/underscore.js"></script>
<script type="text/javascript" src="${resBase}/scripts/aas-core.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/log.js"></script>

<link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/log.css" />

<script>
var realtimeLog = null;
var queryedLog = null;
var isRealTime = true;

$(function() {
    $('body').omBorderLayout({
        panels : [ {
            id : "log_header",
            region : "north",
            header : false,
            resizable : false,
            collapsible : false
        }, {
            id : "log_container",
            region : "center",
            header : false
        }, {
            id : "log_footer",
            region : "south",
            header : false,
            resizable : false,
            collapsible : false
        } ],
        spacing : 0,
        fit : true
    });
    
    $('#startTimeFld').omCalendar({
        showTime : true,
        disabled : ${webConsoleLogEnabled},
        dateFormat : 'yy-mm-dd H:i'
    });
    $('#endTimeFld').omCalendar({
        showTime : true,
        disabled : ${webConsoleLogEnabled},
        dateFormat : 'yy-mm-dd H:i'
    });
    
    if(${webConsoleLogEnabled}) {
        realtimeLog = new aas.RealTimeLogViewer({
            container : '#log_container',
            counterContainer : '.log_category',
            timmerContainer : '#time_tip',
            maxCount : 100,
            dataURL : '${contextPath}/protect/logmonitor/getRealTimeLog'
        });
        
        realtimeLog.startMonitor(true);
    } else {
        $('#startTimeFld').omCalendar('enable');
        $('#endTimeFld').omCalendar('enable');
    }
    
    $('#realTimeFld').change(function(e) {
        if(this.checked == true) {
            isRealTime = true;
            realtimeLog.startMonitor(!isRealTime);
            $('#startTimeFld').omCalendar('disable');
            $('#endTimeFld').omCalendar('disable');
            $('#queryLogBtn').omButton('disable');
            $("#queryWordFld").attr("disabled","disabled");
        } else {
            realtimeLog.stopMonitor();
            $('#startTimeFld').omCalendar('enable');
            $('#endTimeFld').omCalendar('enable');
            $('#queryLogBtn').omButton('enable');
            $("#queryWordFld").removeAttr("disabled");
        }
    });
    
    $('#scrollFld').change(function(e) {
        realtimeLog.setAutoScroll(!this.checked);
    });
    
    $('#clearBtn').omButton({
        onClick : function(e) {
            realtimeLog.clearLog();
        }
    });
    
    $('#queryLogBtn').omButton({
        disabled : ${webConsoleLogEnabled},
        onClick : function(e) {
            isRealTime = false;
            $('#time_tip').text('');
            if(queryedLog == null) {
                queryedLog = new aas.QueriedLogViewer({
                    container : '#log_container',
                    counterContainer : '.log_category',
                    maxCount : 100,
                    dataURL : '${contextPath}/protect/logmonitor/viewLogByTime',
                });
            }

            var validateNotEmpty = function (el) {
                if (el.val() == undefined || el.val().trim().length == 0) {
                    AASMonitor.markFldError(el, '输入项不能为空！');
                    return false;
                } else {
                    AASMonitor.clearFldError(el);
                    return true;
                }
            };
            
            if(validateNotEmpty($('#startTimeFld')) && validateNotEmpty($('#endTimeFld'))) {
                queryedLog.queryLog($('#startTimeFld').val(), $('#endTimeFld').val(),$('#queryWordFld').val());
            }
        }
    });
    
    $('#downloadLogBtn').omButton({
    });
    
    // 窗口切换时停止当前用户实时日志监控
    $(window).unload(function() {
        $.ajax({
            url : '${contextPath}/protect/logmonitor/stopMonitor',
            dataType : 'json',
            success : function(data) {}
        });
    });
});

function showLevel(target, level) {
    $('.category_btn').removeClass('category_btn_selected');
    $(target).addClass('category_btn_selected');
    if(isRealTime) {
        realtimeLog.showLog(level);
    } else {
        queryedLog.showLog(level);
    }
}
</script>

</head>
<body>
<div id="log_header" class="log_header">
    <table class="log_menu">
        <tr>
            <td class="left_cell">
                <input id="realTimeFld" name="realtime" type="checkbox" ${webConsoleLogEnabled ? 'checked="checked"' : ''} />
                <label>实时监控</label>
                <label> | </label>
                <label>起始时间：</label><input id="startTimeFld" type="text" name="startTime" />
                <label>结束时间：</label><input id="endTimeFld" type="text" name="endTime" />
                <label>关键字：</label><input id="queryWordFld" type="text" name="queryWord" disabled="disabled"/>
                <input id="queryLogBtn" type="button" value="查询" />
                <input id="clearBtn" type="button" value="清空" />
                <form action="${contextPath}/protect/logmonitor/downloadLog" style="display: inline;">
                    <input id="downloadLogBtn" type="submit" value="下载所有日志" />
                </form>
            </td>
            <td class="right_cell"><input id="scrollFld" type="checkbox" /><label>滚动锁定</label></td>
        </tr>
    </table>
</div>

<div id="log_container">
    <c:if test="${!webConsoleLogEnabled}">
        <span>WEB控制台已关闭，如需实时监控，请进入系统配置菜单重新开启！</span>
    </c:if>
</div>
<div id="log_footer" class="log_footer">
    <div class="log_category">
        <span class="mr_10">日志级别：</span>
        <a id="all_count" class="all category_btn category_btn_selected" onclick="showLevel(this, undefined);">全部（<span class="count">0</span>）</a>
        <a id="info_count" class="info category_btn" onclick="showLevel(this, aas.LogViewer.LogLevel.info);">信息（<span class="count">0</span>）</a>
        <a id="warn_count" class="warn category_btn" onclick="showLevel(this, aas.LogViewer.LogLevel.warn);">警告（<span class="count">0</span>）</a>
        <a id="error_count" class="error category_btn" onclick="showLevel(this, aas.LogViewer.LogLevel.error);">错误（<span class="count">0</span>）</a>
    </div>
    <div class="log_time">
        <span id="time_tip">监控时长：--小时--分--秒</span>
    </div>
</div>

</body>
</html>