<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>Apusic应用服务器监控管理平台</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/navmenu.js"></script>

<link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/main.css" />
<script>
    $(document).ready(function() {
        $('body').omBorderLayout({
            panels : [ {
                id : "north-panel",
                region : "north",
                header : false,
                resizable : false,
                collapsible : false
            }, {
                id : "center-panel",
                region : "center",
                header : false
            }, {
                id : "west-panel",
                header : false,
                region : "west",
                resizable : false,
                collapsible : false,
                width : 200
            }, {
                id : "south-panel",
                region : "south",
                header : false,
                resizable : false,
                collapsible : false
            } ],
            spacing : 0,
            fit : true
        });
        
        navLink('/protect/preview','preview');
        
        setYear();
    });
    
    function setYear() {
        var date = new Date();
        var txt = date.getFullYear();
        document.getElementById("year").innerHTML = txt;
    }
    
    function navLink(url,menuClass){
    	$('.west-panel-menu').find("div").removeClass("menu-left-img").removeClass("menu-middle-img").removeClass("menu-right-img");
    	$('.west-panel-menu').find("a").css("color","#000"); 	
    	$('.menu-middle .'+menuClass).parent().prev().addClass("menu-left-img");
    	$('.menu-middle .'+menuClass).parent().addClass("menu-middle-img");
    	$('.menu-middle .'+menuClass).parent().next().addClass("menu-right-img");   	
    	$('.menu-middle .'+menuClass).css("color","#FFF");
    	$('#centerFrame').attr('src', '${contextPath}' + url);
    }
    
</script>
<script type="text/javascript">
//处理键盘事件 禁止后退键（Backspace）密码或单行、多行文本框除外
function banBackSpace(e) {
	var ev = e || window.event;//获取event对象   
	var obj = ev.target || ev.srcElement;//获取事件源   

	var t = obj.type || obj.getAttribute('type');//获取事件源类型  

	//获取作为判断条件的事件类型
	var vReadOnly = obj.getAttribute('readonly');
	var vEnabled = obj.getAttribute('enabled');
	//处理null值情况
	vReadOnly = (vReadOnly == null) ? false : vReadOnly;
	vEnabled = (vEnabled == null) ? true : vEnabled;

	//当敲Backspace键时，事件源类型为密码或单行、多行文本的，
	//并且readonly属性为true或enabled属性为false的，则退格键失效
	var flag1 = (ev.keyCode == 8
			&& (t == "password" || t == "text" || t == "textarea") && (vReadOnly == true || vEnabled != true)) ? true
			: false;

	//当敲Backspace键时，事件源类型非密码或单行、多行文本的，则退格键失效
	var flag2 = (ev.keyCode == 8 && t != "password" && t != "text" && t != "textarea") ? true
			: false;

	//判断
	if (flag2) {
		return false;
	}
	if (flag1) {
		return false;
	}
}

//禁止后退键 作用于Firefox、Opera
document.onkeypress = banBackSpace;
//禁止后退键  作用于IE、Chrome
document.onkeydown = banBackSpace;
</script>
</head>
<body>
    <div id="north-panel">
        <div class="header">
            <div class="title">Apusic 应用服务器监控管理平台</div>
            <div class="toolbar">
                <span class="user">授权:${clientname} | </span>
                <span class="user">${username}，欢迎登录 | </span> <a
                    href="${contextPath}/logout" class="logout">注销</a>
            </div>
        </div>
    </div>
    <div id="west-panel" style="background-color: #DBE2EB; border: 1px solid #FFF; ">
    	<div class="west-panel-menu">
    		<div class="menu-top"><div class="menu-top-title" title="${domainInfo}">${domainInfo}</div></div>
    		<div class="menu-model">
	    		<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="preview" href="#" onclick="navLink('/protect/preview','preview');">服务器概览</a></div><div class="menu-right"></div></div>
	    		<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="env" href="#" onclick="navLink('/protect/condition','env');">环境概要</a></div><div class="menu-right"></div></div>
	    		<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="app" href="#" onclick="navLink('/protect/application','app');">应用管理</a></div><div class="menu-right"></div></div>
	    		<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="datasource" href="#" onclick="navLink('/protect/datasource','datasource');">数据源</a></div><div class="menu-right"></div></div>
	    		<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="jndi" href="#" onclick="navLink('/protect/jndi','jndi');">JNDI树</a></div><div class="menu-right"></div></div>
	    		<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="log" href="#" onclick="navLink('/protect/logmonitor','log');">日志监控</a></div><div class="menu-right"></div></div>
	    		<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="asconfig" href="#" onclick="navLink('/protect/aasconfig','asconfig');">服务面板</a></div><div class="menu-right"></div></div>
	    		<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="jms" href="#" onclick="navLink('/protect/jms/factory/main','jms');">JMS消息</a></div><div class="menu-right"></div></div>
    		</div>
    		<div class="menu-model">
    			<div class="menu-model-title"><div class="menu-model-title-content"><span class="sysconfig">系统配置</span></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="vmoption" href="#" onclick="navLink('/protect/sysconfig/sysparam','vmoption');">系统参数</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="logconf" href="#" onclick="navLink('/protect/logconfig','logconf');">日志配置</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="user" href="#" onclick="navLink('/protect/security/usergroup','user');">用户组</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="realm" href="#" onclick="navLink('/protect/sysconfig/realm','realm');">安全域</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="lclistener" href="#" onclick="navLink('/protect/serverLifecycleListener','lclistener');">生命周期监听</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="sysconfigbackup" href="#" onclick="navLink('/protect/sysconfig/sysconfigbackup','sysconfigbackup');">系统备份</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="jndiresource" href="#" onclick="navLink('/protect/jndi/resource','jndiresource');">JNDI资源</a></div><div class="menu-right"></div></div>
				<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="jvmsnap" href="#" onclick="navLink('/protect/jvm-snap/index','jvmsnap');">JVM快照</a></div><div class="menu-right"></div></div>
    		</div>
    		<div class="menu-model">
    			<div class="menu-model-title"><div class="menu-model-title-content"><span class="monitor">监控</span></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="monitorPreview" href="#" onclick="navLink('/protect/monitor','monitorPreview');">监控概览</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="javaee" href="#" onclick="navLink('/protect/monitor/j2ee','javaee');">JavaEE组件</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="datasourcem" href="#" onclick="navLink('/protect/monitor/datasource','datasourcem');">数据源</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="session" href="#" onclick="navLink('/protect/monitor/appsession','session');">应用会话</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="jta" href="#" onclick="navLink('/protect/monitor/jta','jta');">JTA事务</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="http" href="#" onclick="navLink('/protect/monitor/http','http');">HTTP连接</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="jvm" href="#" onclick="navLink('/protect/monitor/memory','jvm');">JVM内存</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="thread" href="#" onclick="navLink('/protect/monitor/thread','thread');">线程</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="classloader" href="#" onclick="navLink('/protect/monitor/classloader','classloader');">类加载</a></div><div class="menu-right"></div></div>
    			<div class="menu-title"><div class="menu-left"></div><div class="menu-middle"><a class="cpu" href="#" onclick="navLink('/protect/monitor/cpu/index','cpu');">CPU监控</a></div><div class="menu-right"></div></div>
    		</div>
    	</div>
    </div>
    <div id="center-panel" style="height: 100%; overflow: hidden;">
        <iframe id="centerFrame" name="centerFrame" frameborder="0"
            height="100%" width="100%" scrolling="auto" marginheight="0" marginwidth="0"></iframe>
    </div>
    <div id="south-panel">
        <div class="footer">
            <span>&copy; 2000-</span><span id="year">2016</span>深圳市金蝶天燕中间件股份有限公司<span>，保留所有权利</span>
           联系我们
        </div>
    </div>
</body>
</html>
