<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>类加载组件</title>
<c:set var="resBase" value="${pageContext.request.contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-rules.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/form.js"></script>
<script type="text/javascript" src="${resBase}/scripts/navmenu.js"></script>

<link class="x-skin" rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
<link class="x-skin" rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link class="x-skin" rel="stylesheet" type="text/css" href="${resBase}/css/main.css" />
	<style type="text/css">
		.jndi-value {

		}

		.classloader-key {
			color: #8E8E8E;
		}

		.classloader-value td span {
			color: #4A4AFF;
			display: inline-block;
			margin-left: 10px;
		}

		.classloader-key td label {
			margin-left: 20px;
		}

		.om-panel-header {
			margin: 8px 0 -8px 8px;
		}

		.om-borderlayout .om-borderlayout-region-body {
			margin: 8px 0 8px 8px;
		}

		.om-buttonbar {
			border-bottom: none;
		}
		#search-panel span.label{
			margin-left: 10px;
		}

		#search-panel .input-text {
			border: 1px solid #6D869E;
			height: 18px;
			vertical-align: middle;
			width: 137px;
		}
	</style>
</head>
<body>
	<div id="north-panel">
		<div id="classloaderButtonbar"></div>

		<div id="search-panel">
			<div style="width: 100%;text-align: center">
				<span class="label">类名称： </span>
				<input id="className" type="text" class="input-text" style="width: 400px;" />
				<span id="button-search">搜索</span>
				<span id="button-clear">清空</span>
			</div>
		</div>
	</div>
	<div id="center-panel">
		<div>
			<fieldset style="display: none" id="fieldset-classloader-search" >

			</fieldset>
			<fieldset>
				<legend>类加载器详细信息</legend>
				<table id="classloader-detail" style="table-layout: fixed">
					<tbody>
						<tr class="classloader-key">
							<td colspan="1" rowspan="1"><label id="key_app_name">所属应用:</label></td>
						</tr>
						<tr class="classloader-value">
							<td colspan="1" rowspan="1"><span id="value_app_name" style="margin-left: 60px; margin-bottom: 10px;"></span></td>
						</tr>
						<tr class="classloader-key">
							<td colspan="1" rowspan="1"><label id="key_class_name">类名:</label></td>
						</tr>
						<tr class="classloader-value">
							<td colspan="1" rowspan="1"><span id="value_class_name" style="margin-left: 60px; margin-bottom: 10px;"></span></td>
						</tr>
						<tr class="classloader-key">
							<td colspan="1" rowspan="1"><label id="key_instance_name">实例名称:</label></td>
						</tr>
						<tr class="classloader-value">
							<td colspan="1" rowspan="1"><span id="value_instance_name" style="margin-left: 60px; margin-bottom: 10px;"></span></td>
						</tr>
						<tr class="classloader-key">
							<td colspan="1" rowspan="1"><label id="key_identify_hash_code">HashCode标识:</label></td>
						</tr>
						<tr class="classloader-value">
							<td colspan="1" rowspan="1"><span id="value_identify_hash_code" style="margin-left: 60px; margin-bottom: 10px;"></span></td>
						</tr>
						<tr class="classloader-key">
							<td colspan="1" rowspan="1"><label id="key_prefer">类加载优先级:</label></td>
						</tr>
						<tr class="classloader-value">
							<td colspan="1" rowspan="1"><span id="value_prefer" style="margin-left: 60px; margin-bottom: 10px;"></span></td>
						</tr>
						<tr class="classloader-key">
							<td colspan="1" rowspan="1"><label id="key_classpath">类加载路径及顺序:</label></td>
						</tr>
						<tr class="classloader-value">
							<td colspan="1" rowspan="1"><span id="value_classpath" style="margin-left: 60px; margin-bottom: 10px;"></span></td>
						</tr>
					</tbody>
				</table>
			</fieldset>
		</div>
	</div>
	<div id="west-panel" >
		<ul id="classLoaderTree"></ul>
	</div>
</body>
<script type="text/javascript">
	var baseUrl = "${pageContext.request.contextPath}/protect/monitor/classloader";
    $(document).ready(function() {
        $('body').omBorderLayout({
            panels : [ {
                id : "center-panel",
                header : false,
                region : "center"
            }, {
                id : "west-panel",
                resizable : true,
                collapsible : false,
                region : "west",
                width : 350
            }, {
                id : "north-panel",
                header : false,
                region : "north",
				height: 80
            } ]

        });
        $('#classloaderButtonbar').omButtonbar({
            btns : [{
                		separtor : true
					}, {
						label : "返回类加载监控",
						id : "button1",
						icons : {
							left : '${resBase}'+'/images/setting.png'
						},
						onClick : function() {
							window.location.href=baseUrl;
						}
            		}, {
                    	separtor : true
                	}
            	]
        });
        loadTree();

        $("#search-panel").omPanel({
			header: false,
            collapsible:false
        });

        $('span#button-search').omButton({
            icons : {left : '${resBase}/images/check.png'},
            width : 70,
            onClick : function(event) {
                var className = $("#className").val();
				if(className == "") {
                    $.omMessageBox.alert({
                        title : '提示',
                        content : '请输入java类名称'
                    });
				    return;
                }
                $.ajax({
                    type : "post",
                    dataType : "json",
                    url : baseUrl+"/searchClassLoaderByClass",
					data : {className : className},
                    success : function(data) {
                        //右侧搜索结果展示
                        showSearchResult(data[0]);

                        // 左侧树形
                        showLeftTree(data[1]);

                        // 选择左侧树形
						showCheckLeftTree(data[0]);
                    }
                });
            }
        });

        $('span#button-clear').omButton({
            icons : {left : '${resBase}/images/delete.png'},
            width : 70,
            onClick : function(event) {
				$("#fieldset-classloader-search").hide();
                clearClassLoaderSearch();
            }
        });

        commonInputFilter("#className");

    });

    function commonInputFilter(selector){
        var regx=/[\'\"\:\;\<\>\,\?\/\`\~\!\#\%\^\&\*\|\\\+\-\=]+/g;
        $(selector).bind("keydown change blur", function(event) {
            var obj=$(this);
            setTimeout(function(){
                var v=obj.val();
                if(regx.test(v))
                    obj.val(v.replace(regx, ""));
            }, 0);
        });
    }

    function showLeftTree(data) {
        $("#classLoaderTree").omTree({
            dataSource : data,
            onClick : function(node, event) {
                showClassLoaderDetail(node);
            }
        });
        $("#classLoaderTree").omTree("expandAll");
        if($.isArray(data) && data.length > 0) {
            var target = $("#classLoaderTree").omTree("findNode", "text", data[0].instanceName);
            if(target) {
                $("#classLoaderTree").omTree('select',target);
                $("#" + target.nid).find("a").first().trigger("click");
            }
        } else {
            clearClassLoaderDetail();
        }
	}

    function showCheckLeftTree(data) {
        if(data.length <= 0) {
            return;
        }
        var target = $("#classLoaderTree").omTree("findNode", "text", data[0].classloaderInstanceName);
        if(target) {
            $("#classLoaderTree").omTree('select',target);
            $("#" + target.nid).find("a").first().trigger("click");
		}
    }

	function showSearchResult(data) {
        var html = '<legend>类加载搜索结果</legend>';
        if(data.length <= 0) {
            html += '<span style="color: #CC0000">找不到对应的类加载信息，可能由于该类未加载，或者该类由BootstrapClassLoader加载!</span>';
        } else {
            for (var i = 0; i < data.length; i++) {
                html += '<table style="table-layout: fixed">' +
                    		'<tbody>' +
								'<tr class="classloader-key">' +
									'<td colspan="1" rowspan="1"><label>类名称:</label></td>' +
								'</tr>' +
								'<tr class="classloader-value">' +
									'<td colspan="1" rowspan="1"><span style="margin-left: 60px; margin-bottom: 10px;">'+data[i].className+'</span></td>' +
								'</tr>' +
                    			'<tr class="classloader-key">' +
                    				'<td colspan="1" rowspan="1"><label>所属应用:</label></td>' +
                    			'</tr>' +
                    			'<tr class="classloader-value">' +
                    				'<td colspan="1" rowspan="1"><span style="margin-left: 60px; margin-bottom: 10px;">'+(data[i].appName ? data[i].appName : '无')+'</span></td>' +
                    			'</tr>' +
								'<tr class="classloader-key">' +
									'<td colspan="1" rowspan="1"><label>类加载器实例名称:</label></td>' +
								'</tr>' +
								'<tr class="classloader-value">' +
									'<td colspan="1" rowspan="1"><span style="margin-left: 60px; margin-bottom: 10px;">'+data[i].classloaderInstanceName+'</span></td>' +
								'</tr>' +
								'<tr class="classloader-key">' +
									'<td colspan="1" rowspan="1"><label>类加载器HashCode标识:</label></td>' +
								'</tr>' +
								'<tr class="classloader-value">' +
									'<td colspan="1" rowspan="1"><span style="margin-left: 60px; margin-bottom: 10px;">'+data[i].classloaderIdentifyHashCode+'</span></td>' +
								'</tr>' +
								'<tr class="classloader-key">' +
									'<td colspan="1" rowspan="1"><label>类加载位置:</label></td>' +
								'</tr>' +
								'<tr class="classloader-value">' +
									'<td colspan="1" rowspan="1"><span style="margin-left: 60px; margin-bottom: 10px;">'+data[i].path+'</span></td>' +
								'</tr>' +
                    		'</tbody>' +
                    	'</table>';
                if (i != data.length - 1) {
                    html += '<hr/>';
                }
            }
        }
        $("#fieldset-classloader-search").html(html);
        $("#fieldset-classloader-search").show();
	}

    function loadTree() {
        $.ajax({
            type : "post",
            dataType : "json",
            url : baseUrl+"/loadClassLoaderTree",
            success : function(data) {
                showLeftTree(data);
            }
        });
    }

   function showClassLoaderDetail(data) {
	   $("#value_app_name").text(data.appName ? data.appName : "无");
       $("#value_class_name").text(data.className);
       $("#value_instance_name").text(data.instanceName);
       $("#value_identify_hash_code").text(data.identifyHashCode);
       $("#value_prefer").text(data.prefer === "true" ? "父类加载器 < 当前类加载器" : "父加载器 > 当前类加载器");
       if($.isArray(data.classpathList) && data.classpathList.length > 0) {
           var classpathText = "";
           for(var i=0; i<data.classpathList.length; i++) {
               classpathText += data.classpathList[i]+"<br/>";
           }
           $("#value_classpath").html(classpathText);
       } else {
           $("#value_classpath").html("");
       }
   }

   function clearClassLoaderDetail() {
       $("#value_app_name").text("");
       $("#value_class_name").text("");
       $("#value_instance_name").text("");
       $("#value_identify_hash_code").text("");
       $("#value_classpath").html("");
       $("#value_prefer").html("");
   }

    function clearClassLoaderSearch() {
		$("#fieldset-classloader-search").html("");
        $("#className").val("");
    }
</script>
</html>

