<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>监控</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/monitor/index-config.js"></script>

<link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/main.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/monitor/monitor.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/app.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/monitor/config.css" />

<script>
	$(function() {
	    window.$m = AASMonitor.monitorConfig;
	    $m.baseUrl = '${contextPath}';
	
		$('#configButtonbar').omButtonbar({
			btns : [{
						label : "返回概要",
						id : "button1",
						icons : {
							left : '${resBase}'+'/images/service.png'
						},
						onClick : function() {
							$m.backIndex();
						}
					}, {
						separtor : true
					}, {
						label : "开启所有监控",
						id : "startAll",
						onClick : function() {
							$m.startAllMonitor(this);
						}
					}, {
						separtor : true
					}, {
						label : "关闭所有监控",
						id : "shutAll",
						onClick : function() {
							$m.shutdownAllMonitor(this);
						}
					}]
		});
	    
	});
</script>
</head>
<body>
<div style="height: 100%; margin: 0px; padding: 0px;">

	<div id="configButtonbar"></div>
    <div class="w-widget-default-font w-widget-pagetitle">
        &nbsp;&nbsp;共有挂件&nbsp;<font color="orange"><strong>${panels.size()}</strong></font>&nbsp;个
    </div>

    <div id="contentPanel" class="list">
        <ul>
            <c:forEach items="${panels}" var="panel">
                <li>
                    <div class="msgbox">
                        <div class="msgbox_img">
                            <p>
                                <img src="${resBase}/images/chart.gif">
                            </p>
                        </div>
                        <div class="msgbox_msg">
                            <p>
                                <span></span>
                            </p>
                            <p>
                                <span>描述：${panel.des}</span>
                            </p>
                            <p>
                                <c:choose>
                                    <c:when
                                        test="${panel.status.equals('started')}">
                                        <span>状态：<font
                                            class="config_color_green">启动</font></span>
                                    </c:when>
                                    <c:otherwise>
                                        <span>状态：<font
                                            class="config_color_red">停止</font></span>
                                    </c:otherwise>
                                </c:choose>
                            </p>
                        </div>
                        <div class="msgbox_operate">
                            <c:choose>
                                <c:when
                                    test="${panel.addToPanel.equals(true)}">
                                    <p>
                                        <input type="button"
                                            value="从概要移除"
                                            onclick="$m.removeFromPanel('${panel.serviceName}',this)"
                                            style="width: 100px;" />
                                    </p>
                                </c:when>
                                <c:otherwise>
                                    <p>
                                        <input type="button"
                                            value="添加至概要"
                                            onclick="$m.addToPanel('${panel.serviceName}',this)"
                                            style="width: 100px;" />
                                    </p>
                                </c:otherwise>
                            </c:choose>

                            <c:choose>
                                <c:when
                                    test="${panel.status.equals('started')}">
                                    <p>
                                        <input type="button"
                                            class="control" value="停止监控"
                                            ha="${panel.serviceName}"
                                            onclick="$m.shutDownMonitor('${panel.serviceName}',this)"
                                            style="width: 100px;" />
                                    </p>
                                </c:when>
                                <c:otherwise>
                                    <p>
                                        <input type="button"
                                            class="control" value="启动监控"
                                            ha="${panel.serviceName}"
                                            onclick="$m.startMonitor('${panel.serviceName}',this)"
                                            style="width: 100px;" />
                                    </p>
                                </c:otherwise>
                            </c:choose>

                        </div>
                    </div>
                </li>
            </c:forEach>
        </ul>
    </div>
</div>
</body>
</html>
