<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>JTA监控</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<%@ include file="/WEB-INF/common-monitor/jqplot-js.jsp"%>
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<%@ include file="/WEB-INF/common-monitor/jqplot-css.jsp"%>
<script>
	$(function() {
		init();
		showCpuChart();
		setInterval("showIntervalChart()", 3000);
	});
	
	function init() {
		isRunning = false;
	}
	
	function showIntervalChart() {
		if(!isRunning) {
			isRunning = true;
            showCpuChart();
			isRunning = false;
		}
	}
	
	function getCpuData(url, data) {
        var json = getAjaxJsonData(url, data);
        var ret = {};
        if(json && json != "" && json != "null") {
            ret.data = json;
        } else {
            ret.data = [];
        }
        return ret;
	}

	function showCpuChart() {
		var url = "${contextPath}/protect/monitor/cpu/cpuJsonData";
		var data = getCpuData(url, {});
		try {
			if(cpuChart) {
                cpuChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#line-inner", "CPU使用率，没有数据");
			return;
		} else {
			$("#line-inner").empty();
		}
		cpuChart = $.jqplot("cpu-chart-inner", data.data, $.extend(true, getDefaultOptions(), {
            title: "CPU监控",
            seriesDefaults: {
                renderer: $.jqplot.BarRenderer,
                rendererOptions: {
                    // 每个柱子都显示不同颜色
                    varyBarColor: true,
                    barWidth: 90,
                    highlightMouseDown: false
                },
                pointLabels: {
                    // 是否显示柱子上的数字
                    show: true
                },
                showLabel: true
            },
            axes: {
                yaxis : {
                    tickOptions: {
                        formatString: '%.2f',
                        formatter: function(format, val) {
                            if (!format) {
                                format = $.jqplot.config.defaultTickFormatString;
                            }
                            return $.jqplot.sprintf(format, val);
                        }
                    }
                }
            }
        }));
	}

</script>
</head>
<body>
	<div style="margin: 8px; width: 98%; height: 97%;">
		<div style="border:1px solid #9CCEFD;width: 100%; height: 65%;">
			<div id="cpu-chart-inner" style="height:98%;"></div>
		</div>
	</div>
</body>
</html>