<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>数据源监控</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<%@ include file="/WEB-INF/common-monitor/jqplot-js.jsp"%>
<link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<%@ include file="/WEB-INF/common-monitor/jqplot-css.jsp"%>
<style type="text/css">
/** 解决表格最后一列与边缘间隔太多 **/
.om-grid div.hDivBox {
	float: left;
	padding-right: 10px;
}
</style>
<script>
	$(function() {
		$('#grid-inner').omGrid({
	        title : '数据源已使用连接情况',
	        limit: 0,
	        height: 255,
	        showIndex : false,
	        singleSelect : true,
	        emptyMsg : 'No data!',
	        onRowClick : function(index,rowData,event){
	        	changeLineChart(rowData.dsName);
	        } ,
	        onSuccess:function(data,testStatus,XMLHttpRequest,event){
	        	if('success' == testStatus && undefined != data.rows[0]){
	        		changeLineChart(data.rows[0].dsName);
	        	}else{
	        		changeLineChart('');
	        	}
	        },
	        dataSource : '${contextPath}/protect/monitor/datasource/getDatasourceGird',
	        colModel : [ {header : '数据源名', name : 'dsName', width : 100, align : 'center'},
	                     {header : '当前连接', name : 'currentCount', width : 70, align : 'left'},
	                     {header : '已使用连接', name : 'useingConnectCount', width : 70, align : 'left'},
	                     {header : '已创建连接', name : 'createCount', width : 70, align : 'left'},
	                     {header : '已关闭连接', name : 'closeCount', width : 70, align : 'left'},
	                     {header : '描述', name : 'des', align : 'left', width : 'autoExpand'}]
	    });

        $('#datasourceButtonbar').omButtonbar({
            btns : [{
                separtor : true
            },{
                label : "SQL语句监控",
                id : "button1",
                icons : {
                    left : '${contextPath}/res/images/setting.png'
                },
                onClick : function() {
                    window.location.href="${contextPath}/protect/monitor/datasource/datasourceDetail";
                }
            }, {
                separtor : true
            }]
        });

		init();
		showCurrentChart();
		setInterval("showCurrentIntervalChart()", 4000);
	});
	
	function init() {
		isCurrentRunning = false;
		isDsRunning = false;
	}
	
	function showDsIntervalChart(dsName) {
		try {
			if(showChartIntervalId) {
				clearInterval(showChartIntervalId);
			}
		} catch(e) { }
		showChartIntervalId = setInterval("showDataSourceChart('"+dsName+"')", 4000);
		if(!isDsRunning) {
			isDsRunning = true;
			showDataSourceChart(dsName);
			isDsRunning = false;
		}
	}
	
	function showCurrentIntervalChart() {
		if(!isCurrentRunning) {
			isCurrentRunning = true;
			showCurrentChart();
			isCurrentRunning = false;
		}
	}


	function changeLineChart(dsName){
		showDsIntervalChart(dsName);
	}
	
	function getDataSourceData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			var legend = new Array();
			var xyData = new Array();
			$(json).each(function(i, v){
				legend.push(v.legend);
				xyData.push(v.data);
			});
			ret.legend = legend;
			ret.data = xyData;
		} else {
			ret.legend = [];
			ret.data = [];
		}
		return ret;
	}

	function showDataSourceChart(dsName) {
		var url = "${contextPath}/protect/monitor/datasource/statisticsJson";
		var data = getDataSourceData(url, {dsName:dsName});
		var count = 0;
		try {
			if(dataSourceChart) {
				dataSourceChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#line-inner", "数据源"+dsName+"连接统计，没有数据");
			return;
		} else {
			$("#line-inner").empty();
		}
		dataSourceChart = $.jqplot('line-inner', data.data, $.extend(true, getDefaultOptions(), {
	  		title: "数据源"+dsName+"连接统计",
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			count++;
	            			if((count)%2 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            }
	        },
	        legend: {
	            renderer: $.jqplot.EnhancedLegendRenderer, 
	            show: true,
	            location: 's',
	            placement: 'outsideGrid',
	            labels: data.legend,
	            shrinkGrid: true,
	            rendererOptions: {
	            	numberRows : 1
	            }
	        }
		}));
	}
	
	function getCurrentConnectData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			ret.data = json;
		} else {
			ret.data = [];
		}
		return ret;
	}

	function showCurrentChart() {
		var url = "${contextPath}/protect/monitor/datasource/currentConnJson";
		var data = getCurrentConnectData(url, {});
		try {
			if(currentConnectChart) {
				currentConnectChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#column-inner", "当前空闲连接监控，没有数据");
			return;
		} else {
			$("#column-inner").empty();
		}
		currentConnectChart = $.jqplot('column-inner', data.data, $.extend(true, getDefaultOptions(), {
			title: "当前空闲连接监控", 
			seriesDefaults: {
	             renderer: $.jqplot.BarRenderer,
	             rendererOptions: {
	   				varyBarColor: true,
	   				barWidth: 45,
	   				highlightMouseDown: false
	   			 },
	             pointLabels: {
	                 show: true
	             },
	             showLabel: true
	         }
		}));
	}
	
</script>
</head>
<body>
<div id="datasourceButtonbar"></div>
<div style="padding: 8px">
	<div style="border:1px solid #9CCEFD;">
		<div style="height:320px; background-color: #FCFCFC;">
			<div id="line-inner" style="height:98%;"></div>
		</div>
    </div>
    
    <div class="ht_15"></div>
	
    <table cellpadding="0" cellspacing="0" height="255" width="100%">
        <tr>
            <td width="48%" style="padding-right: 10px; ">
                <table id="grid-inner"></table>
            </td>
            <td style="border:1px solid #9CCEFD;">
                <div>
                    <div id="column-inner" style="height:98%;"></div>
                </div>
            </td>
        </tr>
    </table>
</div>
</body>
</html>