<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
    <title>数据源监控</title>
    <c:set var="resBase" value="${pageContext.request.contextPath}/res" />
    <script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
    <script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
    <script type="text/javascript" src="${resBase}/scripts/om-rules.js"></script>
    <script type="text/javascript" src="${resBase}/scripts/common.js"></script>
    <script type="text/javascript" src="${resBase}/scripts/form.js"></script>
    <script type="text/javascript" src="${resBase}/scripts/navmenu.js"></script>

    <link class="x-skin" rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
    <link class="x-skin" rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
    <link class="x-skin" rel="stylesheet" type="text/css" href="${resBase}/css/main.css" />
    <style type="text/css">
        .jndi-value {

        }

        .datasource-key {
            color: #8E8E8E;
        }

        .datasource-value td span {
            color: #4A4AFF;
            display: inline-block;
            margin-left: 10px;
        }

        .datasource-key td label {
            margin-left: 20px;
        }

        .om-panel-header {
            margin: 8px 0 -8px 8px;
        }

        .om-borderlayout .om-borderlayout-region-body {
            margin: 8px 0 8px 8px;
        }

        .om-buttonbar {
            border-bottom: none;
        }
        #search-panel span.label{
            margin-left: 10px;
        }

        #search-panel .input-text {
            border: 1px solid #6D869E;
            height: 18px;
            vertical-align: middle;
            width: 137px;
        }
    </style>
</head>
<body>
<div id="north-panel">
    <div></div>
    <div id="datasourceButtonbar"></div>
    <div id="search-panel">
        <div style="width: 100%;text-align: center">
            <span class="label">数据源名称： </span>
            <input id="dsName" type="text" class="input-text" style="width: 200px;" />
            <span class="label">事件类型： </span>
            <select id="eventType">
                <option value="">ALL</option>
                <option value="Statement.Execute">Statement.Execute</option>
                <option value="Statement.SlowExecute">Statement.SlowExecute</option>
                <option value="Connection.close">Connection.close</option>
                <option value="Connection.SetAutoCommit">Connection.SetAutoCommit</option>
                <option value="Connection.Commit">Connection.Commit</option>
                <option value="Connection.Abandoned">Connection.Abandoned</option>
                <option value="Transaction.Begin">Transaction.Begin</option>
                <option value="Transaction.Complete">Transaction.Complete</option>
                <option value="Transaction.Timeout">Transaction.Timeout</option>
            </select>
            <span id="button-search">搜索</span>
            <span id="button-clear">清空</span>
        </div>
    </div>
</div>
<div id="center-panel">
    <div id="grid-sql-inner" style="height:98%;">
    </div>
</div>
</body>
<script type="text/javascript">
    var baseUrl = "${pageContext.request.contextPath}/protect/monitor/datasource";
    $(document).ready(function() {

        $('body').omBorderLayout({
            panels : [ {
                id : "center-panel",
                header : false,
                region : "center"
            }, {
                id : "north-panel",
                header : false,
                region : "north",
                height: 80
            } ]

        });

        var traceAllow = "${traceAllow}";
        var stackTraceAllow = "${stackTraceAllow}";
        var labelTraceAllow, iconTraceAllow;
        var labelStackTraceAllow, iconStackTraceAllow;
        if(traceAllow == "true") {
            labelTraceAllow = "禁用SQL监控";
            iconTraceAllow = "${resBase}/images/stop.png";
        } else {
            labelTraceAllow = "启用SQL监控";
            iconTraceAllow= "${resBase}/images/start.png";
        }
        if(stackTraceAllow == "true") {
            labelStackTraceAllow = "禁用SQL堆栈监控";
            iconStackTraceAllow = "${resBase}/images/stop.png";
        } else {
            labelStackTraceAllow = "启用SQL堆栈监控";
            iconStackTraceAllow = "${resBase}/images/start.png";
        }

        $('#datasourceButtonbar').omButtonbar({
            width : '100%',
            btns : [{
                label : "返回数据源监控",
                id : "button1",
                icons : {
                    left : '${resBase}/images/service.png'
                },
                onClick : function() {
                    window.location.href=baseUrl;
                }
            }, {
                separtor : true
            },{
                label : "刷新",
                id : "button2",
                icons : {
                    left : '${resBase}/images/refresh.png'
                },
                onClick : function() {
                    var dsName = $("#dsName").val();
                    var eventType = $("#eventType").val();
                    showSQLStatTable(dsName, eventType);
                }
            }, {
                separtor : true
            }, {
                label : labelTraceAllow,
                id : "button3",
                icons : {
                    left : iconTraceAllow
                },
                onClick : function() {
                    if(traceAllow == "true") {
                        disable(0);
                    } else {
                        enable(0)
                    }
                }
            }, {
                separtor : true
            }, {
                label : labelStackTraceAllow,
                id : "button3",
                icons : {
                    left : iconStackTraceAllow
                },
                onClick : function() {
                    if(stackTraceAllow == "true") {
                        disable(1);
                    } else {
                        enable(1);
                    }
                }
            }]
        });

        $("#search-panel").omPanel({
            header: false,
            collapsible:false
        });

        $('span#button-search').omButton({
            icons : {left : '${resBase}/images/check.png'},
            width : 70,
            onClick : function(event) {
                var dsName = $("#dsName").val();
                var eventType = $("#eventType").val();
                showSQLStatTable(dsName, eventType);
            }
        });

        $('span#button-clear').omButton({
            icons : {left : '${resBase}/images/delete.png'},
            width : 70,
            onClick : function(event) {
                clearDatasourceSearch();
            }
        });

        commonInputFilter("#dsName");
        showSQLStatTable('', '');
    });

    function enable(type) {
        $.ajax({
            type : "post",
            async:false,
            dataType : "json",
            url : baseUrl+"/enable",
            data : {type : type},
            complete : function() {
            },
            error: function(){
                showErrorTip("启用失败！");
            },
            success : function(data) {
                if(data.status == "200") {
                    showMsgTip("启用成功", "success");
                } else {
                    showErrorTip("启用失败！");
                }
                window.location.href= baseUrl + "/datasourceDetail";
            }
        });
    }

    function disable(type) {
        $.ajax({
            type : "post",
            async:false,
            dataType : "json",
            url : baseUrl+"/disable",
            data : {type : type},
            complete : function() {
            },
            error: function(){
                showErrorTip("禁用失败！");
            },
            success : function(data) {
                if(data.status == "200") {
                    showMsgTip("禁用成功", "success");
                } else {
                    showErrorTip("禁用失败！");
                }
                window.location.href = baseUrl + "/datasourceDetail";
            }
        });
    }

    function showMsgTip(msg,type) {
        var tip = $("<div/>").text(msg).html();
        $.omMessageTip.show({
            type : type,
            title : '提示信息',
            content : tip,
            timeout : 3000
        });
    }

    function showErrorTip(msg) {
        var tip = $("<div/>").text(msg).html();
        $.omMessageTip.show({
            type : 'error',
            title : '失败',
            content : tip,
            timeout : 3000
        });
    }

    function commonInputFilter(selector){
        var regx=/[\'\"\:\;\<\>\,\?\/\`\~\!\#\%\^\&\*\|\\\+\=]+/g;
        $(selector).bind("keydown change blur", function(event) {
            var obj=$(this);
            setTimeout(function(){
                var v=obj.val();
                if(regx.test(v))
                    obj.val(v.replace(regx, ""));
            }, 0);
        });
    }


    function showSQLStatTable(dsName, eventType) {
        $('#grid-sql-inner').omGrid({
            limit : 10,
            height: 650,
            showIndex : true,
            singleSelect : true,
            emptyMsg : 'No data!',
            dataSource : baseUrl + '/getSQLStatisticsGird',
            extraData:{dsName: dsName, eventType: eventType},
            colModel : [
                {header : '事件类型', name : 'eventType', width : 100, align : 'center'},
                {header : '数据源名称', name : 'dsName', width : 100, align : 'center'},
                {header : 'SQL语句', name : 'sql', width : 400, align : 'left', renderer : function(colValue,rowData,rowIndex) {
                    if(rowData.sql != undefined) {
                        return $("<div/>").append($("<div style='word-wrap: break-word; white-space : normal'/>").text(rowData.sql)).html();
                    }
                    return "";
                }},
                {header : '执行次数', name : 'times', width : 80, align : 'center'},
                {header : '执行时长（毫秒）', name : 'executionTime', width : 100, align : 'center'},
                {header : '执行时间', name : 'startExecutionTime', width : 120, align : 'center'},
                {header : '执行堆栈', name : 'exceptionStack', width : 'autoExpand', align : 'left'}
            ]
        });
    }

    function clearDatasourceSearch() {
        $("#dsName").text("");
        $("#eventType").val("");
    }
</script>
</html>

