<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>HTTP链接</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<%@ include file="/WEB-INF/common-monitor/jqplot-js.jsp"%>
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<%@ include file="/WEB-INF/common-monitor/jqplot-css.jsp"%>
<script>
    $(function() {
    	init();
    	showHttpActiveChart();
    });
    
    function init() {
		isRunning = false;
		setInterval("showHttpActiveChart()", 4000);
	}
	
	function showIntervalChart() {
		if(!isRunning) {
			isRunning = true;
			showHttpActiveChart();
			isRunning = false;
		}
	}
	
    function getHttpActiveData(url, data) {
    	var json = getAjaxJsonData(url, data);
    	var ret = {};
    	if(json && json != "" && json != "null") {
    		ret.data = json;
    	} else {
    		ret.data = [];
    	}
    	return ret;
    }

    function showHttpActiveChart() {
    	var url = "${contextPath}/protect/monitor/http/countJson";
    	var data = getHttpActiveData(url, {});
    	var count = 0;
    	try {
    		if(httpActiveChart) {
    			httpActiveChart.destroy();
    		}
    	} catch (e) {
    		
    	}
    	if(data.data.length == 0) {
			showChartNoData("#activeThreadsDiv", "HTTP连接监控，没有数据");
			return;
		} else {
			$("#activeThreadsDiv").empty();
		}
    	httpActiveChart = $.jqplot('activeThreadsDiv', data.data, $.extend(true, getDefaultOptions(), {
    		title: "HTTP连接监控",
    		seriesColors:['#17BDB8'],
    		axes: {
                xaxis: {
                	tickOptions: {
                		formatter: function(format, val) {
                			count++;
                			if((count)%2 == 0) {
                				return val;
                			}
                			return " ";
                		}
                	}
                }
            }
    	}));
    }
</script>
</head>
<body>
    <div style="padding: 8px;width: 98%; height: 97%;">
        <div style="border:1px solid #9CCEFD;width: 100%; height: 65%;">
            <div id="activeThreadsDiv" style="height:98%;"></div>
        </div>
    </div>
</body>
</html>
