<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"/>
    <title>JVM快照</title>
    <c:set var="contextPath" value="${pageContext.request.contextPath}"/>
    <c:set var="resBase" value="${contextPath}/res"/>
    <script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
    <script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
    <script type="text/javascript" src="${resBase}/scripts/common.js"></script>
    <script type="text/javascript" src="${resBase}/scripts/monitor/index-panel.js"></script>
    <link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css"/>
    <link rel="stylesheet" type="text/css" href="${resBase}/css/common.css"/>
    <link rel="stylesheet" type="text/css" href="${resBase}/css/main.css"/>
    <style type="text/css">
        .jndi-value {

        }

        .datasource-key {
            color: #8E8E8E;
        }

        .datasource-value td span {
            color: #4A4AFF;
            display: inline-block;
            margin-left: 10px;
        }

        .datasource-key td label {
            margin-left: 20px;
        }

        .om-panel-header {
            margin: 8px 0 -8px 8px;
        }

        .om-borderlayout .om-borderlayout-region-body {
            margin: 8px 0 8px 8px;
        }

        .om-buttonbar {
            border-bottom: none;
        }

        #search-panel span.label {
            margin-left: 10px;
        }

        #search-panel .input-text {
            border: 1px solid #6D869E;
            height: 18px;
            vertical-align: middle;
            width: 137px;
        }
    </style>
    <script>
        var baseUrl = "${pageContext.request.contextPath}/protect/monitor/thread";
        $(function () {

            $('body').omBorderLayout({
                panels : [ {
                    id : "center-panel",
                    header : false,
                    region : "center"
                }, {
                    id : "north-panel",
                    header : false,
                    region : "north",
                    height: 30
                } ]

            });

            $('#hungThreadButtonbar').omButtonbar({
                btns : [{
                    label : "返回线程监控",
                    id : "button1",
                    icons : {
                        left : '${resBase}'+'/images/service.png'
                    },
                    onClick : function() {
                        window.location.href=baseUrl;
                    }
                }]
            });


            $('#hung-thread-grid').omGrid({
                width: '100%',
                height: 500,
                limit: 0,
                autoFit: true,
                showIndex: true,
                colModel: [
                    {
                        header: '线程ID',
                        name: 'threadId',
                        width: 100,
                        align: 'center'
                    },
                    {
                        header: '线程名称',
                        name: 'threadName',
                        width: 150,
                        align: 'center'
                    },
                    {
                        header: '处理时间（毫秒）',
                        name: 'processTime',
                        width: 100,
                        align: 'center'
                    },
                    {
                        header: '应用名称',
                        name: 'appName',
                        width: 150,
                        align: 'center'
                    },
                    {
                        header: '请求上下文',
                        name: 'context',
                        width: 150,
                        align: 'center'
                    },
                    {
                        header: '请求方法',
                        name: 'method',
                        width: 120,
                        align: 'center'
                    },
                    {
                        header: '请求IP',
                        name: 'ip',
                        width: 150,
                        align: 'center'
                    },
                    {
                        header: '请求url',
                        name: 'url',
                        width: 150,
                        align: 'center'
                    },
                    {
                        header: '线程堆栈',
                        name: 'stackTrace',
                        width: 'autoExpand',
                        align: 'left',
                        renderer: function (colValue, rowData, rowIndex) {
                            if(colValue) {
                                return $("<div></div>").val(colValue.replace(/\n/g, "</br>")).val();
                            }
                            return "";
                        }
                    },
                    {
                        header: '操作',
                        name: '',
                        width: 80,
                        align: 'center',
                        renderer: function (colValue, rowData, rowIndex) {
                            return "<a href='#' onclick=\"stopHungThread('" + rowData.threadId + "')\" title='停止'>停止</a>";
                        }
                    }
                ],
                dataSource: baseUrl + '/hung/list'
            });
        });

        function stopHungThread(id) {
            $.ajax({
                type: "post",
                async: false,
                dataType: "json",
                url: baseUrl + "/hung/stop",
                data: {id: id},
                complete: function () {
                },
                error: function () {
                    showErrorTip("停止失败！");
                },
                success: function (data) {
                    if (data.status == "200") {
                        showMsgTip("成功停止线程！", "success");
                        $('#hung-thread-grid').omGrid("reload");
                    } else {
                        showErrorTip("停止失败！");
                    }
                }
            });
        }

        function showMsgTip(msg, type) {
            var tip = $("<div/>").text(msg).html();
            $.omMessageTip.show({
                type: type,
                title: '提示信息',
                content: tip,
                timeout: 3000
            });
        }

        function showErrorTip(msg) {
            var tip = $("<div/>").text(msg).html();
            $.omMessageTip.show({
                type: 'error',
                title: '失败',
                content: tip,
                timeout: 3000
            });
        }

        function showSelectAlert() {
            $.omMessageBox.alert({
                title: '提示',
                content: '请选择记录！'
            });
        }
    </script>
</head>
<body style="width: 100%;">
<div id="north-panel">
    <div></div>
    <div id="hungThreadButtonbar"></div>
</div>
<div id="center-panel">
    <table id="hung-thread-grid"></table>
    <div id="dialog-confirm" title="确认" style="display: none;">
        确认要删除？
    </div>
</div>

</body>
</html>
