<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>J2EE信息</title>
<c:set var="resBase" value="${pageContext.request.contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-rules.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/form.js"></script>
<script type="text/javascript" src="${resBase}/scripts/navmenu.js"></script>

<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/om-ui/om-apusic.css" />
<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/common.css" />
<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/main.css" />
</head>
<body>
	<div id="center-panel">
        <div style="margin: 0 5px;">
            <table id="jspTable"></table>
            <div class="ht_15"></div>
            <table id="servletTable"></table>
            <div class="ht_15"></div>
            <table id="ejbTable"></table>
        </div>
	</div>
	<div id="west-panel" >
		<ul id="j2eeTree"></ul>
	</div>
</body>
<script type="text/javascript">
	var baseUrl = "${pageContext.request.contextPath}/protect/monitor/j2ee";
    $(document).ready(function() {
        var element = $('body').omBorderLayout({
            panels : [ {
                id : "center-panel",
                header : false,
                region : "center"
            }, {
                id : "west-panel",
                resizable : false,
                collapsible : false,
                region : "west",
                width : 280
            } ]

        });
        loadTree();
    });

    function loadTree() {
        $.ajax({
            type : "post",
            dataType : "json",
            url : baseUrl+"/loadTree",
            success : function(data) {
                $("#j2eeTree").omTree({
                    dataSource : data,
                    onClick : function(node, event) {
                    	fetchData(node);
                    }
                });
                if (data != null && data != "") {
                    loadData(data[0].j2eeType, data[0].name);
                }
            }
        });
    }

    function fetchData(node) {
	     var j2eeType = node.j2eeType;
	     var name = node.name;
	    loadServlet(j2eeType, name) ;
	    loadJsp(j2eeType, name) ;
	    loadEjb(j2eeType, name) ;
    }
    function loadData(j2eeType, name) {
    	loadServlet(j2eeType, name) ;
    	loadJsp(j2eeType, name) ;
      	loadEjb(j2eeType, name) ;
    }
   function loadServlet(j2eeType, name) {
    	  var url = baseUrl+'/servletStatistics?j2eeType=' + j2eeType + '&name='
          + name;
        $('#servletTable').omGrid({
            title : 'Servlet组件',
            height : 260,
            width : 'fit',
            limit : 0,
            showIndex : false,
            singleSelect : true,
            loadingMsg : '正在加载数据，请稍候...',
            colModel : [ {
                header : 'Servlet名',
                name : 'name',
                width : 'autoExpand',
                align : 'left',
                sort : 'clientSide'
            }, {
                header : '服务数',
                name : 'serviceCount',
                align : 'center',
                width : 80,
                sort : 'clientSide'
            }, {
                header : '服务时间',
                name : 'serviceTime',
                align : 'center',
                width : 80,
                sort : 'clientSide',
                renderer : function(colValue, rowData, rowIndex) {
                    if (rowData.serviceTime != null) {
                        return rowData.serviceTime + "ms";
                    } else {
                        return "0ms";
                    }
                }
            }, {
                header : '平均时间',
                name : 'serviceTime',
                align : 'center',
                width : 100,
                sort : 'clientSide',
                renderer : function(colValue, rowData, rowIndex) {
                    if (rowData.serviceCount != 0) {
                        return roundFun((rowData.serviceTime / rowData.serviceCount), 1) + "ms/次";
                    } else {
                        return "--";
                    }
                }
            } ],
            dataSource : url
        });
        $('#servletTable').omGrid("resize");
    }

    function loadJsp(j2eeType, name) {
    	  var url = baseUrl+'/jspStatistics?j2eeType=' + j2eeType + '&name='
          + name;
        $('#jspTable').omGrid({
            title : 'JSP组件',
            height : 200,
            width : 'fit',
            limit : 0,
            showIndex : false,
            singleSelect : true,
            loadingMsg : '正在加载数据，请稍候...',
            colModel : [ {
                header : 'jsp文件',
                name : 'name',
                width : 'autoExpand',
                align : 'left',
                sort : 'clientSide'
            }, {
                header : '服务数',
                name : 'serviceCount',
                width : 80,
                align : 'center',
                sort : 'clientSide'
            }, {
                header : '服务时间',
                name : 'serviceTime',
                width : 80,
                align : 'center',
                sort : 'clientSide',
                renderer : function(colValue, rowData, rowIndex) {
                    if (rowData.serviceTime) {
                        return rowData.serviceTime + "ms";
                    } else {
                        return "0ms";
                    }
                }
            }, {
                header : '平均时间',
                name : 'avgTime',
                width : 100,
                align : 'center',
                sort : 'clientSide',
                renderer : function(colValue, rowData, rowIndex) {
                    if (rowData.serviceCount != 0) {
                        return roundFun((rowData.serviceTime / rowData.serviceCount), 1) + "ms/次";
                    } else {
                        return "--";
                    }
                }
            } ],
            dataSource : url
        });
        $('#jspTable').omGrid("resize");
    }

    function loadEjb(j2eeType, name) {
    	  var url = baseUrl+'/ejbStatistics?j2eeType=' + j2eeType + '&name='
          + name;
        $('#ejbTable').omGrid({
            title : 'EJB组件',
            height : 200,
            width : 'fit',
            limit : 0,
            showIndex : false,
            singleSelect : true,
            loadingMsg : '正在加载数据，请稍候...',
            colModel : [ {
                header : 'ejb名',
                name : 'name',
                width : 'autoExpand',
                align : 'left',
                sort : 'clientSide'
            }, {
                header : '提交数',
                name : 'committedCount',
                width : 60,
                align : 'center',
                sort : 'clientSide'
            }, {
                header : '创建数',
                name : 'createCount',
                width : 80,
                align : 'center',
                sort : 'clientSide'
            }, {
                header : '删除数',
                name : 'removeCount',
                width : 60,
                align : 'center',
                sort : 'clientSide'
            }, {
                header : '成功率',
                name : 'serviceTime',
                width : 60,
                align : 'center',
                sort : 'clientSide',
                renderer : function(colValue, rowData, rowIndex) {
                    if (rowData.createCount != 0) {
                    	 return roundFun((rowData.committedCount/rowData.createCount),1);
                    }else{
                    	 return "--";
                    }
                }
            } ],
            dataSource : url
        });
    }

    function roundFun(numberRound, roundDigit) {
        var digit;
        digit = 1;
        digit = Math.pow(10, roundDigit);
        return (Math.round(numberRound * digit) / digit);
    }
</script>
</html>

