<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>JTA监控</title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<%@ include file="/WEB-INF/common-monitor/jqplot-js.jsp"%>
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<%@ include file="/WEB-INF/common-monitor/jqplot-css.jsp"%>
<script>
	$(function() {
		init();
		showJtaChart();
		setInterval("showIntervalChart()", 3000);
	});
	
	function init() {
		isRunning = false;
	}
	
	function showIntervalChart() {
		if(!isRunning) {
			isRunning = true;
			showJtaChart();
			isRunning = false;
		}
	}
	
	function getJtaData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			var legendName = new Array();
			var xyData = new Array();
			$(json).each(function(i, v){
				legendName.push(v.legend);
				xyData.push(v.data);
			});
			ret.legend = legendName;
			ret.data = xyData;
		} else {
			ret.legend = [];
			ret.data = [];
		}
		return ret;
	}

	function showJtaChart() {
		var url = "${contextPath}/protect/monitor/jta/statisticsJson";
		var data = getJtaData(url, {});
		var count = 0;
		try {
			if(jtaChart) {
				jtaChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#line-inner", "JTA事务统计，没有数据");
			return;
		} else {
			$("#line-inner").empty();
		}
		jtaChart = $.jqplot('line-inner', data.data, $.extend(true, getDefaultOptions(), {
	  		title: "JTA事务统计",
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			count++;
	            			if((count)%2 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            }
	        },
	        legend: {
	            renderer: $.jqplot.EnhancedLegendRenderer, 
	            show: true,
	            location: 's',
	            placement: 'outsideGrid',
	            labels: data.legend,
	            shrinkGrid: true,
	            rendererOptions: {
	            	numberRows : 1
	            }
	        }
		}));
	}

</script>
</head>
<body>
	<div style="margin: 8px; width: 98%; height: 97%;">
		<div style="border:1px solid #9CCEFD;width: 100%; height: 65%;">
			<div id="line-inner" style="height:98%;"></div>
		</div>
	</div>
</body>
</html>