<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"/>
    <title>监控回放</title>
    <c:set var="contextPath" value="${pageContext.request.contextPath}"/>
    <c:set var="resBase" value="${contextPath}/res"/>
    <script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
    <script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
    <script type="text/javascript" src="${resBase}/scripts/common.js"></script>
    <%@ include file="/WEB-INF/common-monitor/jqplot-js.jsp" %>
    <link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css"/>
    <link rel="stylesheet" type="text/css" href="${resBase}/css/common.css"/>
    <link rel="stylesheet" type="text/css" href="${resBase}/css/main.css"/>
    <link rel="stylesheet" type="text/css" href="${resBase}/css/monitor/config.css"/>
    <link rel="stylesheet" type="text/css" href="${resBase}/css/app.css"/>
    <%@ include file="/WEB-INF/common-monitor/jqplot-css.jsp" %>
    <script>
        var baseUrl = "${pageContext.request.contextPath}/protect/monitor/playback";
        var classloadingData, datasourceData, jvmData, transactionData, threadpoolData, httpData, sessionData;
        var playbackLimit = 10;
        var playbackSpeed = 2;
        var classloadingIndex = 0, datasourceIndex = 0, httpIndex = 0, heapIndex = 0, nonheapIndex = 0,
            sessionIndex = 0, transactionIndex = 0, threadpoolIndex = 0;
        var playbackInterval;
        var classloadingStop = false, datasourceStop = false, httpStop = false, heapStop = false, nonheapStop = false,
            sessionStop = false, transactionStop = false, threadpoolStop = false;

        $(function () {
            init();
            var data = getChartData(baseUrl + "/getJsonData", {
                startTime: $("#startTime").val(),
                endTime: $("#endTime").val()
            })
            if (data.data) {
                classloadingData = data.data["classloading"];
                datasourceData = data.data["datasource"];
                jvmData = data.data["jvm"];
                transactionData = data.data["transaction"];
                threadpoolData = data.data["thread-pool"];
                httpData = data.data["http"];
                sessionData = data.data["session"];
            }
            classloadingIndex = 0, datasourceIndex = 0, httpIndex = 0, heapIndex = 0, nonheapIndex = 0,
                sessionIndex = 0, transactionIndex = 0, threadpoolIndex = 0;
            showAllChartData();
        });

        function showAllChartData() {
            if(playbackInterval) {
                clearInterval(playbackInterval);
            }
            classloadingStop = false;
            showClassLoadingChart();
            datasourceStop = false;
            showDataSourceChart();
            threadpoolStop = false;
            showActiveThreadChart();
            httpStop = false;
            showHttpActiveChart();
            sessionStop = false;
            showSessionChart();
            heapStop = false;
            showHeapChart();
            nonheapStop = false;
            showNonHeapChart();
            transactionStop = false;
            showTransactionChart();
            playbackInterval = setInterval(showAllChartData, 3000);
        }

        function init() {
            $('#startTime').omCalendar({
                showTime: true,
                dateFormat: 'yy-mm-dd H:i:s',
                maxDate: new Date(),
                readOnly: true,
                onSelect: function (date) {
                    var now = new Date();
                    $('#endTime').omCalendar({minDate: new Date(date.getTime() - 24 * 3600000)});
                }
            });
            $('#endTime').omCalendar({
                showTime: true,
                readOnly: true,
                dateFormat: 'yy-mm-dd H:i:s',
                maxDate: new Date(),
                onSelect: function (date) {
                    $('#startTime').omCalendar({maxDate: date});
                }
            });
            $('body').omBorderLayout({
                panels: [{
                    id: "center-panel",
                    header: false,
                    region: "center"
                }, {
                    id: "north-panel",
                    header: false,
                    region: "north",
                    height: 80
                }]

            });

            $('#playbackButtonbar').omButtonbar({
                btns : [{
                    label : "返回监控概览",
                    id : "button1",
                    icons : {
                        left : '${resBase}'+'/images/service.png'
                    },
                    onClick : function() {
                        window.location.href="${contextPath}/protect/monitor";
                    }
                }]
            });

            $('span#button-search').omButton({
                icons: {left: '${resBase}/images/check.png'},
                width: 70,
                onClick: function (event) {
                    var startTime = $('#startTime').val();
                    var endTime = $('#endTime').val();
                    if (startTime && endTime) {
                        var start = stringToDate(startTime);
                        var end = stringToDate(endTime);
                        if (end.valueOf() < start.valueOf()) {
                            showErrorTip("开始时间必须小于结束时间!");
                            return;
                        }
                    }
                    var data = getChartData(baseUrl + "/getJsonData", {
                        startTime: $("#startTime").val(),
                        endTime: $("#endTime").val()
                    })
                    if (data.data) {
                        classloadingData = data.data["classloading"];
                        datasourceData = data.data["datasource"];
                        jvmData = data.data["jvm"];
                        transactionData = data.data["transaction"];
                        threadpoolData = data.data["thread-pool"];
                        httpData = data.data["http"];
                        sessionData = data.data["session"];
                    }
                    classloadingIndex = 0, datasourceIndex = 0, httpIndex = 0, heapIndex = 0, nonheapIndex = 0,
                        sessionIndex = 0, transactionIndex = 0, threadpoolIndex = 0;
                    showAllChartData();
                }
            });

            $('span#button-clear').omButton({
                icons: {left: '${resBase}/images/delete.png'},
                width: 70,
                onClick: function (event) {
                    clearPlaybackSearch();
                }
            });

        }

        /**
         * yyyy-MM-dd hh:mm:ss
         * @param date
         * @returns {Date}
         */
        function stringToDate(date) {
            var d = (date.split(" ")[0]).split("-");
            var t = (date.split(" ")[1]).split(":");
            return new Date(d[0], d[1] - 1, d[2], t[0], t[1], t[2]);
        }

        function clearPlaybackSearch() {
            $("#startTime").val("");
            $("#endTime").val("");
        }


        function getChartData(url, data) {
            var json = getAjaxJsonData(url, data);
            var ret = {};
            if (json && json != "" && json != "null") {
                ret.data = json;
            } else {
                ret.data = [];
            }
            return ret;
        }

        function getArrayData(data, start, limit) {
            var array = new Array();
            if(!$.isArray(data)) {
                return array;
            }
            if (data.length > start + limit) {
                array.push(data.slice(start, start + limit));
            } else if (start > data.length - 1) {

            } else {
                array.push(data.slice(start, data.length));
            }
            return array;
        }

        function getArraySliceData(data, start, limit) {
            if(!$.isArray(data)) {
                return new Array();
            }
            if (data.length > start + limit) {
                return data.slice(start, start + limit);
            } else if (start > data.length - 1) {
                return new Array();
            } else {
                return data.slice(start, data.length);
            }
        }

        function getHeapData(json) {
            var ret = {};
            if (json && json != "" && json != "null" && json["heap"]) {
                ret.data = getArrayData(json["heap"], heapIndex, playbackLimit);
            } else {
                ret.data = [];
            }
            return ret;
        }

        function showHeapChart() {
            if(heapStop) {
                return;
            }
            var element = "heap-panel", json = jvmData;
            var data = getHeapData(json);
            heapIndex = heapIndex + playbackSpeed;
            try {
                if (memoryChart) {
                    memoryChart.destroy();
                }
            } catch (e) {

            }
            if (data.data.length == 0) {
                heapStop = true;
                showChartNoData("#" + element, "JVM堆内存监控，没有数据或回放完成");
                return;
            } else {
                $(element).empty();
            }
            memoryChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
                title: "JVM堆内存监控",
                seriesColors: ['#17BDB8'],
                axes: {
                    xaxis: {
                        tickOptions: {
                            formatter: function (format, val) {
                                if (typeof val == "string" && val.indexOf(" ") > 0) {
                                    return val.split(" ")[1];
                                } else {
                                    return val;
                                }
                            }
                        }
                    },
                    yaxis: {
                        tickOptions: {
                            formatter: function (format, val) {
                                return parseInt(val / 1024 / 1024) + "M";
                            }
                        }
                    }
                },
                seriesDefaults: {
                    fill: true,
                    fillAndStroke: true,
                    fillAlpha: 0.5,
                    shadow: false,
                    rendererOptions: {
                        animation: {
                            speed: -1
                        }
                    }
                }
            }));
        }

        function getNonHeapData(json) {
            var ret = {};
            if (json && json != "" && json != "null" && json["nonheap"]) {
                ret.data = getArrayData(json["nonheap"], nonheapIndex, playbackLimit);
            } else {
                ret.data = [];
            }
            return ret;
        }

        function showNonHeapChart() {
            if(nonheapStop) {
                return;
            }
            var element = "nonheap-panel", json = jvmData;
            var data = getNonHeapData(json);
            nonheapIndex = nonheapIndex + playbackSpeed;
            try {
                if (memoryNonHeapChart) {
                    memoryNonHeapChart.destroy();
                }
            } catch (e) {

            }
            if (data.data.length == 0) {
                nonheapStop = true;
                showChartNoData("#" + element, "JVM非堆内存监控，没有数据或回放完成");
                return;
            } else {
                $(element).empty();
            }
            memoryNonHeapChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
                title: "JVM非堆内存监控",
                seriesColors: ['#17BDB8'],
                axes: {
                    xaxis: {
                        tickOptions: {
                            formatter: function (format, val) {
                                if (typeof val == "string" && val.indexOf(" ") > 0) {
                                    return val.split(" ")[1];
                                } else {
                                    return val;
                                }
                            }
                        }
                    },
                    yaxis: {
                        tickOptions: {
                            formatter: function (format, val) {
                                return parseInt(val / 1024 / 1024) + "M";
                            }
                        }
                    }
                },
                seriesDefaults: {
                    fill: true,
                    fillAndStroke: true,
                    fillAlpha: 0.5,
                    shadow: false,
                    rendererOptions: {
                        animation: {
                            speed: -1
                        }
                    }
                }
            }));
        }

        function showClassLoadingChart() {
            if(classloadingStop) {
                return;
            }
            var element = "classloading-panel", json = classloadingData;
            try {
                if (classloadChart) {
                    classloadChart.destroy();
                }
            } catch (e) {

            }
            var data = getArrayData(json, classloadingIndex, playbackLimit);
            classloadingIndex = classloadingIndex + playbackSpeed;
            if (data.length == 0) {
                classloadingStop = true;
                showChartNoData("#" + element, "JVM类加载监控，没有数据或回放完成");
                return;
            } else {
                $(element).empty();
            }
            classloadChart = $.jqplot(element, data, $.extend(true, getDefaultOptions(), {
                title: "JVM类加载监控",
                seriesColors: ['#17BDB8'],
                axes: {
                    xaxis: {
                        tickOptions: {
                            formatter: function (format, val) {
                                if (typeof val == "string" && val.indexOf(" ") > 0) {
                                    return val.split(" ")[1];
                                } else {
                                    return val;
                                }
                            }
                        }
                    }
                },
                seriesDefaults: {
                    fill: true,
                    fillAndStroke: true,
                    fillAlpha: 0.5,
                    shadow: false,
                    rendererOptions: {
                        animation: {
                            speed: -1
                        }
                    }
                }
            }));
        }

        function getSessionData(json) {
            var ret = {};
            if (json && json != "" && json != "null") {
                var appName = new Array();
                var xyData = new Array();
                for (var i in json) {
                    appName.push(i);
                    var arr = getArraySliceData(json[i], sessionIndex, playbackLimit);
                    if(arr.length > 0) {
                        xyData.push(arr);
                    }
                }
                ret.legend = appName;
                ret.data = xyData;
            } else {
                ret.legend = [];
                ret.data = [];
            }
            return ret;
        }

        function showSessionChart() {
            if(sessionStop) {
                return;
            }
            var element = "session-panel", json = sessionData;
            var data = getSessionData(json);
            sessionIndex = sessionIndex + playbackSpeed;
            try {
                if (appSessionChart) {
                    appSessionChart.destroy();
                }
            } catch (e) {

            }
            if (data.data.length == 0) {
                sessionStop = true;
                showChartNoData("#" + element, "应用会话统计，没有数据或回放完成");
                return;
            } else {
                $(element).empty();
            }
            var numberRows = data.legend.length / 5, numberColumns = 5;
            if (numberRows == 0) {
                numberRows = 1;
            }
            for (var i = 0; i < data.legend.length; i++) {
                if (data.legend[i].length > 10) {
                    data.legend[i] = data.legend[i].substring(0, 10) + "...";
                }
            }
            appSessionChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
                title: "应用会话统计",
                axes: {
                    xaxis: {
                        tickOptions: {
                            formatter: function (format, val) {
                                if (typeof val == "string" && val.indexOf(" ") > 0) {
                                    return val.split(" ")[1];
                                } else {
                                    return val;
                                }
                            }
                        }
                    }
                },
                legend: {
                    renderer: $.jqplot.EnhancedLegendRenderer,
                    show: true,
                    location: 's',
                    placement: 'outsideGrid',
                    // 图例单独指定
                    labels: data.legend,
                    shrinkGrid: true,
                    rendererOptions: {
                        numberRows: numberRows,
                        numberColumns: numberColumns
                    }
                },
                seriesDefaults: {
                    fillAndStroke: true,
                    fillAlpha: 0.5,
                    shadow: false,
                    rendererOptions: {
                        animation: {
                            speed: -1
                        }
                    }
                }
            }));
        }

        function getDataSourceData(json) {
            var ret = {};
            if (json && json != "" && json != "null") {
                var datasourceName = new Array();
                var xyData = new Array();
                for (var i in json) {
                    datasourceName.push(i);
                    var arr = getArraySliceData(json[i], datasourceIndex, playbackLimit);
                    if(arr.length != 0) {
                        xyData.push(arr);
                    }
                }
                ret.legend = datasourceName;
                ret.data = xyData;
            } else {
                ret.legend = [];
                ret.data = [];
            }
            return ret;
        }

        function showDataSourceChart() {
            if(datasourceStop) {
                return;
            }
            var element = "datasource-panel", json = datasourceData
            var data = getDataSourceData(json);
            datasourceIndex = datasourceIndex + playbackSpeed;
            try {
                if (dataSourceChart) {
                    dataSourceChart.destroy();
                }
            } catch (e) {

            }
            if (data.data.length == 0) {
                datasourceStop = true;
                showChartNoData("#" + element, "数据源监控，没有数据或回放完成");
                return;
            } else {
                $(element).empty();
            }
            dataSourceChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
                title: "数据源连接统计",
                axes: {
                    xaxis: {
                        tickOptions: {
                            formatter: function (format, val) {
                                if (typeof val == "string" && val.indexOf(" ") > 0) {
                                    return val.split(" ")[1];
                                } else {
                                    return val;
                                }
                            }
                        }
                    }
                },
                legend: {
                    renderer: $.jqplot.EnhancedLegendRenderer,
                    show: true,
                    location: 's',
                    placement: 'outsideGrid',
                    labels: data.legend,
                    shrinkGrid: true,
                    rendererOptions: {
                        numberRows: 1
                    }
                },
                seriesDefaults: {
                    fillAndStroke: true,
                    fillAlpha: 0.5,
                    shadow: false,
                    rendererOptions: {
                        animation: {
                            speed: -1
                        }
                    }
                }
            }));
        }

        function getActiveThreadData(json) {
            var ret = {};
            if (json && json != "" && json != "null") {
                var threadName = new Array();
                var xyData = new Array();
                for (var i in json) {
                    threadName.push(i);
                    var arr = getArraySliceData(json[i], threadpoolIndex, playbackLimit);
                    if(arr.length != 0) {
                        xyData.push(arr);
                    }
                }
                ret.legend = threadName;
                ret.data = xyData;
            } else {
                ret.legend = [];
                ret.data = [];
            }
            return ret;
        }


        function showActiveThreadChart() {
            if(threadpoolStop) {
                return;
            }
            var element = "thread-panel", json = threadpoolData;
            var data = getActiveThreadData(json);
            threadpoolIndex = threadpoolIndex + playbackSpeed;
            try {
                if (activeThreadChart) {
                    activeThreadChart.destroy();
                }
            } catch (e) {

            }
            if (data.data.length == 0) {
                threadpoolStop = true;
                showChartNoData("#" + element, "活动线程数监控，没有数据或回放完成");
                return;
            } else {
                $(element).empty();
            }
            activeThreadChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
                title: "活动线程数监控",
                axes: {
                    xaxis: {

                        tickOptions: {
                            formatter: function (format, val) {
                                if (typeof val == "string" && val.indexOf(" ") > 0) {
                                    return val.split(" ")[1];
                                } else {
                                    return val;
                                }
                            }
                        }
                    }
                },
                legend: {
                    renderer: $.jqplot.EnhancedLegendRenderer,
                    show: true,
                    location: 's',
                    placement: 'outsideGrid',
                    labels: data.legend,
                    shrinkGrid: true,
                    rendererOptions: {
                        numberRows: 1
                    }
                },
                seriesDefaults: {
                    fillAndStroke: true,
                    fillAlpha: 0.5,
                    shadow: false,
                    rendererOptions: {
                        animation: {
                            speed: -1
                        }
                    }
                }
            }));
        }


        function showHttpActiveChart() {
            if(httpStop) {
                return;
            }
            var element = "http-panel", json = httpData;
            try {
                if (httpActiveChart) {
                    httpActiveChart.destroy();
                }
            } catch (e) {

            }
            var data = getArrayData(json, httpIndex, playbackLimit);
            httpIndex = httpIndex + playbackSpeed;
            if (data.length == 0) {
                httpStop = true;
                showChartNoData("#" + element, "HTTP连接监控，没有数据或回放完成");
                return;
            } else {
                $(element).empty();
            }
            httpActiveChart = $.jqplot(element, data, $.extend(true, getDefaultOptions(), {
                title: "HTTP连接监控",
                seriesColors: ['#17BDB8'],
                axes: {
                    xaxis: {

                        tickOptions: {
                            formatter: function (format, val) {
                                if (typeof val == "string" && val.indexOf(" ") > 0) {
                                    return val.split(" ")[1];
                                } else {
                                    return val;
                                }
                            }
                        }
                    }
                },
                seriesDefaults: {
                    fillAndStroke: true,
                    fillAlpha: 0.5,
                    shadow: false,
                    rendererOptions: {
                        animation: {
                            speed: -1
                        }
                    }
                }
            }));
        }

        function getTransactionData(json) {
            var ret = {};
            if (json && json != "" && json != "null") {
                var array = new Array();
                array.push("已提交");
                array.push("已回滚");
                array.push("已超时");
                ret.legend = array;
                var xyData = new Array();
                xyData.push(getArraySliceData(json["committed"], transactionIndex, playbackLimit));
                xyData.push(getArraySliceData(json["rollback"], transactionIndex, playbackLimit));
                xyData.push(getArraySliceData(json["timeout"], transactionIndex, playbackLimit));
                ret.data = xyData;
            } else {
                ret.legend = [];
                ret.data = [];
            }
            return ret;
        }

        function showTransactionChart() {
            if(transactionStop) {
                return;
            }
            var element = "transaction-panel", json = transactionData;
            var data = getTransactionData(json);
            transactionIndex = transactionIndex + playbackSpeed;
            try {
                if (jtaChart) {
                    jtaChart.destroy();
                }
            } catch (e) {

            }
            if (data.data.length == 0 || data.data[0].length == 0) {
                transactionStop = true;
                showChartNoData("#" + element, "JTA事务统计，没有数据或回放完成");
                return;
            } else {
                $(element).empty();
            }
            jtaChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
                title: "JTA事务统计",
                highlighter: {
                    show: true,
                    tooltipAxes: "y"
                },
                axes: {
                    xaxis: {
                        tickOptions: {
                            formatter: function (format, val) {
                                if (typeof val == "string" && val.indexOf(" ") > 0) {
                                    return val.split(" ")[1];
                                } else {
                                    return val;
                                }
                            }
                        }
                    }
                },
                legend: {
                    renderer: $.jqplot.EnhancedLegendRenderer,
                    show: true,
                    location: 's',
                    placement: 'outsideGrid',
                    labels: data.legend,
                    shrinkGrid: true,
                    rendererOptions: {
                        numberRows: 1
                    }
                },
                seriesDefaults: {
                    fillAndStroke: true,
                    fillAlpha: 0.5,
                    shadow: false,
                    rendererOptions: {
                        animation: {
                            speed: -1
                        }
                    }
                }
            }));
        }

        function showMsgTip(msg, type) {
            var tip = $("<div/>").text(msg).html();
            $.omMessageTip.show({
                type: type,
                title: '提示信息',
                content: tip,
                timeout: 3000
            });
        }

        function showErrorTip(msg) {
            var tip = $("<div/>").text(msg).html();
            $.omMessageTip.show({
                type: 'error',
                title: '失败',
                content: tip,
                timeout: 3000
            });
        }
    </script>
</head>
<body>
<div id="north-panel">
    <div id="playbackButtonbar"></div>
    <div id="search-panel" style="padding-top: 4px;">
        <div style="width: 100%;text-align: center">
            <span class="label">开始时间： </span>
            <input id="startTime" class="inputDateUI" type="text" name="startTime"/>
            <span class="label">结束时间： </span>
            <input id="endTime" class="inputDateUI" type="text" name="endTime"/>
            <span id="button-search">回放</span>
            <span id="button-clear">清空</span>
        </div>
    </div>
</div>
<div id="center-panel">
    <div class="index_panel">
        <div id="datasource-panel" style="height:98%;"></div>
    </div>
    <div class="index_panel index_panel_right">
        <div id="classloading-panel" style="height:98%;"></div>
    </div>
    <div class="index_panel">
        <div id="thread-panel" style="height:98%;"></div>
    </div>
    <div class="index_panel index_panel_right">
        <div id="session-panel" style="height:98%;"></div>
    </div>
    <div class="index_panel">
        <div id="heap-panel" style="height:98%;"></div>
    </div>
    <div class="index_panel index_panel_right">
        <div id="nonheap-panel" style="height:98%;"></div>
    </div>
    <div class="index_panel">
        <div id="transaction-panel" style="height:98%;"></div>
    </div>
    <div class="index_panel index_panel_right">
        <div id="http-panel" style="height:98%;"></div>
    </div>

</div>
</body>
</html>
