<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>线程监控 </title>
<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<%@ include file="/WEB-INF/common-monitor/jqplot-js.jsp"%>
<link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<%@ include file="/WEB-INF/common-monitor/jqplot-css.jsp"%>
<script>
    $(function() {
        $('#threadButtonbar').omButtonbar({
            btns : [{
                separtor : true
            }, {
                label : "Hung线程",
                id : "button1",
                icons : {
                    left : '${resBase}/images/setting.png'
                },
                onClick : function() {
                    window.location.href="${contextPath}/protect/monitor/thread/hung";
                }
            }, {
                separtor : true
            }]
        });
    	init();
    	showActiveThreadChart();
    	showThreadPoolChart();
    	setInterval("showIntervalChart()", 4000);
        $('#dumpThreadBtn').omButton({});
        
        $('#threadsTbl').omGrid({
            limit : 0,
            height : 300,
            showIndex : false,
            singleSelect : true,
            colModel : [ {
                header : '编号',
                name : 'id',
                width : 30,
                align : 'left'
            }, {
                header : '名称',
                name : 'name',
                width : 'autoExpand',
                align : 'left',
                wrap : true
            } ],
            dataSource : '${contextPath}/protect/monitor/thread/listThreads',
            onRowSelect : function(rowIndex, data) {
                $.ajax({
                    type : "post",
                    data : {
                        tid : data.id
                    },
                    url : "${contextPath}/protect/monitor/thread/threadInfo",
                    success : function(data) {
                        $('.threadInfo pre').html(data);
                    }
                });
            }
        });
        $('#nameFilterFld').keyup(function() {
            $('#threadsTbl').omGrid('setData', '${contextPath}/protect/monitor/thread/listThreads?nameFilter=' + $('#nameFilterFld').val());
        });
    });
    
    function init() {
		isRunning = false;
	}
	
	function showIntervalChart() {
		if(!isRunning) {
			isRunning = true;
			showActiveThreadChart();
			showThreadPoolChart();
			isRunning = false;
		}
	}
    
    function getActiveThreadData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			ret.data = json;
		} else {
			ret.data = [];
		}
		return ret;
	}
	
	function showActiveThreadChart() {
		var url = "${contextPath}/protect/monitor/thread/countJson";
		var data = getActiveThreadData(url, {});
		var count = 0;
		try {
			if(activeThreadChart) {
				activeThreadChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#activeThreadsDiv", "活动线程数监控，没有数据");
			return;
		} else {
			$("#activeThreadsDiv").empty();
		}
		activeThreadChart = $.jqplot('activeThreadsDiv', data.data, $.extend(true, getDefaultOptions(), {
			title: "活动线程数监控",
			seriesColors:['#17BDB8'],
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			count++;
	            			if((count)%2 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            }
	        }
		}));
	}
	
	function getThreadPoolData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			ret.data = json;
		} else {
			ret.data = [];
		}
		return ret;
	}

	function showThreadPoolChart() {
		var url = "${contextPath}/protect/monitor/thread/poolStatisticsJson";
		var data = getThreadPoolData(url, {});
		var count = 0;
		try {
			if(threadPoolChart) {
				threadPoolChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#threadPoolsDiv", "各线程池活动线程数监控，没有数据");
			return;
		} else {
			$("#threadPoolsDiv").empty();
		}
		threadPoolChart = $.jqplot('threadPoolsDiv', data.data, {
			title: "各线程池活动线程数监控",
			grid: {
	            drawBorder: false, 
	            drawGridlines: false,
	            shadow: false
	        },
			seriesColors: ['#a50c64', '#85e6bb', "#94c540", "#4b5de4", "#C7754C", "#4bb2c5", "#C5B47F", "#CC6666"],
			seriesDefaults:{
				renderer:$.jqplot.PieRenderer,
			    rendererOptions: {
			    	sliceMargin: 8,
			    	padding: 5,
			    	startAngle: 180,
			      	sliceMargin: 4,
			      	showDataLabels: true,
			      	dataLabels: "value"
			    }
			},
			legend: {
	            show: true,
	            location: 's',
	            placement: 'outsideGrid',
	            shrinkGrid: true,
	            rendererOptions: {
	            	numberRows : 2
	            }
	        }
		});
	}
</script>
<style type="text/css">
/** 解决表格最后一列与边缘间隔太多 **/
.om-grid div.hDivBox {
	float: left;
	padding-right: 10px;
}
pre{
	white-space: pre-wrap;       
	white-space: -moz-pre-wrap;  
	white-space: -pre-wrap;      
	white-space: -o-pre-wrap;    
	word-wrap: break-word;       
}
</style>
</head>
<body>
	<div id="threadButtonbar"></div>
	<div style="padding: 8px">
		<div style="border:1px solid #9CCEFD;">
			<div style="height:320px; background-color: #FCFCFC;">
				<div id="activeThreadsDiv" style="height:97%;"></div>
			</div>
	    </div>
	    <div class="ht_15"></div>
	    <table cellpadding="0" cellspacing="0" style="width: 100%;">
	        <tr>
	            <td width="25%" style="border:1px solid #9CCEFD;">
	                <div style="background-color: #FCFCFC;">
	                    <div id="threadPoolsDiv" style="width: 97%;"></div>
	                </div>
	            </td>
	            <td width="25%">
	                <input id="nameFilterFld" style="width:99%;"/>
	                <table id="threadsTbl"></table>
	            </td>
	            <td width="50%">
	            	<div class="threadInfo"><pre></pre></div>
	            </td>
	        </tr>
	    </table>
	</div>
</body>
</html>
