<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<title>安全域配置</title>

<c:set var="contextPath" value="${pageContext.request.contextPath}" />
<c:set var="resBase" value="${contextPath}/res" />

<%
    java.security.SecureRandom random = new java.security.SecureRandom();
    String key = String.valueOf(random.nextInt());
    int tmp = 16-key.length();
    for(int i=0;i<tmp;i++) {
        key +="0";
    }
    session.setAttribute("ldapKey", key);
%>

<script type="text/javascript" src="${resBase}/scripts/aes.js"></script>
<script type="text/javascript" src="${resBase}/scripts/pad-zeropadding-min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/sysconfig/realm.js"></script>

<link rel="stylesheet" type="text/css" href="${resBase}/css/om-ui/om-apusic.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/common.css" />
<link rel="stylesheet" type="text/css" href="${resBase}/css/sysconfig/realm.css" />

<style type="text/css">

#north_panel .title-bk {
    border-top: none;
    border-left: none;
    border-right: none;
    border-bottom: 1px solid #99A8BC;
}
#center_panel .title-bk {
    border: 1px solid #99A8BC;;
    border-bottom: none;
}

.panel-div {
	width: 98%;
}

.om-tabs .om-tabs-headers {
	border-top: none;
	border-left: none;
	border-right: none;
}
</style>
</head>

<body>
<div style="margin: 0px; padding: 8px;">
<div style="height: 94%; width: 100%; overflow: hidden;">  
<div id="realm">
    
    <input id="contextPath" value="${contextPath}" type="hidden" />
    <input id="resBase" value="${resBase}" type="hidden" />
    <div id="north_panel" style="border: 1px solid #99A8BC; height: 90px;">
        <div class="title-bk">默认域</div>
        <div class="realm-top">
        <label>名称：</label><input id="default_name" disabled="disabled" value="${default_realm_name}" />
        <label>类型：</label><input id="default_type" disabled="disabled" value="${default_realm_type}" />
        </div>
    </div>
    
    <div id="center_panel"  >
    	<div class="title-bk" style="margin-top: 15px;">域管理</div>
        <div style="border: 1px solid #99A8BC; ">
        <div id="realm-security" >
            <ul class="panel-div">
                <li><a href="#jdbc">JDBC存储</a></li>
                <li><a href="#ldap">LDAP存储</a></li>
                <li><a href="#self">自定义存储</a></li>
                <li><a href="#text">文本存储</a></li>
            </ul>
            <div id="jdbc" class="panel-div">
                <div class="realm_form_container">
                <form id="jdbcForm" action="${contextPath}/protect/sysconfig/realm/savejdbcRealm" method="post">
                    <table class="form_tbl">
                        <tr>
                            <td class="label_cell"><label>安全域名称：</label></td>
                            <td><input id="jdbcRealmName" name="jdbcRealmName" value="${jdbcModel.jdbcRealmName}" type="text" class="wt_80" /> <font color="red">*</font></td>
                            <td class="label_cell"><label>数据源JNDI名：</label></td>
                            <td><input type="text" name="jdbcDataSourceName" id="jdbcDataSourceName" value="${jdbcModel.jdbcDataSourceName}" class="wt_80" /> <font color="red">*</font></td>
                            <td class="label_cell"><label>用户信息表名：</label></td>
                            <td><input type="text" name="jdbcUserTableName" id="jdbcUserTableName" value="${jdbcModel.jdbcUserTableName}" class="wt_80" /> <font color="red">*</font></td>
                        </tr>
                        <tr>
                            <td class="label_cell"><label>用户名字段名：</label></td>
                            <td><input type="text" name="jdbcUserName" id="jdbcUserName" value="${jdbcModel.jdbcUserName}" class="wt_80" /> <font color="red">*</font></td>
                            <td class="label_cell"><label>密码字段名：</label></td>
                            <td><input type="text" name="jdbcPassword" id="jdbcPassword" value="${jdbcModel.jdbcPassword}" class="wt_80" autocomplete="off"/> <font color="red">*</font></td>
                            <td class="label_cell"><label>密码编码：</label></td>
                            <td>
                                <input type="radio" name="jdbcPasswordEncode" id="jdbcPasswordEncodeTrue" value="true" /><label>是</label>
                                <input type="radio" id="jdbcPasswordEncodeFalse" name="jdbcPasswordEncode" value="false" checked="checked" /><label>否</label>
                            </td>
                        </tr>
                        <tr>
                            <td class="label_cell"><label>根据用户名查询用户：</label></td>
                            <td colspan="5"><input type="text" name="jdbcSQLByUser" id="jdbcSQLByUser" value="${jdbcModel.jdbcSQLByUser}" class="wt_320" /> <font color="red">*</font></td>
                        </tr>
                        <tr>
                            <td class="label_cell"><label>根据组名查询用户：</label></td>
                            <td colspan="5"><input type="text" name="jdbcSQLByGroup" id="jdbcSQLByGroup" value="${jdbcModel.jdbcSQLByGroup}" class="wt_320" /> <font color="red">*</font></td>
                        </tr>
                        <tr>
                            <td class="label_cell"><label>编码密码的全类名：</label></td>
                            <td colspan="4"><input type="text" name="jdbcEncodeClass"  id="jdbcEncodeClass" value="${jdbcModel.jdbcEncodeClass}" class="wt_320" /><font style="margin-left: 5px;" color="red">*</font></td>
                            <td align="right"><input id="jdbc_realm_button"  type="submit" value="保存" /></td>
                        </tr>
                    </table>
                </form>
                </div>
                <div class="realm-text-list">
                    <div id="realm-jdbc-buttonbar"></div>
                    <table id="realm-jdbc-grid"></table>
                </div>
            </div>
            <div id="ldap" class="panel-div">
                <div class="realm_form_container">
                <form id="ldapForm" action="${contextPath}/protect/sysconfig/realm/saveldapRealm" method="post">
                    <table class="form_tbl">
                        <tr>
                            <td class="label_cell"><label>安全域名称：</label></td>
                            <td><input id="ldapRealmName" name="ldapRealmName" value="${ldModel.ldapRealmName}" type="text" class="wt_80" /> <font color="red">*</font></td>
                            <td class="label_cell"><label>LDAP主机：</label></td>
                            <td><input type="text" name="ldapHost" id="ldapHost" value="${ldModel.ldapHost}" class="wt_80" /> <font color="red">*</font></td>
                            <td class="label_cell"><label>LDAP端口：</label></td>
                            <td><input type="text" onkeyup="javascript:{this.value=this.value.replace(/\D/g,''); if(this.value>65535){this.value=65535;showFailure('端口范围:0~65535.'); }}" title="端口范围:0~65535." name="ldapPort" id="ldapPort" value="${ldModel.ldapPort}" class="wt_80" /> <font color="red">*</font></td>
                        </tr>
                        <tr>
                            <td class="label_cell"><label>LDAP根DN：</label></td>
                            <td><input type="text" name="ldapRootDN" id="ldapRootDN" value="${ldModel.ldapRootDN}" class="wt_80" /> <font color="red">*</font></td>
                            <td class="label_cell"><label>根DN密码：</label></td>
                            <td>
                                <input type="hidden" id="ldapKey" value="${ldapKey}"/>
                                <input type="password" autocomplete="off" name="ldapRootDNPassword" id="ldapRootDNPassword" value="${ldModel.ldapRootDNPassword}" class="wt_80" /> <font color="red">*</font>
                            </td>
                            <td class="label_cell"><label>搜索用户基DN：</label></td>
                            <td><input type="text" id="ldapsSearchBaseDN" name="ldapsSearchBaseDN" value="${ldModel.ldapsSearchBaseDN}" class="wt_80" /> <font color="red">*</font></td>
                        </tr>
                        <tr>
                            <td class="label_cell"><label>搜索组基DN：</label></td>
                            <td><input type="text" name="ldapGroupBaseDN" id="ldapGroupBaseDN" value="${ldModel.ldapGroupBaseDN}" class="wt_80" /> <font color="red">*</font></td>
                            <td class="label_cell"><label>用户名字段名：</label></td>
                            <td><input type="text" name="ldapUserFieldName" id="ldapUserFieldName" value="${ldModel.ldapUserFieldName}" class="wt_80" /> <font color="red">*</font></td>
                            <td class="label_cell"><label>密码字段名：</label></td>
                            <td><input type="text" name="ldapPasswordFieldName" id="ldapPasswordFieldName" value="${ldModel.ldapPasswordFieldName}" class="wt_80" />
                            <font color="red">*</font></td>
                        </tr>
                        <tr>
                            <td class="label_cell"><label>组中用户成员字段名：</label></td>
                            <td><input type="text" name="ldapMemberFieldName"  id="ldapMemberFieldName" value="${ldModel.ldapMemberFieldName}" class="wt_80" />  <font color="red">*</font></td>
                            <td colspan="3"></td>
                            <td align="right"><input id="ldap_realm_button"  type="submit" value="保存" /></td>
                        </tr>
                    </table>
                </form>
                </div>
                <div class="realm-text-list">
                    <div id="realm-ldap-buttonbar"></div>
                    <table id="realm-ldap-grid"></table>
                </div>
            </div>
            <div id="self" class="panel-div">
                <div class="realm_form_container">
                <table class="form_tbl">
                    <tr>
                        <td width="160"><label>安全域名称：</label></td>
                        <td><input id="self_realm_name" type="text" class="wt_200" /> <font color="red">*</font></td>
                        <td width="160"><label>身份验证提供程序的全类名：</label></td>
                        <td><input id="self_realm_authenticationProvider" type="text" class="wt_200" /> <font color="red">*</font></td>
                    </tr>
                    <tr>
                        <td><label>授权提供程序的全类名：</label></td>
                        <td><input id="self_realm_authorizationProvider" type="text" class="wt_200" /> <font color="red">*</font></td>
                        <td colspan="2" align="right"><input id="self_realm_button" type="button" value="保存" /></td>
                    </tr>
                </table>
                </div>
                <div class="realm-text-list">
                    <div id="realm-self-buttonbar"></div>
                    <table id="realm-self-grid"></table>
                </div>
            </div>
            <div id="text" class="panel-div">
                <div class="realm_form_container">
                <table class="form_tbl">
                    <tr>
                        <td width="120"><label>安全域名称：</label></td>
                        <td><input id="text_realm_name" type="text" class="wt_200" /> <font color="red">*</font></td>
                        <td colspan="2" align="right"><input id="text_realm_button" type="button" value="保存" /></td>
                    </tr>
                </table>
                </div>
                <div class="realm-text-list">
                    <div id="realm-text-buttonbar"></div>
                    <table id="realm-text-grid"></table>
                </div>
            </div>
        </div>
        </div>
    </div>
</div>
</div>
</div>
</body>

</html>
