﻿<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>UserGroup Page</title>
<c:set var="resBase" value="${pageContext.request.contextPath}/res" />
<script type="text/javascript" src="${resBase}/scripts/jquery.min.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-ui.js"></script>
<script type="text/javascript" src="${resBase}/scripts/om-rules.js"></script>
<script type="text/javascript" src="${resBase}/scripts/common.js"></script>
<script type="text/javascript" src="${resBase}/scripts/form.js"></script>

<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/om-ui/om-apusic.css" />
<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/common.css" />
<link class="x-skin" rel="stylesheet" type="text/css"
	href="${resBase}/css/main.css" />
<style type="text/css">
.om-buttonbar {
	border-bottom: none;
} 
</style>
</head>
<body>
	<div style="padding: 8px; height: 610px; overflow: hidden;">
		<div class="title-bk">用户管理</div>
		<div id="userBtnbar"></div>
		<div id="body" style="width: 100%;">
			<table id="userGrid"></table>
		</div>

		<div id="header" style="margin-top:15px;">
			<div class="title-bk">组管理</div>
			<div id="groupBtnbar"></div>
		</div>
		<div id="body" style="width: 100%; ">
			<table id="groupGrid"></table>
		</div>
		<div id="dialog-confirm" title="确认" style="display: none;"> 确定要删除？</div>
	</div>
<input name="passwordLength" id="passwordLength" type="hidden" value="${passwordLength}" readonly="readonly" />
<input name="passwordStrength" id="passwordStrength" type="hidden" value="${passwordStrength}" readonly="readonly" />
</body>
<script type="text/javascript">
	var usergroupBaseUrl = "${pageContext.request.contextPath}/protect/security/usergroup";
	$(document).ready(function() {
		$('#userBtnbar').omButtonbar({
	         	width : '100%',
	         	btns : [{label:"新增",
	         		     id:"addUser" ,
	         		     icons : {left : '${resBase}/images/add.png'}
	         			},
	            	    {label:"刷新",
	            			 id:"refreshUsers",
	            			 icons : {left : '${resBase}/images/refresh.png'}
	            	    }
	         		]
	       });
		
		$('#groupBtnbar').omButtonbar({
         	width : '100%',
         	btns : [{label:"新增",
         		     id:"addGroup" ,
         		     icons : {left : '${resBase}/images/add.png'}
         			},
            	    {label:"刷新",
            			 id:"refreshGroups",
            			 icons : {left : '${resBase}/images/refresh.png'}
            	    }
         		]
       });
		
		
		$('#userGrid').omGrid({
			limit : 0,
			width : 'fit',
			height : 240,
			autoFit : true,
			showIndex : true,
			colModel : [{
				header : '用户名',
				name : 'userName',
				width : 150,
				align : 'left',
				sort : 'clientSide'
			},{
				header : '所属组',
				name : 'groups',
				width : 150,
				align : 'left'
			},{
				header : '操作',
				name : 'xxx',
				width : 80,
				align : 'center',
				renderer : function(colValue,rowData,rowIndex) {
					var result = "<a href='#' onclick=\"toModifyUser('" + rowData.userName + "')\" title='编辑用户'><img style='border:0'  src='${resBase}/images/setting.png'></a>";
					result = result+  "&nbsp;&nbsp; <a href='#' onclick=\"delUserConfirm('" + rowData.userName + "')\" title='删除用户'><img style='border:0'  src='${resBase}/images/delete.png'></a>";
					return result;
				}
			} ],
			dataSource : usergroupBaseUrl+"/listUsers"
		 });
		
		$('#groupGrid').omGrid({
			limit : 0,
			width : 'fit',
			height : 240,
			autoFit : true,
			showIndex : true,
			colModel : [{
				header : '组名',
				name : 'group',
				width : 150,
				align : 'left',
				sort : 'clientSide'
			},{
				header : '组用户',
				name : 'users',
				width : 150,
				align : 'left'
			},{
				header : '操作',
				name : 'xxx',
				width : 80,
				align : 'center',
				renderer : function(colValue,rowData,rowIndex) {
					
					var result ="<a href='#' onclick=\"toModifyGroup('" + rowData.group + "')\" title='编辑组'><img style='border:0'  src='${resBase}/images/setting.png'></a>";
					result = result+ "&nbsp;&nbsp; <a href='#' onclick=\"delGroupConfirm('" + rowData.group + "')\" title='删除组'><img style='border:0'  src='${resBase}/images/delete.png'></a>";
					return result;
				}
			} ],
			dataSource : usergroupBaseUrl+"/listGroups"
		 });
		
		$("#refreshUsers").click(function() {
			$('#userGrid').omGrid("reload");
		});
		
		$("#refreshGroups").click(function() {
			$('#groupGrid').omGrid("reload");
		});
		
		
		//add user
		$("#addUser").click(function() {
			var url = usergroupBaseUrl+"/toAddUser";
			$.ajax({
				url : url,
				success : function(data) {
					var d = $("<div style='display:none;' />").appendTo($(document.body));
					d.html(data).omDialog({
						autoOpen : true,
						closeOnEscape : false,
						height : 400,
						width : 400,
						modal : true,
						title : '添加用户',
						onOpen:function(){
							addUserHandler_Init();
	                    },
						onClose : function() {
							d.omDialog('destroy');
							d.remove();
						},
						buttons : [ {
							text : "保存",
							click : function() {
								addUser(d);
							}
						}, {
							text : "取消",
							click : function() {
								d.omDialog('destroy');
								d.remove();
							}
						} ]
					});
				}
			});
		});
		
		//add Group 
		$("#addGroup").click(function() {
			var url = usergroupBaseUrl+"/toAddGroup";
			$.ajax({
				url : url,
				success : function(data) {
					var d = $("<div style='display:none' />").appendTo($(document.body));
					d.html(data).omDialog({
						autoOpen : true,
						closeOnEscape : false,
						height : 400,
						width : 400,
						modal : true,
						title : '新增组',
						onOpen:function(){
							addGroupHandler_Init();
	                    },
						onClose : function() {
							d.omDialog('destroy');
							d.remove();
						},
						buttons : [ {
							text : "保存",
							click : function() {
								addGroup(d);
							}
						}, {
							text : "取消",
							click : function() {
								d.omDialog('destroy');
								d.remove();
							}
						} ]

					});
					}
				});	
		});
		
	});
	
	function addUserHandler_Init(){
		$('#groupGridView').omGrid({
			limit : 0,
			width : 250,
			height : 200,
			autoFit : true,
			showIndex : false,
			singleSelect : false,
			colModel : [{
				header : '组名',
				name : 'group',
				width : 150,
				align : 'left'
			} ],
			dataSource : usergroupBaseUrl+"/listGroups"
		 });
		// init validateUserParams
		
		validateAddUserParams();
	}
	
	function addUser(d){
		var  validataRes = $("#user_params_form").validate().form();
		if (!validataRes) {
			return false;
		} else {
			var userName =$("#userName").val();
	   		var password = $("#password").val();
	   		var repassword = $("#repassword").val();
	   		if(!checkComplex($("#password").val())) {
				return false;
			}
	   		var selecteds = $('#groupGridView').omGrid("getSelections", true);
	   		var groups = "";
	   		if (selecteds.length>0) {
	   			$(selecteds).each(function(index, item) {
	   				groups += item.group + ",";
	       		});
	       		if (groups.length > 0) {
	       			groups = groups.substring(0, groups.length - 1);
	       		}
	   		}
	   		$.ajax({
	   				type : "post",
	   				async:false,
	   				dataType : "json",
	   				url : usergroupBaseUrl+"/addUser",
	   				data : {
	   					userName : userName,password:password,repassword:repassword,groupNames:groups
	   				},
	   				error: function(){
	   					showErrorTip("新增失败:提交参数错误!");
	   				},
	   				success : function(data) {
	   					if(data.state=="success"){
	   						$('#userGrid').omGrid("reload");
	   						$('#groupGrid').omGrid("reload");
	   					}
	   					showMsgTip(data.desc,data.state);
	   					d.omDialog('destroy');
						d.remove();
	   				}
	   			});
			}
   	}
	

	// modify user
	function toModifyUser(value) {
		var url = usergroupBaseUrl+"/toModifyUser";
		$.ajax({
			url : url,
			data:{userName:value},
			success : function(data) {
				var d = $("<div style='display:none' />").appendTo($(document.body));
				d.html(data).omDialog({
					autoOpen : true,
					closeOnEscape : false,
					height : 400,
					width : 400,
					modal : true,
					title : '修改用户',
					onOpen:function(){
						modifyUserHandler_Init();
                    },
					onClose : function() {
						d.omDialog('destroy');
						d.remove();
					},
					buttons : [ {
						text : "保存",
						click : function() {
							saveUser(d);
						}
					}, {
						text : "取消",
						click : function() {
							d.omDialog('destroy');
							d.remove();
						}
					} ]

				});
			}
		});	
	}
	
	function modifyUserHandler_Init(){
		$('#groupGridView').omGrid({
			limit : 0,
			width : 250,
			height : 200,
			autoFit : true,
			showIndex : false,
			singleSelect : false,
			onRefresh:function(nowPage,pageRecords,event){
		         var rows=[];
		         $(pageRecords).each(function(i){
		        	 if(selectedGroups.indexOf(this.group)!=-1){
		                 rows.push(i);
		             }
		         });
		         $('#groupGridView').omGrid('setSelections',rows);
		     },
			colModel : [{
				header : '组名',
				name : 'group',
				width : 150,
				align : 'left'
			} ],
			dataSource : "${pageContext.request.contextPath}/protect/security/usergroup/listGroups"
		 });
		
    	$("#changepwd").change(function(){
    		  if($(this).attr("checked")){
    			 $("#pwdToggle").css("display","block").find("input").attr("disabled",false);
    		  }else{
    			  $("#pwdToggle").css("display","none").find("input").attr("disabled",true);
    		  }
    	});
    	// init  validateUserParams();
    	validateModifyUserParams();
	}
	
	function saveUser(d){
		var  validataRes = $("#user_params_form").validate().form();
		if (!validataRes) {
			return false;
		} else {
			var userName =$("#userName").val();
			var password ="";
	  		var newpassword = "";
	  		var renewpassword = "";
	  	    if($("#changepwd").attr("checked")){
	  	    	password =  $("#password").val();
	  	    	if(!checkComplex($("#newpassword").val())){
	  	    		return false;
	  	    	}
	  	    	newpassword= $("#newpassword").val();
	  	    	renewpassword= $("#renewpassword").val();
	  	    }
	  		var selecteds = $('#groupGridView').omGrid("getSelections", true);
	  		var groups = "";
	  		if (selecteds.length>0) {
	  			$(selecteds).each(function(index, item) {
	  				groups += item.group + ",";
	      		});
	      		if (groups.length > 0) {
	      			groups = groups.substring(0, groups.length - 1);
	      		}
	  		}
	  		var changepwd = false;
	  		if($("#changepwd").attr("checked")){
	  			changepwd = true ;
	  		}
	  		$.ajax({
	  				type : "post",
	  				async:false,
	  				dataType : "json",
	  				url : usergroupBaseUrl+"/modifyUser",
	  				data : {
	  					userName : userName,changepwd:changepwd,password:password,newpassword:newpassword,renewpassword:renewpassword,groupNames:groups
	  				},
	  				error: function(){
	  					showErrorTip("更新失败！");
	  				},
	  				success : function(data) {
	  					if(data.state=="success"){
	   						$('#userGrid').omGrid("reload");
	   						$('#groupGrid').omGrid("reload");
	   					}
	   					showMsgTip(data.desc,data.state);
	   					d.omDialog('destroy');
						d.remove();
	  				}
	  		});
		}
  	}
	
	function checkComplex(passwd) {
		var count = 0;
		if(/.*[a-z]+.*/.test(passwd))
		   count++;
		if(/.*[A-Z]+.*/.test(passwd))
		   count++;
		if(/.*[0-9]+.*/.test(passwd))
		   count++;
		if(/.*[^a-zA-Z0-9]+.*/.test(passwd))
		   count++;
		var complex = $('#passwordStrength').val();
		if(complex=='STRONG' && count < 3) {	
			showErrorTip("输入密码复杂度不符合要求，复杂度要求为大小写字母、数字和特殊字符中的3种组合");
		   //$('#errorMsgID').html("输入密码复杂度不符合要求，复杂度要求为强");
		   return false;
		 }
		 return true;
	}

	/* confirm dele */
	function delUserConfirm(userName) {
		$("#dialog-confirm").text("确认要删除用户："+userName+" ？");
	    $( "#dialog-confirm" ).omDialog({
	        autoOpen : false, 
	        resizable: false,
	        height:140,
	        modal: false,
	        buttons: [{
	            text : "确认", 
	            click : function () {
	                $("#dialog-confirm" ).omDialog("close");
	                delUser(userName);
	            }
	        }, {
	            text : "取消", 
	            click : function () {
	                $("#dialog-confirm" ).omDialog("close");
	            }
	        }]
	    });
	
	    $( "#dialog-confirm" ).omDialog("open");
	}
	
	//delete user
	function delUser(userName) {
		$.ajax({
				type : "post",
				async:false,
				dataType : "json",
				url : usergroupBaseUrl+"/delUser",
				data : {
					userName : userName
				},
				error: function(){
					showErrorTip("更新失败!");
				},
				success : function(data) {
					if(data.state=="success"){
   						$('#userGrid').omGrid("reload");
   						$('#groupGrid').omGrid("reload");
   					}
   					showMsgTip(data.desc,data.state);
				}
			});
	}
	
	// modify Group 
	function toModifyGroup(group) {
		$.ajax({
			url : usergroupBaseUrl+"/toModifyGroup",
			data:{group:group},
			success : function(data) {
				var d = $("<div style='display:none' />").appendTo($(document.body));
				d.html(data).omDialog({
					autoOpen : true,
					closeOnEscape : false,
					height : 400,
					width : 400,
					modal : true,
					title : '修改组',
					onOpen:function(){
						modifyGroupHandler_Init();
                    },
					onClose : function() {
						d.omDialog('destroy');
						d.remove();
					},
					buttons : [ {
						text : "保存",
						click : function() {
							saveGroup(d);
						}
					}, {
						text : "取消",
						click : function() {
							d.omDialog('destroy');
							d.remove();
						}
					} ]
				});
			}
		});
	}
	
	function modifyGroupHandler_Init(){
		// 放在子页面来初始化
		//var selectedUserNames  = "${selectedUserNames}";
		$('#userGridView').omGrid({
				limit : 0,
				width : 250,
				height : 200,
				autoFit : true,
				showIndex : false,
				singleSelect : false,
				onRefresh:function(nowPage,pageRecords,event){
			         var rows=[];
			         $(pageRecords).each(function(i){
			        	 if(selectedUserNames.indexOf(this.userName)!=-1){
			                 rows.push(i);
			             }
			         });
			         $('#userGridView').omGrid('setSelections',rows);
			     },
				colModel : [ {
				header : '用户名',
				name : 'userName',
				width : 150,
				align : 'left'
			} ],
			dataSource : usergroupBaseUrl+"/listUsers"
		});
		
		//init validateGroupParams
		validateGroupParams();
	}
	
	function saveGroup(d) {
		var  validataRes = $("#group_params_form").validate().form();
		if (!validataRes) {
			return false;
		} else {
			var groupName = $("#group").val();
			var selecteds = $('#userGridView').omGrid("getSelections", true);
			var users = "";
			if (selecteds.length > 0) {
				$(selecteds).each(function(index, item) {
					users = users + (item.userName + ",");
				});
				if (users.length > 0) {
					users = users.substring(0, users.length - 1);
				}
			}
			$.ajax({
				type : "post",
				async : false,
				dataType : "json",
				url : usergroupBaseUrl+"/modifyGroup",
				data : {
					group : groupName,
					userNames : users
				},
				error : function() {
					showErrorTip("操作失败:你提交参数错误!");
				},
				success : function(data) {
					if(data.state=="success"){
						$('#userGrid').omGrid("reload");
						$('#groupGrid').omGrid("reload");
					}
					showMsgTip(data.desc,data.state);
					d.omDialog('destroy');
					d.remove();
				}
			});
		}
	}
	
	function addGroupHandler_Init(){
		// init userGridView
		$('#userGridView').omGrid({
			limit : 0,
			width : 250,
			height : 200,
			autoFit : true,
			showIndex : false,
			singleSelect : false,
			colModel : [{
				header : '用户名',
				name : 'userName',
				width : 150,
				align : 'left'
			} ],
			dataSource : usergroupBaseUrl+"/listUsers"
		 });
		//init validateGroupParams
		validateGroupParams();
	}
	
	 function addGroup(d){
		var  validataRes = $("#group_params_form").validate().form();
		if (!validataRes) {
			return false;
		} else {
			var groupName =$("#group").val();
	   		var selecteds = $('#userGridView').omGrid("getSelections", true);
	   		var users = "";
	   		if (selecteds.length>0) {
	   			$(selecteds).each(function(index, item) {
	   				users += item.userName + ",";
	       		});
	       		if (users.length > 0) {
	       			users = users.substring(0, users.length - 1);
	       		}
	   		}
	   		$.ajax({
	   				type : "post",
	   				async:false,
	   				dataType : "json",
	   				url :  usergroupBaseUrl+"/addGroup",
	   				data : {
	   					group:groupName,userNames:users
	   				},
	   				error: function(){
	   					showErrorTip("操作失败:你提交参数错误!");
	   				},
	   				success : function(data) {
	   					if(data.state=="success"){
	   						$('#userGrid').omGrid("reload");
	   						$('#groupGrid').omGrid("reload");
						}
						showMsgTip(data.desc,data.state);
						d.omDialog('destroy');
						d.remove();
	   				}
	   		});
		}
   	}

	/* confirm dele */
	function delGroupConfirm(group) {
		$("#dialog-confirm").text("确认要删除用户组："+group+" ？");
	    $( "#dialog-confirm" ).omDialog({
	        autoOpen : false, 
	        resizable: false,
	        height:140,
	        modal: false,
	        buttons: [{
	            text : "确认", 
	            click : function () {
	                $("#dialog-confirm" ).omDialog("close");
	                delGroup(group);
	            }
	        }, {
	            text : "取消", 
	            click : function () {
	                $("#dialog-confirm" ).omDialog("close");
	            }
	        }]
	    });
	
	    $( "#dialog-confirm" ).omDialog("open");
	}
		
	 // delete Group
	function delGroup(group) {
		$.ajax({
			type : "post",
			async:false,
			dataType : "json",
			url : usergroupBaseUrl+"/delGroup",
			data : {
				group : group
			},
			error: function(){
				showErrorTip("操作失败:你提交参数错误!");
			},
			success : function(data) {
				if(data.state=="success"){
					$('#userGrid').omGrid("reload");
					$('#groupGrid').omGrid("reload");
				}
				showMsgTip(data.desc,data.state);
			}
		});
	}
	 
	function validateGroupParams(){
		$('#group_params_form').validate({
		    validateOnEmpty : true,
		    rules : {
		    	group : {
		            required : true
		        }
		    },
		    messages : {
		    	group : {
		            required : '组名称不能为空!'
		        }
		    },
		    showErrors: function(errorMap, errorList) {
		        var next = $(this.currentElements).next();
		        while(next.hasClass('errorMsg')) {
		            next.remove();
		            next = $(this.currentElements).next();
		        }
		        $(this.currentElements).removeClass('error');
		        $(this.currentElements).unbind('mouseover').unbind('mouseout');
		        if(errorList && errorList.length > 0){
		            $.each(errorList, function(index, obj){
		                $(obj.element).addClass('error');
		                var msg = this.message;
		                var em = $('<span class="errorMsg">{0}</span>'.format(msg));
		                $(obj.element).after(em);
		                $(obj.element).mouseover(function() {
		                    em.show();
		                }).mouseout(function() {
		                    em.hide();
		                });
		            });
		        }
		    }
		});
	}
	 
	
	function validateModifyUserParams(){
		$('#user_params_form').validate({
		    validateOnEmpty : true,
		    rules : {
		    	userName : {
		            required : true
		        },
		        password : {
		            required : true
		        },
		        newpassword : {
		            required : true,
		            minlength : $('#passwordLength').val(),
		            maxlength : 256,
                    isNotContainsBlank: true
		        },
		        renewpassword : {
		            required : true,
		            minlength : $('#passwordLength').val(),
		            maxlength : 256,
		            equalTo:'#newpassword'
		        }
		    },
		    messages : {
		    	userName : {
		            required : '用户名不能为空!'
		        },
		  		password : {
		            required : '密码不能为空!',
		        },
		        newpassword : {
		            required : '新密码不能为空!',
		            minlength :$.validator.format("新密码长度不能小于{0}."),
		            maxlength :$.validator.format("新密码长度不能大于{0}."),
                    isNotContainsBlank: "密码不能包含空格"
		        },
		        renewpassword : {
		            required : '确认密码不能为空!',
		            minlength :$.validator.format("确认密码长度不能小于{0}."),
		            maxlength :$.validator.format("确认密码长度不能大于{0}."),
		            equalTo:'两次输入不一致！'
		        }
		    },
		    showErrors: function(errorMap, errorList) {
		        var next = $(this.currentElements).next();
		        while(next.hasClass('errorMsg')) {
		            next.remove();
		            next = $(this.currentElements).next();
		        }
		        $(this.currentElements).removeClass('error');
		        $(this.currentElements).unbind('mouseover').unbind('mouseout');
		        if(errorList && errorList.length > 0){
		            $.each(errorList, function(index, obj){
		                $(obj.element).addClass('error');
		                var msg = this.message;
		                var em = $('<span class="errorMsg">{0}</span>'.format(msg));
		                $(obj.element).after(em);
		                $(obj.element).mouseover(function() {
		                    em.show();
		                }).mouseout(function() {
		                    em.hide();
		                });
		            });
		        }
		    }
		});
	}
	function validateAddUserParams(){
		$('#user_params_form').validate({
		    validateOnEmpty : true,
		    rules : {
		    	userName : {
		            required : true,
		            minlength : 2,
		            maxlength : 15
		        },
		        password : {
		            required : true,
                    isNotContainsBlank: true,
		            minlength : $('#passwordLength').val(),
		            maxlength : 256
		        },
		        repassword : {
		            required : true,
		            minlength : $('#passwordLength').val(),
		            maxlength : 256,
		            equalTo:'#password'
		        }
		    },
		    messages : {
		    	userName : {
		            required : '用户名不能为空!',
		            minlength : $.validator.format("用户名长度不能小于{0}."),
		            maxlength : $.validator.format("用户名长度不能大于{0}."),
		        },
		  		password : {
		            required : '密码不能为空!',
		            minlength :$.validator.format("密码长度不能小于{0}."),
		            maxlength :$.validator.format("密码长度不能大于{0}."),
                    isNotContainsBlank: "密码不能包含空格"
		        },
		        repassword : {
		            required : '确认密码不能为空!',
		            minlength :$.validator.format("确认密码长度不能小于{0}."),
		            maxlength :$.validator.format("确认密码长度不能大于{0}."),
		            equalTo:'两次输入不一致！'
		        }
		    },
		    showErrors: function(errorMap, errorList) {
		        var next = $(this.currentElements).next();
		        while(next.hasClass('errorMsg')) {
		            next.remove();
		            next = $(this.currentElements).next();
		        }
		        $(this.currentElements).removeClass('error');
		        $(this.currentElements).unbind('mouseover').unbind('mouseout');
		        if(errorList && errorList.length > 0){
		            $.each(errorList, function(index, obj){
		                $(obj.element).addClass('error');
		                var msg = this.message;
		                var em = $('<span class="errorMsg">{0}</span>'.format(msg));
		                $(obj.element).after(em);
		                $(obj.element).mouseover(function() {
		                    em.show();
		                }).mouseout(function() {
		                    em.hide();
		                });
		            });
		        }
		    }
		});
	}
	
	 // tips msg 
	function showMsgTip(msg,type) {     
	    $.omMessageTip.show({
	        type : type,
	        title : '提示信息',
	        content : msg,
	        timeout : 3000
	    });
	}

	function showErrorTip(msg) {
		$.omMessageTip.show({
			type : 'error',
			title : '失败',
			content : msg,
			timeout : 3000
		});
	}

	function showSelectAlert() {
		$.omMessageBox.alert({
			title : '提示',
			content : '请选择记录！'
		});
	}
</script>
</html>