/**
 * AAS核心JS，依赖jQuery、underscore两个类库
 * 定了aas对象以及aas.utils和aas.Core对象
 * 
 */
;
(function(root, $, _) {
    var aas = root.aas = {};
    var utils = aas.utils = {};

    utils.extend = function(protoProps, staticProps) {
        var parent = this;
        var child;

        // The constructor function for the new subclass is either defined by
        // you
        // (the "constructor" property in your `extend` definition), or
        // defaulted
        // by us to simply call the parent's constructor.
        if (protoProps && _.has(protoProps, 'constructor')) {
            child = protoProps.constructor;
        } else {
            child = function() {
                return parent.apply(this, arguments);
            };
        }

        // Add static properties to the constructor function, if supplied.
        _.extend(child, parent, staticProps);

        // Set the prototype chain to inherit from `parent`, without calling
        // `parent`'s constructor function.
        var Surrogate = function() {
            this.constructor = child;
        };
        Surrogate.prototype = parent.prototype;
        child.prototype = new Surrogate;

        // Add prototype properties (instance properties) to the subclass,
        // if supplied.
        if (protoProps)
            _.extend(child.prototype, protoProps);

        // Set a convenience property in case the parent's prototype is needed
        // later.
        child.__super__ = parent.prototype;

        return child;
    };
    
    utils.info = function(content) {
        $.omMessageTip.show({
            content : content,
            timeout : 2000
        });
    };
    
    utils.error = function(content) {
        $.omMessageTip.show({
            content : content,
            type : 'error',
            title : '错误'
        });
    };
    
    aas.initContext = function(context) {
        aas.contextPath = context;
    };
    
    var Core = aas.Core = function(setting) {
        this.initialize(setting);
    };

    Core.extend = utils.extend;

    Core.prototype = {
        initialize : {},
        getContextPath : function() {
            return aas.contextPath;
        }
    };
})(this, jQuery, _);