;
(function($, $m) {
    $m.appMgmt = {
        baseUrl : '',
        deployInClient : true,

        viewModules : function(name) {
            $.ajax({
                url : this.baseUrl + '/viewModules',
                data : {
                    name : name
                },
                success : function(data) {
                    var d = $('<div />').appendTo($(document.body));
                    d.html(data).omDialog({
                        autoOpen : true,
                        height : 400,
                        width : 500,
                        modal : true,
                        title : '查看应用模块',
                        onClose : function() {
                            d.omDialog('destroy');
                            d.remove();
                        },
                        onOpen : function(event) {
                        	resizeWin(d,400);
                        }
                    });
                }
            });
        },

        viewApusicApplicationXML : function(name) {
            $.ajax({
                url : this.baseUrl + '/viewApusicApplicationXML',
                data : {
                    name : name
                },
                success : function(data) {
                    var d = $('<div />').appendTo($(document.body));
                    $('<pre class="brush: xml"></pre>').appendTo(d).text(data);
                    d.omDialog({
                        autoOpen : true,
                        height : 400,
                        width : 500,
                        modal : true,
                        title : '查看apusic-application.xml',
                        onClose : function() {
                            d.omDialog('destroy');
                            d.remove();
                        },
                        onOpen : function(event) {
                        	resizeWin(d,400);
                        }
                    });
                }
            });
        },

        viewWebXML : function(name) {
            $.ajax({
                url : this.baseUrl + '/viewWebXML',
                data : {
                    name : name
                },
                success : function(data) {
                    var d = $('<div />').appendTo($(document.body));
                    $('<pre class="brush: xml"></pre>').appendTo(d).text(data);
                    d.omDialog({
                        autoOpen : true,
                        height : 400,
                        width : 600,
                        modal : true,
                        title : '查看J2EE标准控制文件',
                        onClose : function() {
                            d.omDialog('destroy');
                            d.remove();
                        },
                        onOpen : function(event) {
                        	resizeWin(d,400);
                        }
                    });
                }
            });
        },

        monitor : function(name) {
            $.ajax({
                url : this.baseUrl + '/monitor',
                data : {
                    name : name
                },
                success : function(data) {
                    var d = $('<div />').appendTo($(document.body));
                    var timmer = self.setInterval(function() {
                        $('#jsp_component').omGrid('reload');
                        $('#servlet_component').omGrid('reload');
                        $('#ejb_component').omGrid('reload');
                    }, 5000);
                    d.html(data).omDialog({
                        autoOpen : true,
                        height : 500,
                        width : 700,
                        modal : true,
                        title : 'J2EE监控',
                        onClose : function() {
                            d.omDialog('destroy');
                            d.remove();
                            clearInterval(timmer);
                        },
                        onOpen : function(event) {
                        	resizeWin(d,500);
                        }
                    });
                }
            });
        },
        
        //应用配置
      config:function(){
        	  if ($('#app_deploy_param_form').valid()) {
        		  var submit = true;
        		  var loadon = $('#loadon').val();
	   			  if (loadon.trim().length != 0) {
	   				if(isNaN(loadon)){
	   				    submit = false;
	   				    $m.markFldError($('#loadon'), '加载顺序必须是数字!');
	   				}
	   			  }
                  var arg = /^((\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.){1,3}\*$|((\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.){3}((\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$|((\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\-(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])))$/;
                  var $allowHosts = ($("#allowHosts").val()).replace(/^\s+|\s+$/g,"");
                  var $denyHosts = ($("#denyHosts").val()).replace(/^\s+|\s+$/g,"");
                  $("#allowHosts").val($allowHosts);
                  $("#denyHosts").val($denyHosts);
                  var tags1 = new Array();
                  var tags2 = new Array();
                  if(submit && $allowHosts != ''){
                  	tags1 = $allowHosts.split(',');
                  	for(var i=0;i<tags1.length;i++){
                  		if (tags1[i].match(arg) == null) {
                  			submit = false;
                  			$m.markFldError($("#allowHosts"), '允许访问IP列表格式不正确！');
                          }
                  	}
                  }
                  if(submit && $denyHosts != ''){
                  	tags2 = $denyHosts.split(',');
                  	for(var j=0;j<tags2.length;j++){
                  		if (tags2[j].match(arg) == null) {
                  			 submit = false;
                  			 $m.markFldError($("#denyHosts"), '禁止访问IP列表格式不正确！');
                          }
                  	}
                  }

                  if(submit) {
                      $('#app_deploy_param_form').submit();
                  }
        	  }
        	    
        	 $m.addFormValidator('#app_deploy_param_form', {
                    rules : {
                        loadon : {
                            digits : true
                        }
                    },
                    messages : {
                        loadon : {
                            digits : '加载顺序只能输入数字'
                        }
                    }
                });
        },

        
        //选择文件
        chooseFile:function(){
        	new aas.utils.ServerFileSelector({
    	        allowFolder : true,
    	        suffix : '.jar;.war;.ear;.rar',
    	        callback : function(data) {
    	            $('#archivePathFld').val(data);
    	        }
    	    });
        },
        
        //初始化页面
        pageInit:function(){
        	$('#page').omBorderLayout({
    			panels : [ {
    				id : "north-panel",
    				region : "north",
    				header : false
    			}, {
    				id : "center-panel",
    				header : false,
    				region : "center"
    			} ],
    			spacing : 2
    		});
        },
        
        //部署应用
        appDeploy:function(){
        	var _t = this;
        	 if ($('#app_deploy_form').valid()) {
                 var submit = true;
                
                var appName = '#appName';
				if ($(appName).val().trim().length == 0) {
					submit = false;
					$m.markFldError($(appName), '应用名不为空');
				}

				if (submit && /^.*[\*#\?;\:%\\&\,=\|<>].*$/.test($(appName).val().trim())) {
					submit = false;
					$m.markFldError($("#appName"), '应用名禁止含有特殊符号');
				}
				var cFld = _t.deployInClient ? '#clientFileFld'
						: '#archivePathFld';
				var uncField = _t.deployInClient ? '#archivePathFld'
						: '#clientFileFld';
                 
                 if($(cFld).val().trim().length == 0) {
                     submit = false;
                     $m.markFldError($(cFld), '必须选择应用！');
                     $m.clearFldError($(uncField));
                 } else {
                  //   submit = true;
                     $m.clearFldError($(cFld));
                     $m.clearFldError($(uncField));
                 }
                 
                var loadon = $('#loadon').val();
 				if (loadon.trim().length != 0) {
 					if(isNaN(loadon)){
 					    submit = false;
 					    $m.markFldError($('#loadon'), '加载顺序必须是数字!');
 					}
 				}

                 var arg = /^((\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.){1,3}\*$|((\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.){3}((\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$|((\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\-(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])))$/;
                 var $allowHosts = ($("#allowHosts").val()).replace(/^\s+|\s+$/g,"");
                 var $denyHosts = ($("#denyHosts").val()).replace(/^\s+|\s+$/g,"");
                 $("#allowHosts").val($allowHosts);
                 $("#denyHosts").val($denyHosts);
                 var tags1 = new Array();
                 var tags2 = new Array();
                 if(submit && $allowHosts != ''){
                 	tags1 = $allowHosts.split(',');
                 	for(var i=0;i<tags1.length;i++){
                 		if (tags1[i].match(arg) == null) {
                 			submit = false;
                 			$m.markFldError($("#allowHosts"), '允许访问IP列表格式不正确！');
                         }
                 	}
                 }
                 if(submit && $denyHosts != ''){
                 	tags2 = $denyHosts.split(',');
                 	for(var j=0;j<tags2.length;j++){
                 		if (tags2[j].match(arg) == null) {
                 			 submit = false;
                 			 $m.markFldError($("#denyHosts"), '禁止访问IP列表格式不正确！');
                         }
                 	}
                 }

                 if(submit) {
                     $('#app_deploy_form').submit();
                 }
             }	
        }
        
    };
    
    function resizeWin(d,size) {
    	//if (window.ActiveXObject || "ActiveXObject" in window || $.browser.mozilla) {
			var dialog = d.parent().parent().find(".om-dialog");
			dialog.css("top", ($(window).height()-size)/2+"px");
    	//}
    }
})(jQuery, AASMonitor);