;
(function($) {
	$.ajaxSetup({cache:false});
	/**
	 * 
	 * 添加字符串的format方法，用于格式化字符串。
	 * 
	 * 示例："a{0}b{0}c{1}".format('***', 123)的结果为：a***b***c123
	 * 
	 */
	String.prototype.format = function(args) {
		var str = this;
		if (arguments.length == 0) {
			return str;
		}
		for (var i = 0; i < arguments.length; i++) {
			var re = new RegExp('\\{' + i + '\\}', 'gm');
			str = str.replace(re, arguments[i]);
		}
		return str;
	};

	/**
	 * 
	 * 添加字符串的trim方法，用于去掉字符串开头和结尾的空格。
	 * 
	 * 示例：" a a bc ".trim()的结果为：a a bc
	 * 
	 */
	String.prototype.trim = function() {
		return this.replace(/(^\s*)|(\s*$)/g, "");
	};

	Function.prototype.createDelegate = function(context) {
		var _t = this;
		return function() {
			_t.apply(context, arguments);
		};
	};

	if (!window.AASMonitor) {
		window.AASMonitor = {
			_id : 1,

			id : function() {
				return this._id++;
			},

			mixin : function(target, source) {
				for (k in source) {
					target[k] = source[k];
				}
				return target;
			},

        	markFldError : function(el, msg) {
				this.clearFldError(el);
				if (msg) {
					$(el).addClass('error');
					var em = $('<span class="errorMsg">{0}</span>'.format(msg));
					$(el).after(em);
					$(el).mouseover(function() {
								em.show();
							}).mouseout(function() {
								em.hide();
							});
				}
			},

			clearFldError : function(el) {
				var next = $(el).next();
				while (next.hasClass('errorMsg')) {
					next.remove();
					next = $(el).next();
				}
				$(el).removeClass('error');
				$(el).unbind('mouseover').unbind('mouseout');
			},

			info : function(content) {
				$.omMessageTip.show({
							content : content,
							timeout : 2000
						});
			},

			warn : function(content) {
				$.omMessageTip.show({
							content : content,
							type : 'warn'
						});
			},

			error : function(content) {
				$.omMessageTip.show({
							content : content,
							type : 'error'
						});
			},
			HashMap : function() {
				var size = 0;
				var entry = new Object();
				this.put = function(key, value) {
					if (!this.containsKey(key)) {
						size++;
					}
					entry[key] = value;
				};
				this.get = function(key) {
					if (this.containsKey(key)) {
						return entry[key];
					} else {
						return null;
					}
				};
				this.remove = function(key) {
					if (delete entry[key]) {
						size--;
					}
				};
				this.containsKey = function(key) {
					return (key in entry);
				};
				this.containsValue = function(value) {
					for (var prop in entry) {
						if (entry[prop] == value) {
							return true;
						}
					}
					return false;
				};
				this.values = function() {
					var values = new Array(size);
					for (var prop in entry) {
						values.push(entry[prop]);
					}
					return values;
				};
				this.keys = function() {
					var keys = new Array(size);
					for (var prop in entry) {
						keys.push(prop);
					}
					return keys;
				};
				this.size = function() {
					return size;
				};
			}

		};
	}
})(jQuery);