function muxConfig_Init() {
	
    $('#asconfig_muxConfig_form').validate({
        validateOnEmpty : true,
        rules : {
            multiplexingPort : {
                required : true,
                isInteger : true,
                range:[0,56535]
            },
            overtimeLink : {
                isInteger : true
            },
             backlog : {
                isInteger : true
            },
            maxWaitingClient : {
                isInteger : true
            },
            waitingClientOvertime : {
                isInteger : true
            },
            readOvertimeAhead : {
                required : true,
                isInteger : true
            },
            singlePort : {
                isInteger : true,
                range:[0,56535]
            },
            doublePort : {
                isInteger : true,
                range:[0,56535]
            },
            checkCRLInterval : {
                isInteger : true
            }

        },
        messages : {
            multiplexingPort : {
                required : '值不能为空!',
                isInteger : '必须是整数!',
                range:"0-56535"
            },
            overtimeLink : {
                isInteger : '必须是整数!'
            },
            maxWaitingClient : {
                isInteger : '必须是整数!'
            },
            waitingClientOvertime : {
                isInteger : '必须是整数!'
            },
            readOvertimeAhead : {
                isInteger : '必须是整数!'
            },
            backlog : {
                isInteger : '必须是整数!'
            },
            singlePort : {
                isInteger : '必须是整数!',
                range:"0-56535"
            },
            doublePort : {
                isInteger : '必须是整数!',
                range:"0-56535"
            },
             checkCRLInterval : {
                isInteger : '必须是整数!'
            }
        },
        showErrors : function(errorMap, errorList) {
            var next = $(this.currentElements).next();
            while (next.hasClass('errorMsg')) {
                next.remove();
                next = $(this.currentElements).next();
            }
            $(this.currentElements).removeClass('error');
            $(this.currentElements).unbind('mouseover').unbind('mouseout');
            if (errorList && errorList.length > 0) {
                $.each(errorList, function(index, obj) {
                    $(obj.element).addClass('error');
                    var msg = this.message;
                    var em = $('<span class="errorMsg">{0}</span>'.format(msg));
                    $(obj.element).after(em);
                    $(obj.element).mouseover(function() {
                                em.show();
                            }).mouseout(function() {
                                em.hide();
                            });
                });
            }
        }
    }); 
	
	$('#asconfig_muxConfig_form').submit(function() {
                $(this).omAjaxSubmit(new muxOptions());
                return false;
            });
            
	 if($("#clientAuthentication").val()=="false"){
	 	$("#sslProtocol").attr("disabled", "disabled");
        $("#doublePort").attr("disabled", "disabled");
     	$("#reliableKeystorePath").attr("disabled", "disabled");
     	$("#reliableKeystoreType").attr("disabled", "disabled");
     	$("#reliableKeystoreAlgorithm").attr("disabled", "disabled");
     	$("#reliableKeystorePassword").attr("disabled", "disabled");
	 }
	
	 $('#clientAuthentication').omCombo({
	 	        width:140,
	 	        value:$("#clientAuthentication").val(),
	 	        editable:false,
                dataSource : [ {text : '双向认证', value : 'true'}, 
                               {text : '单向认证', value : 'false'}, 
                               {text : '根据需要', value : 'want'} ],
                 onValueChange : function(target, newValue, oldValue, event) {
                         if(newValue=="false"){
                         	$("#sslProtocol").attr("disabled", "disabled");
                         	$("#doublePort").attr("disabled", "disabled");
                        	$("#reliableKeystorePath").attr("disabled", "disabled");
                         	$("#reliableKeystoreType").attr("disabled", "disabled");
                         	$("#reliableKeystoreAlgorithm").attr("disabled", "disabled");
                         	$("#reliableKeystorePassword").attr("disabled", "disabled");
                         }else{
                         	$("#sslProtocol").removeAttr("disabled");
                            $("#doublePort").removeAttr("disabled");
                        	$("#reliableKeystorePath").removeAttr("disabled");
                         	$("#reliableKeystoreType").removeAttr("disabled");
                         	$("#reliableKeystoreAlgorithm").removeAttr("disabled");
                         	$("#reliableKeystorePassword").removeAttr("disabled");
                         }
               }
               
            });
            
            
             
         $('#openGzip').click(function(){
            if(!$(this).prop("checked")){
                $("#openGzip").removeAttr("checked");
                $("#openGzip").val("false");
            }else{
                $("#openGzip").attr("checked","checked");
                $("#openGzip").val("true");
            }
            
         });
         
             
               
         $('#tcpNODELAY').click(function(){
            if(!$(this).prop("checked")){
                $("#tcpNODELAY").removeAttr("checked");
                $("#tcpNODELAY").val("false");
            }else{
                $("#tcpNODELAY").attr("checked","checked");
                $("#tcpNODELAY").val("true");
            }
            
         });
         
            
         $('#openSSL').click(function(){
         	if(!$(this).prop("checked")){
         		$("#openSSL").removeAttr("checked");
         		$("#openSSL").val("false");
         		//$("#sslTable tr:gt(1)").children().children(":input").attr("readonly",true);
         		// var b = $("#sslTable tr:gt(1) td input");
         		$("#sslTable tr:gt(0) td input").attr("readonly",true);
         		$('#clientAuthentication').omCombo({readOnly:true});
         	}else{
         		$("#openSSL").attr("checked","checked");
                $("#openSSL").val("true");
                $("#sslTable tr:gt(0)").children().children(":input").attr("readonly",false);
                $('#clientAuthentication').omCombo({readOnly:false});
         	}
         	
         });
         
         	
         if(!$("#openSSL").prop("checked")){
         	$("#sslTable tr:gt(0) td input").attr("readonly",true);
            $('#clientAuthentication').omCombo({readOnly:true});
         };

}

function muxOptions(){
	this.dataType="json";
	this.success = function(data) {
            if (data == "success") {
               showMsgTip("配置多路复用成功！重启后生效！", "success");
            } else {
               showMsgTip(data, "error");
            }
        };
     this.error =function(){
     	 showMsgTip("配置多路复用失败！", "error");
     };
    
}
	
