function commonOptions(param) {
	this.param = param;
	this.dataType = "json";
}

commonOptions.prototype.success = function(data) {
	
	if (data.state == "success") {
		showMsgTip("配置"+this.param+"成功！重启后生效！", "success");
	} else {
		showMsgTip(data.msg, "error");
	}
};

commonOptions.prototype.error = function() {
	showMsgTip("配置"+this.param+"失败！", "error");
};

function restartClick(name, contextPath) {
	$.ajax({
				url : contextPath + '/protect/aasconfig/threadpool/restartPool',
				type : "get",
				dataType : "json",
				data : {
					poolName : name
				},
				complete : function() {
					changeServerState(contextPath,name);
				},
				success : function(data) {
					if (data.state == "success") {
						$("#" + name + "_state").html("<span style='color:green'>Running</span>");
						showMsgTip("重启"+name+"成功！", "success");
					} else {
						showMsgTip("重启"+name+"失败", "error");
					}
				},
				error : function() {
					showMsgTip("重启"+name+"失败", "error");
				}
			});
}

function startClick(name, contextPath) {
	$.ajax({
				url : contextPath + '/protect/aasconfig/threadpool/startPool',
				type : "get",
				dataType : "json",
				data : {
					poolName : name
				},
				complete : function() {
					changeServerState(contextPath,name);
				},
				success : function(data) {
					if (data.state == "success") {
						$("#" + name + "_state").html("<span style='color:green'>Running</span>");
						$("#" + name + "_stop").show();
						$("#" + name + "_start").hide();
						showMsgTip("启动"+name+"成功！", "success");
					} else {
						showMsgTip("启动"+name+"失败", "error");
					}
				},
				error : function() {
					showMsgTip("启动"+name+"失败", "error");
				}
			});
}

function stopClick(name, contextPath) {
	$.ajax({
				url : contextPath + '/protect/aasconfig/threadpool/stopPool',
				type : "get",
				dataType : "json",
				data : {
					poolName : name
				},
				complete : function() {
					changeServerState(contextPath,name);
				},
				success : function(data) {
					if (data.state  == "success") {
						$("#" + name + "_state").html("<span style='color:red'>Stopped</span>");
						$("#" + name + "_stop").hide();
						$("#" + name + "_start").show();
						showMsgTip("停止"+name+"成功！", "success");
					} else {
						showMsgTip("停止"+name+"失败", "error");
					}
				},
				error : function() {
					showMsgTip("停止"+name+"失败", "error");
				}
			});
}

function httpHandler_Init() {
	$('#asconfig_httpHandler_form').submit(function() {
				$(this).omAjaxSubmit(new commonOptions('HTTPHandler'));
				return false;
			});

	$('#asconfig_httpHandler_form').validate({
		validateOnEmpty : true,
		rules : {
			idleTimeout : {
				required : true,
				isInteger : true
			},
			maxQueueSize : {
				required : true,
				isInteger : true
			},
			maxThreads : {
				required : true,
				isInteger : true
			},
			maxSpareThreads : {
				required : true,
				isInteger : true
			},
			minSpareThreads : {
				required : true,
				isInteger : true
			},
			priority : {
				required : true,
				range : [1, 10]
			}

		},
		messages : {
			idleTimeout : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxQueueSize : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxSpareThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			minSpareThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			priority : {
				required : '值不能为空!',
				range : '范围是1-10!'
			}
		},
		showErrors : function(errorMap, errorList) {
			var next = $(this.currentElements).next();
			while (next.hasClass('errorMsg')) {
				next.remove();
				next = $(this.currentElements).next();
			}
			$(this.currentElements).removeClass('error');
			$(this.currentElements).unbind('mouseover').unbind('mouseout');
			if (errorList && errorList.length > 0) {
				$.each(errorList, function(index, obj) {
					$(obj.element).addClass('error');
					var msg = this.message;
					var em = $('<span class="errorMsg">{0}</span>'.format(msg));
					$(obj.element).after(em);
					$(obj.element).mouseover(function() {
								em.show();
							}).mouseout(function() {
								em.hide();
							});
				});
			}
		}
	});
}

function defaultHandler_Init() {
	   initButtins("default");
	$('#asconfig_defaultHandler_form').submit(function() {
				$(this).omAjaxSubmit(new commonOptions('Default'));
				return false;
			});
	$('#asconfig_defaultHandler_form').validate({
		validateOnEmpty : true,
		rules : {
			idleTimeout : {
				required : true,
				isInteger : true
			},
			maxQueueSize : {
				required : true,
				isInteger : true
			},
			maxThreads : {
				required : true,
				isInteger : true
			},
			maxSpareThreads : {
				required : true,
				isInteger : true
			},
			minSpareThreads : {
				required : true,
				isInteger : true
			},
			priority : {
				required : true,
				range : [1, 10]
			}

		},
		messages : {
			idleTimeout : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxQueueSize : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxSpareThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			minSpareThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			priority : {
				required : '值不能为空!',
				range : '范围是1-10!'
			}
		},
		showErrors : function(errorMap, errorList) {
			var next = $(this.currentElements).next();
			while (next.hasClass('errorMsg')) {
				next.remove();
				next = $(this.currentElements).next();
			}
			$(this.currentElements).removeClass('error');
			$(this.currentElements).unbind('mouseover').unbind('mouseout');
			if (errorList && errorList.length > 0) {
				$.each(errorList, function(index, obj) {
					$(obj.element).addClass('error');
					var msg = this.message;
					var em = $('<span class="errorMsg">{0}</span>'.format(msg));
					$(obj.element).after(em);
					$(obj.element).mouseover(function() {
								em.show();
							}).mouseout(function() {
								em.hide();
							});
				});
			}
		}
	});
}

function initButtins(handleName){
	if($("#"+handleName+"_state").html()=="Stopped"){
		$("#" + handleName + "_stop").hide();
        $("#" + handleName + "_start").show();
	}else{
		$("#" + handleName + "_stop").show();
        $("#" + handleName + "_start").hide();
	}
	
}

function muxHandler_Init() {
	initButtins("MuxHandler");
	$('#asconfig_muxHandler_form').submit(function() {
				$(this).omAjaxSubmit(new commonOptions('MuxHandler'));
				return false;
			});
	$('#asconfig_muxHandler_form').validate({
		validateOnEmpty : true,
		rules : {
			idleTimeout : {
				required : true,
				isInteger : true
			},
			maxQueueSize : {
				required : true,
				isInteger : true
			},
			maxThreads : {
				required : true,
				isInteger : true
			},
			maxSpareThreads : {
				required : true,
				isInteger : true
			},
			minSpareThreads : {
				required : true,
				isInteger : true
			},
			priority : {
				required : true,
				range : [1, 10]
			}

		},
		messages : {
			idleTimeout : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxQueueSize : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxSpareThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			minSpareThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			priority : {
				required : '值不能为空!',
				range : '范围是1-10!'
			}
		},
		showErrors : function(errorMap, errorList) {
			var next = $(this.currentElements).next();
			while (next.hasClass('errorMsg')) {
				next.remove();
				next = $(this.currentElements).next();
			}
			$(this.currentElements).removeClass('error');
			$(this.currentElements).unbind('mouseover').unbind('mouseout');
			if (errorList && errorList.length > 0) {
				$.each(errorList, function(index, obj) {
					$(obj.element).addClass('error');
					var msg = this.message;
					var em = $('<span class="errorMsg">{0}</span>'.format(msg));
					$(obj.element).after(em);
					$(obj.element).mouseover(function() {
								em.show();
							}).mouseout(function() {
								em.hide();
							});
				});
			}
		}
	});
}

function jmsHandler_Init() {
	initButtins("JMSHandler");
	$('#asconfig_jmsHandler_form').submit(function() {
				$(this).omAjaxSubmit(new commonOptions('JMSHandler'));
				return false;
			});
	$('#asconfig_jmsHandler_form').validate({
		validateOnEmpty : true,
		rules : {
			idleTimeout : {
				required : true,
				isInteger : true
			},
			maxQueueSize : {
				required : true,
				isInteger : true
			},
			maxThreads : {
				required : true,
				isInteger : true
			},
			maxSpareThreads : {
				required : true,
				isInteger : true
			},
			minSpareThreads : {
				required : true,
				isInteger : true
			},
			priority : {
				required : true,
				range : [1, 10]
			}

		},
		messages : {
			idleTimeout : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxQueueSize : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxSpareThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			minSpareThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			priority : {
				required : '值不能为空!',
				range : '范围是1-10!'
			}
		},
		showErrors : function(errorMap, errorList) {
			var next = $(this.currentElements).next();
			while (next.hasClass('errorMsg')) {
				next.remove();
				next = $(this.currentElements).next();
			}
			$(this.currentElements).removeClass('error');
			$(this.currentElements).unbind('mouseover').unbind('mouseout');
			if (errorList && errorList.length > 0) {
				$.each(errorList, function(index, obj) {
					$(obj.element).addClass('error');
					var msg = this.message;
					var em = $('<span class="errorMsg">{0}</span>'.format(msg));
					$(obj.element).after(em);
					$(obj.element).mouseover(function() {
								em.show();
							}).mouseout(function() {
								em.hide();
							});
				});
			}
		}
	});
}


function mqHandler_Init() {
    initButtins("MQHandler");
    $('#asconfig_mqHandler_form').submit(function() {
                $(this).omAjaxSubmit(new commonOptions('MQHandler'));
                return false;
            });
    $('#asconfig_mqHandler_form').validate({
        validateOnEmpty : true,
        rules : {
            idleTimeout : {
                required : true,
                isInteger : true
            },
            maxQueueSize : {
                required : true,
                isInteger : true
            },
            maxThreads : {
                required : true,
                isInteger : true
            },
            maxSpareThreads : {
                required : true,
                isInteger : true
            },
            minSpareThreads : {
                required : true,
                isInteger : true
            },
            priority : {
                required : true,
                range : [1, 10]
            }

        },
        messages : {
            idleTimeout : {
                required : '值不能为空!',
                isInteger : '必须是整数!'
            },
            maxQueueSize : {
                required : '值不能为空!',
                isInteger : '必须是整数!'
            },
            maxThreads : {
                required : '值不能为空!',
                isInteger : '必须是整数!'
            },
            maxSpareThreads : {
                required : '值不能为空!',
                isInteger : '必须是整数!'
            },
            minSpareThreads : {
                required : '值不能为空!',
                isInteger : '必须是整数!'
            },
            priority : {
                required : '值不能为空!',
                range : '范围是1-10!'
            }
        },
        showErrors : function(errorMap, errorList) {
            var next = $(this.currentElements).next();
            while (next.hasClass('errorMsg')) {
                next.remove();
                next = $(this.currentElements).next();
            }
            $(this.currentElements).removeClass('error');
            $(this.currentElements).unbind('mouseover').unbind('mouseout');
            if (errorList && errorList.length > 0) {
                $.each(errorList, function(index, obj) {
                    $(obj.element).addClass('error');
                    var msg = this.message;
                    var em = $('<span class="errorMsg">{0}</span>'.format(msg));
                    $(obj.element).after(em);
                    $(obj.element).mouseover(function() {
                                em.show();
                            }).mouseout(function() {
                                em.hide();
                            });
                });
            }
        }
    });
}
function orbHandler_Init() {
	initButtins("ORBWorker");
	$('#asconfig_orbHandler_form').submit(function() {
				$(this).omAjaxSubmit(new commonOptions('ORBWorker'));
				return false;
			});
	$('#asconfig_orbHandler_form').validate({
		validateOnEmpty : true,
		rules : {
			idleTimeout : {
				required : true,
				isInteger : true
			},
			maxQueueSize : {
				required : true,
				isInteger : true
			},
			maxThreads : {
				required : true,
				isInteger : true
			},
			maxSpareThreads : {
				required : true,
				isInteger : true
			},
			minSpareThreads : {
				required : true,
				isInteger : true
			},
			priority : {
				required : true,
				range : [1, 10]
			}

		},
		messages : {
			idleTimeout : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxQueueSize : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			maxSpareThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			minSpareThreads : {
				required : '值不能为空!',
				isInteger : '必须是整数!'
			},
			priority : {
				required : '值不能为空!',
				range : '范围是1-10!'
			}
		},
		showErrors : function(errorMap, errorList) {
			var next = $(this.currentElements).next();
			while (next.hasClass('errorMsg')) {
				next.remove();
				next = $(this.currentElements).next();
			}
			$(this.currentElements).removeClass('error');
			$(this.currentElements).unbind('mouseover').unbind('mouseout');
			if (errorList && errorList.length > 0) {
				$.each(errorList, function(index, obj) {
					$(obj.element).addClass('error');
					var msg = this.message;
					var em = $('<span class="errorMsg">{0}</span>'.format(msg));
					$(obj.element).after(em);
					$(obj.element).mouseover(function() {
								em.show();
							}).mouseout(function() {
								em.hide();
							});
				});
			}
		}
	});
}


function changeServerState(changeServerState,serverType){
	$.post( changeServerState + '/protect/aasconfig/threadpool/getServerState',{serverType:serverType},
	function(data,status){
		if(data != '' && 'success' == status){
			$('#state_'+serverType).attr("class", data);
		}
	});
}