var datasourceInterval;
(function($, aas, $m) {
    var validateNotEmpty = function (el) {
        if (el.val() == undefined || el.val().trim().length == 0) {
            $m.markFldError(el, '输入项不能为空！');
            return false;
        } else {
            $m.clearFldError(el);
            return true;
        }
    };
    var _DS = null;
    _DS = aas.ds = {
        baseUrl : '',
        configDS : function(name) {
            $.ajax({
                url : _DS.baseUrl + '/configDS',
                data : {
                    dsName : name
                },
                success : function(data) {
                    var d = $("<div id='configdialogDiv'/>").appendTo($(document.body));
                    d.html(data);
                    d.find('input[name="maxPoolSize"]').omNumberField({
                        allowDecimals : false
                    });
                    d.find('input[name="maxFreePoolSize"]').omNumberField({
                        allowDecimals : false
                    });
                    d.find('input[name="minFreePoolSize"]').omNumberField({
                        allowDecimals : false
                    });
                    d.find('input[name="idleTimeout"]').omNumberField({
                        allowDecimals : false
                    });
                    d.find('input[name="maxWaitTime"]').omNumberField({
                        allowDecimals : false
                    });
                    d.find('input[name="minWaitTime"]').omNumberField({
                        allowDecimals : false
                    });
                    d.find('input[name="initialPoolSize"]').omNumberField({
                        allowDecimals : false
                    });
                    d.find('input[name="stmtCacheSize"]').omNumberField({
                        allowDecimals : false
                    });
                    d.find('input[name="preFetchSize"]').omNumberField({
                        allowDecimals : false
                    });
                    $('#ds_cfg_form').validate({
                        onkeyup : false,
                        onfocusout : false,
                        onsubmit : false,
                        validateOnEmpty : true,
                        rules : {
                            jndiName : { required : true },
                            driverClassName : { required : true },
                            connectionURL : { required : true }
                        },
                        messages : {
                            jndiName : { required : '该项必须输入' },
                            driverClassName : { required : '该项必须输入' },
                            connectionURL : { required : '该项必须输入' }
                        },
                        showErrors: function(errorMap, errorList) {
                            var next = $(this.currentElements).next();
                            while(next.hasClass('errorMsg')) {
                                next.remove();
                                next = $(this.currentElements).next();
                            }
                            $(this.currentElements).removeClass('error');
                            $(this.currentElements).unbind('mouseover').unbind('mouseout');
                            if(errorList && errorList.length > 0){
                                $.each(errorList, function(index, obj){
                                    $(obj.element).addClass('error');
                                    var msg = this.message;
                                    var em = $('<span class="errorMsg">{0}</span>'.format(msg));
                                    $(obj.element).after(em);
                                    $(obj.element).mouseover(function() {
                                        em.show();
                                    }).mouseout(function() {
                                        em.hide();
                                    });
                                });
                            }
                        }
                    });
                    d.omDialog({
                        autoOpen : true,
                        height : 620,
                        width : 730,
                        modal : true,
                        title : '配置数据源',
                        buttons : [ {
                        	id:"configDSButton",
                            text : '保存',
                            click : function() {
                                var cp = '';
                                $.each($('#driver_cls_tbl').find('td input.driver_path'), function(i, v) {
                                    cp = cp + $(v).val() + ';';
                                });
                                
                                $('#driverClassPathFld').val(cp);
                                
                                if( $('#driverClassPathFld').val()==""){
                                	createDsError("驱动路径不能为空");
                                	return false;
                                }
                                
                                var testBeforeReused = $('#testBeforeReusedFld')[0].checked;
                                
                                var valid1 = $('#ds_cfg_form').valid();
                                var valid2 = true;
                                if(testBeforeReused) {
                                    valid2 = validateNotEmpty($('#testCommand'));
                                } else {
                                    $m.clearFldError($('#testCommand'));
                                }
                                var valid3 = true;
                                $('#conn_prop_tbl input.conn_prop').each(function() {
                                    valid3 = validateNotEmpty($(this)) && valid3;
                                });
                                if(valid1 && valid2 && valid3) {
                                     $('#ds_cfg_form').submit();
                                     $("#configloadingDiv").show();
                                     $("#configDSButton").attr("disabled","disabled");
                                }else{
                                	return false;
                                }
                            }
                        }, {
                            text : '取消',
                            click : function() {
                                d.omDialog("close");
                                d.remove();
                            }
                        } ],
                         onOpen:function(){
                            $('#ds_cfg_form').submit(function() {
                                    $(this).omAjaxSubmit(configDsOptions);
                                    return false;
                              });
                      }
                    });
                }
            });
        },

        create : function() {
        	
        },
        
        showTestDSDialog : function(name) {
            var d = $('<div />').appendTo($(document.body));
            var fld = $('<textarea name="testSQL" style="width: 200px; height: 60px;" />');
            fld.keyup(function() {
                validateNotEmpty(fld);
            }).blur(function() {
                validateNotEmpty(fld);
            });
            d.html('<label>测试SQL语句：</label>').append(fld);
            d.omDialog({
                autoOpen : true,
                height : 200,
                width : 290,
                modal : true,
                title : '测试数据源',
                onClose: function() {
                    datasourceIndex();
                },
                buttons : [ {
                    text : '测试',
                    click : function() {
                        if(validateNotEmpty(fld)) {
                            _DS.testDS(name, fld.val());
                        }
                    }
                }, {
                    text : '关闭',
                    click : function() {
                        d.omDialog("close");
                        d.remove();
                    }
                } ]
            });
        },
        
        testDS : function(dsName, sql) {
            $.ajax({
                url : _DS.baseUrl + '/testDS',
                type : 'post',
                data : {
                    dsName : dsName,
                    testSQL : sql
                },
                success : function(data) {
                    if ('success' == data.status) {
                        $m.info('测试数据源{0}成功！'.format(dsName));
                    } else {
                        $m.error('测试数据源{0}失败！{1}'.format(dsName, data.content != undefined ? data.content : ''));
                    }
                },
                error : function() {
                    $m.error('测试数据源{0}失败！出现未知错误'.format(dsName));
                }
            });
        },
        
        monitorDatasource : function (name) {
            var d = $('<div />').appendTo($(document.body));
            d.append('<div id="ds_monitor_div" />');
            d.omDialog({
                autoOpen : true,
                height : 360,
                width : 600,
                modal : true,
                title : '数据源监控 - ' + name,
                onOpen: function() {
                    init();
                    showDatasourceMonitorIntervalChart(name);
                },
                onClose : function() {
                    d.omDialog('destroy');
                    d.remove();
                    datasourceIndex();
                }
            });
        }
    };

    function init() {
        isDsMonitorRunning = false;
    }

    function showDatasourceMonitorIntervalChart(dsName) {
        try {
            if(datasourceInterval) {
                clearInterval(datasourceInterval);
            }
        } catch(e) { }
        datasourceInterval = setInterval(function(){
            showDataSourceMonitorChart(dsName);
        }, 4000);
        if(!isDsMonitorRunning) {
            isDsMonitorRunning = true;
            showDataSourceMonitorChart(dsName);
            isDsMonitorRunning = false;
        }
    }

    function getDataSourceMonitorData(url, data) {
        var json = getAjaxJsonData(url, data);
        var ret = {};
        if(json && json != "" && json != "null") {
            var legend = new Array();
            var xyData = new Array();
            $(json).each(function(i, v){
                legend.push(v.legend);
                xyData.push(v.data);
            });
            ret.legend = legend;
            ret.data = xyData;
        } else {
            ret.legend = [];
            ret.data = [];
        }
        return ret;
    }

    function showDataSourceMonitorChart(dsName) {
        var url = _DS.baseUrl + "/../monitor/datasource/statisticsJson";
        var data = getDataSourceMonitorData(url, {dsName:dsName});
        var count = 0;
        try {
            if(dataSourceMonitorChart) {
                dataSourceMonitorChart.destroy();
            }
        } catch (e) {

        }
        if(data.data.length == 0) {
            showChartNoData("#ds_monitor_div", "数据源统计，没有数据");
            return;
        } else {
            $("#line-inner").empty();
        }
        dataSourceMonitorChart = $.jqplot('ds_monitor_div', data.data, $.extend(true, getDefaultOptions(), {
            title: "数据源统计",
            axes: {
                xaxis: {
                    tickOptions: {
                        formatter: function(format, val) {
                            count++;
                            if((count)%2 == 0) {
                                return val;
                            }
                            return " ";
                        }
                    }
                }
            },
            legend: {
                renderer: $.jqplot.EnhancedLegendRenderer,
                show: true,
                location: 's',
                placement: 'outsideGrid',
                labels: data.legend,
                shrinkGrid: true,
                rendererOptions: {
                    numberRows : 1
                }
            }
        }));
    }
})(jQuery, aas,  AASMonitor);