var contextPath = "";
var resBase = "";
$(document).ready(function() {
	resBase = $("#resBase").val();
	contextPath = $("#contextPath").val();
	$('#buttonbar').omButtonbar({
		btns : [{
					label : "新增Jndi资源",
					id : "button1",
					icons : {
						left : resBase + '/images/add.png'
					},
					onClick : function() {
						addJndiResource("jndi", '新增Jndi资源');
					}
				}, {
					separtor : true
				}, {
					label : "新增JavaMail会话",
					id : "button2",
					icons : {
						left : resBase + '/images/add.png'
					},
					onClick : function() {
						addJndiMailResource("javax.mail.Session", '新增JavaMail会话');
					}
				}, {
					separtor : true
				}, {
					label : "刷新",
					id : "button3",
					icons : {
						left : resBase + '/images/refresh.png'
					},
					onClick : function() {
						$("#jndi-resource-grid").omGrid('reload');
					}
				}]
	});


	$('#jndi-resource-grid').omGrid({
		limit : 0,
		showIndex : true,
		height : 680,
		width : '100%',
		singleSelect : true,
		colModel : [{
					header : 'jndi资源名称',
					name : 'jndiName',
					align : 'center',
                    width: 150
				}, {
					header : '资源类名',
					name : 'resourceType',
					align : 'left',
                    width: 200
				}, {
					header : '构造函数参数',
					name : 'constructs',
					align : 'left',
                    width: 200
				}, {
					header : '资源工厂',
					name : 'factoryClass',
					align : 'left',
                    width: 200
				}, {
					header : '资源属性',
					name : 'bridges',
					align : 'left',
                    width: 'autoExpand'
				}, {
					header : '操作',
					name : 'operation',
					align : 'center',
                    width: 80,
					renderer : function(colValue, rowData, rowIndex) {
						return "<img src="
								+ resBase
								+ "/images/edit-1.png title='修改' style='cursor:pointer' onclick=\"updateJndiResource('"+rowData.resourceType+"','"
								+ rowData.jndiName
								+ "')\";/>&nbsp;<img src="
								+ resBase
								+ "/images/delete.png title='删除' style='cursor:pointer' onclick=\"showDelConfirm('"
								+ rowData.jndiName + "')\";/>";
					}
			}],
			dataSource : contextPath + '/protect/jndi/loadJndiResource'
	});
});

function showSuccess(content) {
	var option = {
		type : 'success',
		title : '成功',
		content : content
	};
	showMessageTip(option);
}

function showFailure(content) {
	var option = {
		type : 'error',
		title : '失败',
		content : content == null ? "操作失败" : content
	};
	showMessageTip(option);
}

function showDelConfirm(key) {
	$.omMessageBox.confirm({
		title : '确认删除',
		content : '确认删除记录吗？',
		onClose : function(v) {
			if (v) {
				deleteJndiResource(key);
			} else {
				return false;
			}
		}
	});
}

function deleteJndiResource(jndiNames) {
	$.ajax({
		url : contextPath + '/protect/jndi/delJndiResource',
		type : "post",
		dataType : "json",
		data : {
			jndiNames : jndiNames
		},
		success : function(data) {
			if (data == "success") {
				showSuccess("删除"+jndiNames+"资源成功");
				$("#jndi-resource-grid").omGrid('reload');
			} else {
				showFailure(data);
			}

		},
		error : function() {
			showFailure("修改失败");
		}
	});
}

function addJndiResource(resourceType, title) {
	$.ajax({
		url : contextPath + '/protect/jndi/createJndiResource',
		type : "post",
		dataType : "html",
		data : {
			resourceType : resourceType
		},
		success : function(data) {
			var d = $("#addJndiResourceDialog");
			d.html(data).omDialog({
				autoOpen : true,
				height : 540,
				width : 520,
				modal : true,
				title : title,
				buttons : [ {
						text : '创建',
						click : function() {
							var success = true;
							$('#jndi_resource_form input').each(function() {
								if ($(this).val() == undefined || $(this).val().trim().length == 0) {
									success = false;
									AASMonitor.markFldError($(this), '输入项不允许为空！');
								} else {
									AASMonitor.clearFldError($(this));
								}
							});
							var jndiName = $('#jndi_resource_form input[name="jndiName"]').val();
							if (success) {
								$.ajax({
									url : $("#jndi_resource_form").attr("action"),
									type : "post",
									dataType : "html",
									data : $("#jndi_resource_form").serializeArray(),
									success : function(val) {
										if(val == "success") {
											showSuccess("新增"+jndiName+"成功");
											$("#jndi-resource-grid").omGrid('reload');
											d.omDialog('close');
										} else {
											showFailure(val);
										}
									}
								});
							}
						}
				}, {
					text : '取消',
					click : function() {
						d.omDialog('close');
					}
				}],
				onClose : function() {
					argsIndex = -1;
					attrIndex = -1;
					d.html("");
				}
			});
			inputFilter("#jndi_resource_form input[name='jndiName']");
			inputFilter("#jndi_resource_form input[name='resourceType']");
			$('#jndi_resource_form input').each(function() {
				var _el = $(this);
				_el.keyup(function() {
					validateNotEmpty(_el);
				}).blur(function() {
					validateNotEmpty(_el);
				});
			});
		}
	});
}

function updateJndiResource(resourceType, jndiName) {
	var height = 540;
	var title = "修改Jndi资源";
	if(resourceType == "javax.mail.Session") {
		height = 450;
		title = "修改JavaMail会话";
	}
	$.ajax({
		url : contextPath + '/protect/jndi/updateJndiResource',
		type : "post",
		dataType : "html",
		data : {
			resourceType : resourceType,
			jndiName : jndiName
		},
		success : function(data) {
			var d = $("#addJndiResourceDialog");
			d.html(data).omDialog({
				autoOpen : true,
				height : height,
				width : 520,
				modal : true,
				title : title,
				buttons : [ {
						text : '修改',
						click : function() {
							var success = true;
							$('#jndi_resource_form input').each(function() {
								if ($(this).val() == undefined || $(this).val().trim().length == 0) {
									success = false;
									AASMonitor.markFldError($(this), '输入项不允许为空！');
								} else {
									AASMonitor.clearFldError($(this));
								}
							});
							if (success) {
								$.ajax({
									url : $("#jndi_resource_form").attr("action"),
									type : "post",
									dataType : "html",
									data : $("#jndi_resource_form").serializeArray(),
									success : function(val) {
										if(val == "success") {
											showSuccess("修改"+jndiName+"资源成功");
											$("#jndi-resource-grid").omGrid('reload');
											d.omDialog('close');
										} else {
											showFailure(val);
										}
									}
								});
							}
						}
				}, {
					text : '取消',
					click : function() {
						d.omDialog('close');
					}
				}],
				onClose : function() {
					argsIndex = -1;
					attrIndex = -1;
					d.html("");
				}
			});
			inputFilter("#jndi_resource_form input[name='jndiName']");
			inputFilter("#jndi_resource_form input[name='resourceType']");
			$('#jndi_resource_form input').each(function() {
				var _el = $(this);
				_el.keyup(function() {
					validateNotEmpty(_el);
				}).blur(function() {
					validateNotEmpty(_el);
				});
			});
		}
	});
}

var attrTpl = '<tr>' 
		     +'<td class="tdCenter"><input name="pName{0}" type="text" class="inputUI"/></td>'
		     +'<td class="tdCenter"><input name="pValue{0}" type="text" class="inputUI"/></td>'
		     +'<td class="tdCenter"><a onclick="removeAttr(this);">删除</a></td>'
		 +'</tr>';

var argsTpl = '<tr>' 
    		+'<td class="tdCenter"><input name="argsType{0}" type="text" class="inputUI"/></td>'
    		+'<td class="tdCenter"><input name="argsValue{0}" type="text" class="inputUI"/></td>'
    		+'<td class="tdCenter"><a onclick="removeAttr(this);">删除</a></td>'
    	 +'</tr>';

var argsIndex = -1;
var attrIndex = -1;

function addArgsAttr() {
	if(argsIndex == -1) {
		var index = $("#argsTb tbody").find("tr").size();
		if(index >0) {
			argsIndex = index;
		}
	}
	argsIndex++;
	var r = $(argsTpl.format(argsIndex));
    r.find('input').each(function() {
        var _el = $(this);
        _el.keyup(function() {
            validateNotEmpty(_el);
        }).blur(function() {
            validateNotEmpty(_el);
        });
    });
    $('#argsTb tbody').append(r);
}

function addAttr() {
	if(attrIndex == -1) {
		var index = $("#attrTb tbody").find("tr").size();
		if(index>0) {
			attrIndex = index;
		}
	}
	attrIndex++;
	var r = $(attrTpl.format(attrIndex));
    r.find('input').each(function() {
        var _el = $(this);
        _el.keyup(function() {
            validateNotEmpty(_el);
        }).blur(function() {
            validateNotEmpty(_el);
        });
    });
    $('#attrTb tbody').append(r);
}

function validateNotEmpty(el) {
    if (el.val() == undefined || el.val().trim().length == 0) {
        AASMonitor.markFldError(el, '输入项不能为空！');
    } else {
        AASMonitor.clearFldError(el);
    }
}

function removeAttr(element) {
	$(element).parent().parent().remove();
}


function inputFilter(element) {
	/** /[\'\"\:\;\<\>\,\?\/\`\~\!\#\$\%\^\&\*\|\\\+\-\=]+/g; **/
	var regx=/[\'\"]+/g;
	$(element).bind("keydown change blur", function(event) {
		var obj=$(this);
		setTimeout(function(){
			v=obj.val();
			if(regx.test(v))
				obj.val(v.replace(regx, ""));
		}, 0);
	});
}

function addJndiMailResource(resourceType, title) {
	$.ajax({
		url : contextPath + '/protect/jndi/createJndiResource',
		type : "post",
		dataType : "html",
		data : {
			resourceType : resourceType
		},
		success : function(data) {
			var d = $("#addJndiResourceDialog");
			d.html(data).omDialog({
				autoOpen : true,
				height : 450,
				width : 520,
				modal : true,
				title : title,
				buttons : [ {
						text : '创建',
						click : function() {
							var success = true;
							$('#jndi_resource_form input').each(function() {
								if ($(this).val() == undefined || $(this).val().trim().length == 0) {
									success = false;
									AASMonitor.markFldError($(this), '输入项不允许为空！');
								} else {
									AASMonitor.clearFldError($(this));
								}
							});
							var jndiName = $('#jndi_resource_form input[name="jndiName"]').val();
							if (success) {
								$.ajax({
									url : contextPath + '/protect/jndi/saveJndiMailResource',
									type : "post",
									dataType : "html",
									data : $("#jndi_resource_form").serializeArray(),
									success : function(val) {
										if(val == "success") {
											showSuccess("新增"+jndiName+"资源成功");
											$("#jndi-resource-grid").omGrid('reload');
											d.omDialog('close');
										} else {
											showFailure(val);
										}
									}
								});
							}
						}
				}, {
					text : '取消',
					click : function() {
						d.omDialog('close');
					}
				}],
				onClose : function() {
					argsIndex = -1;
					attrIndex = -1;
					d.html("");
				}
			});
			inputFilter("#jndi_resource_form input[name='jndiName']");
			inputFilter("#jndi_resource_form input[name='resourceType']");
			$('#jndi_resource_form input').each(function() {
				var _el = $(this);
				_el.keyup(function() {
					validateNotEmpty(_el);
				}).blur(function() {
					validateNotEmpty(_el);
				});
			});
		}
	});
}

function changeMailStoreProtocol(element) {
	var selected = $(element).val();
	if(selected == "pop3") {
		$("#mail_store_class").val("com.sun.mail.pop3.POP3Store");
	} else {
		$("#mail_store_class").val("com.sun.mail.imap.IMAPStore");
	}
}

function showMessageTip(options){
	var option={title:"提示", timeout:4000, type:"alert"};
	if (typeof options==="object"){
		option=$.extend(option, options);
	}else if(typeof options==="string"){
		option.content=options;
	}
	try{
		window.top.$.omMessageTip.show(option);
	}catch(ex){
		try{
			$.omMessageTip.show(option);
		}catch(e){
			alert(option.content);
		}
	}
}
