function getDefaultOptions() {
	var defaultOptions = {
			grid : {
				drawGridlines: true,
				background : '#E8F6FD' // 设置整个图表区域的背景色
			},
			seriesColors:["#00749F", "#579575", "#ae2509", "#839557", "#953579", "#4b5de4", "#C7754C", "#ffbffd", "#ffd386", "#66b842", "#90c2f0", "#33335c", "#7a5f5f", "#493e4f", "#524343", "#537173", "#5928ad", "#94918c", "#575b5c"],
			title : {
				fontSize : '20px',
				fontFamily : '黑体'
			},
			animate : !$.jqplot.use_excanvas,
			animateReplot : true,
			seriesDefaults : {
				rendererOptions: {
	                animation: {
	                    speed: 2000
	                }
	            },
                lineWidth: 1,
                shadow: false,
                rendererOptions: {
                    smooth: false
                },
                markerOptions: {
                    show: true,
                    shadow: false,
                    size: 5
                }
			},
			axesDefaults : {
				
			},
			axes : {
				xaxis : {
					renderer : $.jqplot.CategoryAxisRenderer
				},
				yaxis : {
					min: 0,
	            	autoscale: true,
	            	tickOptions: {
	                    formatString: '%d',
	                    // jqplot bug: 解决显示多条为0或者1的刻度
	                    formatter: function(format, val) {
	                    	if (typeof val == 'number') {
	                            if (!format) {
	                                format = $.jqplot.config.defaultTickFormatString;
	                            } 
	                            if (val % 1 === 0) {
	                                return $.jqplot.sprintf(format, val);
	                            } else {
	                                return '';
	                            }
	                        }
	                        else {
	                            return String(val);
	                        }
	                    }
	                }
				}
			},
			highlighter: {
	        	show: true,
	        	tooltipAxes: "y"
	        },
	        cursor:{
	        	show: false
	        }
		};
	return defaultOptions;
}
	
function getAjaxJsonData(url, data) {
	var ret = null;
	$.ajax({
		async: false,
		url: url,
		data: data,
		cache: false,
		dataType: "json",
		success: function(data) {
			ret = data;
		}
	});
	return ret;
}

function showChartNoData(elemId, title) {
	if(title == undefined) {
		title = "没有数据";
	}
	$(elemId).html("<div style='width:100%;height:100%;text-align:center;vertical-align: middle;'><table style='vertical-align:center;height: 100%;width:100%;'><tr><td style='text-align:center;'>"+title+"</td></tr></table></div>");
}