(function() {
	var contextPath="";
    var resBase="";
	$(document).ready(function() {
		contextPath = $("#contextPath").val();
		resBase = $("#resBase").val();
        $('#classloaderButtonbar').omButtonbar({
            btns : [{
                separtor : true
            }, {
                label : "类加载器信息",
                id : "button1",
                icons : {
                    left : resBase +'/images/setting.png'
                },
                onClick : function() {
                    window.location.href=contextPath+"/protect/monitor/classloader/classloaderDetail";
                }
            }, {
                separtor : true
            }]
        });

		$('#grid').omGrid({
					limit : 0,
					showIndex : false,
					height: 100,
					colModel : [{
								header : '名称',
								name : 'name',
								width : 70,
								align : 'center',
								sort : 'clientSide'
							}, {
								header : '值',
								name : 'value',
								width : 70,
								align : 'center',
								sort : 'clientSide'
							}, {
								header : '描述',
								name : 'des',
								width : 'autoExpand',
								align : 'center',
								sort : 'clientSide'
							}],
					dataSource : contextPath
							+ '/protect/monitor/classloader/list'
				});
		init();
		showIntervalChart();
		setInterval(function() {
			$.ajax({
						type : "get",
						dataType : "json",
						url : contextPath + '/protect/monitor/classloader/list',
						success : function(data) {
							$('#grid').omGrid("reload");
						}
					});
			showIntervalChart();
		}, 3000);

	});
	
	function init() {
		isRunning = false;
	}
	
	function showIntervalChart() {
		if(!isRunning) {
			isRunning = true;
			showClassloaderChart();
			isRunning = false;
		}
	}
	
	function getClassloaderData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			ret.data = json;
		} else {
			ret.data = [];
		}
		return ret;
	}
	
	function showClassloaderChart() {
		var url = contextPath+"/protect/monitor/classloader/refreshJsonDate";
		var data = getClassloaderData(url, {});
		var count = 0;
		try {
			if(classloadChart) {
				classloadChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#classloader-chart-inner", "JVM类加载监控，没有数据");
			return;
		} else {
			$("#classloader-chart-inner").empty();
		}
		classloadChart = $.jqplot('classloader-chart-inner', data.data, $.extend(true, getDefaultOptions(), {
			title: "JVM类加载监控",
			seriesColors:['#17BDB8'],
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			count++;
	            			if((count)%2 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            }
	        },
	        seriesDefaults:{
	            fill: true,
	            fillAndStroke: true,
	            fillAlpha: 0.5,
	            shadow: false
	        }
		}));
	}
})();
