(function(M) {
	M.panel={
	   baseUrl : '',
	   resUrl  : '',
	   panles:[],
	   fixLength:'',
	   watchMap:'',
	   showConfig:function(){
	      	window.location.href=this.baseUrl+"/protect/monitor/config";
	   },
	   initPanels:function(){
            var count=0;
            init();
            var methodArray = new Array();
            for(var index=1;index<=this.fixLength;index++){
                var panelA = this.watchMap.get(this.panles[count]);
                count++;
                var panelB = this.watchMap.get(this.panles[count]);
                count++;
                try{
                	eval(panelA+"("+"'a"+index+"')");
                	methodArray.push(panelA+"("+"'a"+index+"')");
                } catch(e) { }
                try{
                	eval(panelB+"("+"'b"+index+"')");
                	methodArray.push(panelB+"("+"'b"+index+"')");
                } catch(e) { }
            }
            setInterval(_showIntervalChart(methodArray), 3000);
	   }
	};
	
	function init() {
		isRunning = false;
	}
	
	function _showIntervalChart(methodArray) {
		return function () {
			showIntervalChart(methodArray);
		}
	}
	
	function showIntervalChart(methodArray) {
		if(!isRunning) {
			isRunning = true;
			for(i=0; i<methodArray.length; i++) {
				eval(methodArray[i]);
			}
			isRunning = false;
		}	
	}
	
	function getMemoryData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			ret.data = json;
		} else {
			ret.data = [];
		}
		return ret;
	}

	function showMemoryChart(element) {
		var url = M.panel.baseUrl+"/protect/monitor/memory/refreshJsonDate";
		var data = getMemoryData(url, {});
		var memoryCount = 0;
		try {
			if(memoryChart) {
				memoryChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#"+element, "JVM堆内存监控，没有数据");
			return;
		} else {
			$(element).empty();
		}
		memoryChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
			title: "JVM堆内存监控",
			seriesColors: ['#17BDB8'],
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			memoryCount++;
	            			if((memoryCount)%3 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            },
	            yaxis : {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			return val+"M";
	            		}
	            	}
	            }
	        },
	        seriesDefaults:{
	            fill: true,
	            fillAndStroke: true,
	            fillAlpha: 0.5,
	            shadow: false
	        }
		}));
	}
	
	function getClassloaderData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			ret.data = json;
		} else {
			ret.data = [];
		}
		return ret;
	}
	
	function showClassLoaderChart(element) {
		var url = M.panel.baseUrl+"/protect/monitor/classloader/refreshJsonDate";
		var data = getClassloaderData(url, {});
		var classCount = 0;
		try {
			if(classloadChart) {
				classloadChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#"+element, "JVM类加载监控，没有数据");
			return;
		} else {
			$(element).empty();
		}
		classloadChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
			title: "JVM类加载监控",
			seriesColors:['#17BDB8'],
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			classCount++;
	            			if((classCount)%3 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            }
	        },
	        seriesDefaults:{
	            fill: true,
	            fillAndStroke: true,
	            fillAlpha: 0.5,
	            shadow: false
	        }
		}));
	}
	
	function getAppSessionData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			var appName = new Array();
			var xyData = new Array();
			$(json).each(function(i, v){
				appName.push(v.appName);
				xyData.push(v.data);
			});
			ret.legend = appName;
			ret.data = xyData;
		} else {
			ret.legend = [];
			ret.data = [];
		}
		return ret;
	}

	function showAppSessionChart(element) {
		var url = M.panel.baseUrl+"/protect/monitor/appsession/statisticsJson";
		var data = getAppSessionData(url, {});
		var appSessionCount = 0;
		try {
			if(appSessionChart) {
				appSessionChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#"+element, "应用会话统计，没有数据");
			return;
		} else {
			$(element).empty();
		}
		var numberRows = data.legend.length/5, numberColumns = 5;
		if(numberRows == 0) {
			numberRows = 1;
		}
		appSessionChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
	  		title: "应用会话统计",
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			appSessionCount++;
	            			if((appSessionCount)%3 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            }
	        },
	        legend: {
	            renderer: $.jqplot.EnhancedLegendRenderer, 
	            show: true,
	            location: 's',
	            placement: 'outsideGrid',
	            // 图例单独指定
	            labels: data.legend,
	            shrinkGrid: true,
	            rendererOptions: {
	            	numberRows : numberRows,
	            	numberColumns : numberColumns
	            }
	        }
		}));
	}
	
	function getDataSourceData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			var legend = new Array();
			var xyData = new Array();
			$(json).each(function(i, v){
				legend.push(v.legend);
				xyData.push(v.data);
			});
			ret.legend = legend;
			ret.data = xyData;
		} else {
			ret.legend = [];
			ret.data = [];
		}
		return ret;
	}

	function showDataSourceChart(element) {
		var url = M.panel.baseUrl+"/protect/monitor/datasource/maxstatisticsJson";
		var data = getDataSourceData(url, {});
		var dataSourceCount = 0;
		try {
			if(dataSourceChart) {
				dataSourceChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#"+element, "数据源监控，没有数据");
			return;
		} else {
			$(element).empty();
		}
		dataSourceChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
	  		title: "数据源连接统计",
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			dataSourceCount++;
	            			if((dataSourceCount)%3 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            }
	        },
	        legend: {
	            renderer: $.jqplot.EnhancedLegendRenderer, 
	            show: true,
	            location: 's',
	            placement: 'outsideGrid',
	            labels: data.legend,
	            shrinkGrid: true,
	            rendererOptions: {
	            	numberRows : 1
	            }
	        }
		}));
	}
	
	function getActiveThreadData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			ret.data = json;
		} else {
			ret.data = [];
		}
		return ret;
	}
	
	function showActiveThreadChart(element) {
		var url = M.panel.baseUrl+"/protect/monitor/thread/countJson";
		var data = getActiveThreadData(url, {});
		var activeThreadCount = 0;
		try {
			if(activeThreadChart) {
				activeThreadChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#"+element, "活动线程数监控，没有数据");
			return;
		} else {
			$(element).empty();
		}
		activeThreadChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
			title: "活动线程数监控",
			seriesColors:['#17BDB8'],
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			activeThreadCount++;
	            			if((activeThreadCount)%3 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            }
	        }
		}));
	}
	
	function getHttpActiveData(url, data) {
    	var json = getAjaxJsonData(url, data);
    	var ret = {};
    	if(json && json != "" && json != "null") {
    		ret.data = json;
    	} else {
    		ret.data = [];
    	}
    	return ret;
    }

    function showHttpActiveChart(element) {
    	var url = M.panel.baseUrl+"/protect/monitor/http/countJson";
    	var data = getHttpActiveData(url, {});
    	var httpActiveCount = 0;
    	try {
    		if(httpActiveChart) {
    			httpActiveChart.destroy();
    		}
    	} catch (e) {
    		
    	}
    	if(data.data.length == 0) {
			showChartNoData("#"+element, "HTTP连接监控，没有数据");
			return;
		} else {
			$(element).empty();
		}
    	httpActiveChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
    		title: "HTTP连接监控",
    		seriesColors:['#17BDB8'],
    		axes: {
                xaxis: {
                	tickOptions: {
                		formatter: function(format, val) {
                			httpActiveCount++;
                			if((httpActiveCount)%3 == 0) {
                				return val;
                			}
                			return " ";
                		}
                	}
                }
            }
    	}));
    }
    
    function getJtaData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			var legendName = new Array();
			var xyData = new Array();
			$(json).each(function(i, v){
				legendName.push(v.legend);
				xyData.push(v.data);
			});
			ret.legend = legendName;
			ret.data = xyData;
		} else {
			ret.legend = [];
			ret.data = [];
		}
		return ret;
	}

	function showJtaChart(element) {
		var url = M.panel.baseUrl+"/protect/monitor/jta/statisticsJson";
		var data = getJtaData(url, {});
		var jtaCount = 0;
		try {
			if(jtaChart) {
				jtaChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#"+element, "JTA事务统计，没有数据");
			return;
		} else {
			$(element).empty();
		}
		jtaChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
	  		title: "JTA事务统计",
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			jtaCount++;
	            			if((jtaCount)%3 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            }
	        },
	        legend: {
	            renderer: $.jqplot.EnhancedLegendRenderer, 
	            show: true,
	            location: 's',
	            placement: 'outsideGrid',
	            labels: data.legend,
	            shrinkGrid: true,
	            rendererOptions: {
	            	numberRows : 1
	            }
	        }
		}));
	}
	
	function getAppsCountData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			var legendName = new Array();
			var xyData = new Array();
			$(json).each(function(i, v){
				legendName.push(v.legend);
				xyData.push(v.data);
			});
			ret.legend = legendName;
			ret.data = xyData;
		} else {
			ret.legend = [];
			ret.data = [];
		}
		return ret;
	}

	function showAppsCountChart(element) {
		var url = M.panel.baseUrl+"/protect/monitor/appcount/statisticsJson";
		var data = getAppsCountData(url, {});
		var appsCount = 0;
		try {
			if(appsChart) {
				appsChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#"+element, "应用数量统计，没有数据");
			return;
		} else {
			$(element).empty();
		}
		appsChart = $.jqplot(element, data.data, $.extend(true, getDefaultOptions(), {
	  		title: "应用数量统计",
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			appsCount++;
	            			if((appsCount)%3 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            }
	        },
	        legend: {
	            renderer: $.jqplot.EnhancedLegendRenderer, 
	            show: true,
	            location: 's',
	            placement: 'outsideGrid',
	            labels: data.legend,
	            shrinkGrid: true,
	            rendererOptions: {
	            	numberRows : 1
	            }
	        }
		}));
	}
	
})(AASMonitor);
