(function() {
	var contextPath="";
	var resBase="";

	$(document).ready(function() {
		contextPath = $("#contextPath").val();
		resBase = $("#resBase").val();
		showNonHeapChart();
		init();
		showMemoryChart();
		$('#grid').omGrid({
					limit : 0,
					autoFit : true,
					showIndex : false,
					height : 320,
					colModel : [{
								header : '名称',
								name : 'name',
								width : 100,
								align : 'center',
								sort : 'clientSide'
							}, {
								header : '值',
								name : 'value',
								width : 100,
								align : 'center',
								sort : 'clientSide'
							}, {
								header : '描述',
								name : 'des',
								width : 'autoExpand',
								align : 'center',
								sort : 'clientSide'
							}],
					dataSource : contextPath + '/protect/monitor/memory/list'
				});

		setInterval(function() {
					$.ajax({
								type : "get",
								dataType : "json",
								url : contextPath
										+ '/protect/monitor/memory/list',
								success : function(data) {
									$('#grid').omGrid("reload");
								}
							});
					showIntervalChart();
				}, 3000);
	});
	
	function init() {
		isRunning = false;
	}
	
	function showIntervalChart() {
		if(!isRunning) {
			isRunning = true;
			showMemoryChart();
			isRunning = false;
		}
	}

	function showNonHeapChart() {
		var nonHeapNow = $("#nonHeapNow").val();
		var nonHeapMax = $("#nonHeapMax").val();
		var value = 0, max = 0, step = 0;
		if(!isNaN(parseInt(nonHeapNow))) {
			value = parseInt(nonHeapNow);
		}
		if(!isNaN(parseInt(nonHeapMax))) {
			max = parseInt(nonHeapMax);
			step = max/3;
		}
		if(max <= value) {
			max = value * 3;
			step = max/3;
		}
		if(max == 0) {
			max = 500;
			step = max/3;
		}
		try {
			if(nonHeapChart) {
				nonHeapChart.destroy();
			}
		} catch (e) {
			
		}
		if(isNaN(parseInt(nonHeapNow))) {
			showChartNoData("#non-heap-chart", "非堆内存监控，没有数据");
			return;
		} else {
			$("#non-heap-chart").empty();
		}
		nonHeapChart = $.jqplot('non-heap-chart', [[value]], {
			grid: {
	            drawBorder: false, 
	            drawGridlines: false,
	            shadow: false
	        },
			seriesDefaults: {
				renderer: $.jqplot.MeterGaugeRenderer,
				rendererOptions: {
					ringColor: "#cfe2f3",
					max: max,
					label: 'MB',
	                labelHeightAdjust: -5,
	                intervals: [step, step*2, step*3],
	                intervalOuterRadius: 75,
	                intervalColors:['#66cc66', '#93b75f', '#CC6666']
	            }
			}
		});
	}
	
	function getMemoryData(url, data) {
		var json = getAjaxJsonData(url, data);
		var ret = {};
		if(json && json != "" && json != "null") {
			ret.data = json;
		} else {
			ret.data = [];
		}
		return ret;
	}

	function showMemoryChart() {
		var url = contextPath+"/protect/monitor/memory/refreshJsonDate";
		var data = getMemoryData(url, {});
		var count = 0;
		try {
			if(memoryChart) {
				memoryChart.destroy();
			}
		} catch (e) {
			
		}
		if(data.data.length == 0) {
			showChartNoData("#memory-chart-inner", "JVM内存监控，没有数据");
			return;
		} else {
			$("#memory-chart-inner").empty();
		}
		memoryChart = $.jqplot('memory-chart-inner', data.data, $.extend(true, getDefaultOptions(), {
			title: "JVM内存监控",
			seriesColors: ['#17BDB8'],
			axes: {
	            xaxis: {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			count++;
	            			if((count)%3 == 0) {
	            				return val;
	            			}
	            			return " ";
	            		}
	            	}
	            },
	            yaxis : {
	            	tickOptions: {
	            		formatter: function(format, val) {
	            			return val+"M";
	            		}
	            	}
	            }
	        },
	        seriesDefaults:{
	            fill: true,
	            fillAndStroke: true,
	            fillAlpha: 0.5,
	            shadow: false
	        }
		}));
	}
	
})();
