;
/**
 * 服务器端文件选择器
 * */
(function($, aas) {
    var SFS = null;
    SFS = aas.utils.ServerDirSelector = aas.Core.extend({
        /**
         * 点击选择按钮后的回调方法，签名为：function(value)，其中参数value为选中的文件的路径
         * */
        callback : null,

        selectedPath: null,

        initialize : function(cfg) {
            this.callback = cfg.callback;
            var _t = this;
            var dialog_tpl = '<div id="selector_west"><ul id="forder_tree"></ul></div>' +
                             '<div id="selector_center"><table id="file_grid"></table></div>' +
                             '<div id="selector_south"><label>已选择：</label><input id="selected_dir_name" type="text" disabled="disabled" /></div>';
            var dialog = $('<div class="file-selector-dialog" />').appendTo($(document.body));
            dialog.omDialog({
                autoOpen : true,
                height : 450,
                width : 600,
                modal : true,
                title : '选择目录',
                buttons : [ {
                    text : '选择',
                    click : function() {
                        if(_t.selectedData == undefined || _t.selectedData.trim().length == 0) {
                            alert('请选择目录！');
                        } else {
                            _t.callback(dialog, _t.selectedData);
                        }
                    }
                }, {
                    text : '取消',
                    click : function() {
                        dialog.omDialog('close');
                    }
                } ],
                onClose : function() {
                    dialog.omDialog('destroy');
                    dialog.remove();
                }
            });
            dialog.css('padding', '0');
            dialog.append($(dialog_tpl));

            if(cfg.selectedPath) {
                dialog.find("input#selected_dir_name").val(cfg.selectedPath);
            }

            dialog.omBorderLayout({
                panels : [ {
                    id : 'selector_west',
                    region : 'west',
                    header : false,
                    resizable : false,
                    collapsible : false,
                    width : 200
                }, {
                    id : 'selector_center',
                    region : 'center',
                    header : false
                }, {
                    id : 'selector_south',
                    region : 'south',
                    header : false,
                    resizable : false,
                    collapsible : false
                } ],
                spacing : 0
            });
            
            $('#forder_tree').omTree({
                dataSource : _t.getContextPath() + SFS.FOLDER_TREE_DATA_URL,
                onSelect : function(n) {
                    $('#file_grid').omGrid('setData', _t._buildGridDataURL(n.path));
                },
                onBeforeExpand : function(n){
                	var nodeDom = $("#"+n.nid);
                	if(nodeDom.hasClass("hasChildren")){
                		nodeDom.removeClass("hasChildren");
                		$.ajax({
                            url: _t.getContextPath() + SFS.FOLDER_TREE_DATA_URL,
                            data : {
                                parent : n.path
                            },
                            method: 'GET',
                            dataType: 'json',
                            success: function(data){
                                $("#forder_tree").omTree("insert", data, n);
                            }
                        });
                	}
                	return true;
                },
                onDblClick : function(n) {
                    $("#forder_tree").omTree("expand", n);
                }
            });

            $('#file_grid').omGrid({
                height : 279,
                width : '100%',
                limit : 0,
                showIndex : false,
                singleSelect : true,
                colModel : [ {
                    header : '名称',
                    name : 'name',
                    width : 'autoExpand',
                    align : 'left',
                    renderer : function(colValue, rowData, rowIndex) {
                        if(rowData.folder) {
                            return '<span class="folder">{0}</span>'.format(colValue);
                        }
                    }
                } ],
                dataSource : _t.getContextPath() + SFS.FILE_GRID_DATA_URL,
                onRowSelect : function(rowIndex, data) {
                    _t.selectedData = data.path;
                    $('#selected_dir_name').val(data.path);
                },
                onRowDblClick : function(rowIndex, data) {
                    _t.selectedData = data.path;
                    $('#selected_dir_name').val(data.path);
                    _t.callback(dialog, _t.selectedData);
                }
            });
        },
        
        _buildGridDataURL : function(parent) {
            var url = this.getContextPath() + SFS.FILE_GRID_DATA_URL + '?folder=' + encodeURIComponent(parent);
            if(this.suffix != null) {
                url = url + '&suffix=' + encodeURIComponent(this.suffix);
            }
            return url;
        }
    }, {
        FOLDER_TREE_DATA_URL : '/protected/selector/server_file/folders',
        FILE_GRID_DATA_URL : '/protected/selector/server_file/dirs'
    });
})(jQuery, aas);