var contextPath = "";
var resBase = "";

var realTabInitialized = [ 1, 0, 0, 0 ];

$(document).ready(function() {
    contextPath = $("#contextPath").val();
    resBase = $("#resBase").val();

    $('#realm-security').omTabs({
        width : '100%',
        border : false,
        lazyLoad : true,
        onActivate : function(i, e) {
            if(i > 0 && realTabInitialized[i] == 0) {
                realTabInitialized[i] = 1;
                if(i == 1) {
                    initLDAPRealmTab();
                } else if(i == 2) {
                    initUserDefinedRealmTab();
                } else if(i == 3) {
                    initTextStoreRealmTab();
                } 
            }
        }
    });
    
    initJDBCRealmTab();
});

function initJDBCRealmTab() {
    $("#jdbc_realm_button").omButton();

    $('#realm-jdbc-buttonbar').omButtonbar({
        btns : [ {
            label : "复制为新域",
            id : "button1",
            icons : {
                left : resBase + '/images/copy.png'
            },
            onClick : function() {
                copyRealm("realm-jdbc");
            }
        }, {
            separtor : true
        }, {
            label : "设为默认域",
            id : "button3",
            icons : {
                left : resBase + '/images/setting2.png'
            },
            onClick : function() {
                var dels = $('#realm-jdbc-grid').omGrid("getSelections", true);
                if (dels.length <= 0) {
                    showFailure("请先选择选项！");
                    return;
                }
                var delIds = "";
                $(dels).each(function(index, item) {
                    delIds = item.realmName;
                });
                showConfirm("设置默认域", "是否置为默认域？", setDefaultRealm, delIds, "JDBC存储");
            }
        } ]
    });

    $('#realm-jdbc-grid')
            .omGrid(
                    {
                        limit : 0,
                        autoFit : true,
                        showIndex : false,
                        width : 'fit',
                        height : 220,
                        colModel : [
                                {
                                    header : '名称',
                                    name : 'realmName',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : '数据源JNDI名',
                                    name : 'providerProps.datasource-jndi-name',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : '用户信息表名',
                                    name : 'providerProps.user-table-name',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : '用户名字段名',
                                    name : 'providerProps.usernameField',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : '密码编码',
                                    name : 'providerProps.needEncode',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : '是否默认域',
                                    name : 'isDefaultRealm',
                                    width : 150,
                                    align : 'center',
                                    renderer : function(colValue, rowData, rowIndex) {
                                        if ($("#default_name").val() == rowData.realmName) {
                                            return "&nbsp;&nbsp; <img src=" + resBase + "/images/check.png/>";
                                        } else {
                                            return "";
                                        }
                                    }

                                },
                                {
                                    header : '操作',
                                    name : 'opration',
                                    width : 100,
                                    align : 'center',
                                    renderer : function(colValue, rowData, rowIndex) {
                                        if ($("#default_name").val() != rowData.realmName) {
                                            return "&nbsp;&nbsp; <img src="
                                                    + resBase
                                                    + "/images/delete.png style='cursor:pointer' onclick=\"showConfirm('删除域','是否要删除域',deleteRealm,'"
                                                    + rowData.realmName + "','realm-jdbc')\"  />";
                                        } else {
                                            return "";
                                        }
                                    }
                                } ],
                        dataSource : contextPath + '/protect/sysconfig/realm/jdbcRealms'
                    });

    var jdbcoptions = {
        clearForm : true,
        dataType : "json",
        beforeSubmit : validateJdbc,
        success : function(data) {
            if (data == "success") {
                $("#realm-jdbc-grid").omGrid('reload');
                showSuccess();
                $('#jdbcForm')[0].reset();
            } else {
                showFailure(data);
            }
        },
        error : showFailure
    };

    $('#jdbcForm').submit(function() {
        $(this).omAjaxSubmit(jdbcoptions);
        return false;
    });
}

function initLDAPRealmTab() {
    $("#ldap_realm_button").omButton({
        onClick : function () {
            // 在此处加密 ldap pwd
            var key = document.getElementById("ldapKey").value;
            key = CryptoJS.enc.Utf8.parse(key);//密钥
            var iv = key;//偏移量
            var pwd = document.getElementById("ldapRootDNPassword").value;
            if(pwd != ''){
                var encryptedPwd = CryptoJS.AES.encrypt(pwd, key, {
                    iv : iv,
                    mode : CryptoJS.mode.CBC,
                    padding : CryptoJS.pad.ZeroPadding
                });
                document.getElementById("ldapRootDNPassword").value = encryptedPwd;
            }
            document.getElementById("ldapKey").value = "";
        }
    });

    $('#ldapPort').omNumberField({
        allowDecimals : false,
        allowNegative : false
    });

    $('#realm-ldap-buttonbar').omButtonbar({
        btns : [ {
            label : "复制为新域",
            id : "button1",
            icons : {
                left : resBase + '/images/copy.png'
            },
            onClick : function() {
                copyRealm("realm-ldap");
            }
        }, {
            separtor : true
        }, {
            label : "设为默认域",
            id : "button3",
            icons : {
                left : resBase + '/images/setting2.png'
            },
            onClick : function() {
                var dels = $('#realm-ldap-grid').omGrid("getSelections", true);
                if (dels.length <= 0) {
                    showFailure("请先选择选项！");
                    return;
                }
                var delIds = "";
                $(dels).each(function(index, item) {
                    delIds = item.realmName;
                });
                showConfirm("设置默认域", "是否置为默认域？", setDefaultRealm, delIds, "LDAP存储");
            }
        } ]
    });

    $('#realm-ldap-grid')
            .omGrid(
                    {
                        limit : 0,
                        autoFit : true,
                        showIndex : false,
                        width : 'fit',
                        height : 220,
                        colModel : [
                                {
                                    header : '名称',
                                    name : 'realmName',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : 'LDAP主机',
                                    name : 'providerProps.host',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : 'LDAP端口',
                                    name : 'providerProps.port',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : 'LDAP根DN',
                                    name : 'providerProps.rootDN',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : '是否默认域',
                                    name : 'isDefaultRealm',
                                    width : 150,
                                    align : 'center',
                                    renderer : function(colValue, rowData, rowIndex) {
                                        if ($("#default_name").val() == rowData.realmName) {
                                            return "&nbsp;&nbsp; <img src=" + resBase + "/images/check.png/>";
                                        } else {
                                            return "";
                                        }
                                    }

                                },
                                {
                                    header : '操作',
                                    name : 'opration',
                                    width : 100,
                                    align : 'center',
                                    renderer : function(colValue, rowData, rowIndex) {
                                        if ($("#default_name").val() != rowData.realmName) {
                                            return "&nbsp;&nbsp; <img src="
                                                    + resBase
                                                    + "/images/delete.png style='cursor:pointer' onclick=\"showConfirm('删除域','是否要删除域',deleteRealm,'"
                                                    + rowData.realmName + "','realm-ldap')\"  />";
                                        } else {
                                            return "";
                                        }
                                    }
                                } ],
                        dataSource : contextPath + '/protect/sysconfig/realm/ldapRealms'
                    });

    var ldapoptions = {
        clearForm : true,
        dataType : "json",
        beforeSubmit : validateldap,
        success : function(data) {
            if (data == "success") {
                $("#realm-ldap-grid").omGrid("reload");
                showSuccess();
                $('#ldapForm')[0].reset();
            } else {
                showFailure(data);
            }
        },
        error : showFailure
    };

    $('#ldapForm').submit(function() {
        $(this).omAjaxSubmit(ldapoptions);
        return false;
    });
}

function initUserDefinedRealmTab() {
    $('#self_realm_button').omButton({
        width : '60px',
        onClick : function() {
            save_realm_self();
        }
    });

    $('#realm-self-buttonbar').omButtonbar({
        btns : [ {
            label : "复制为新域",
            id : "button1",
            icons : {
                left : resBase + '/images/copy.png'
            },
            onClick : function() {
                copyRealm("realm-self");
            }
        }, {
            separtor : true
        }, {
            label : "设为默认域",
            id : "button3",
            icons : {
                left : resBase + '/images/setting2.png'
            },
            onClick : function() {
                var dels = $('#realm-self-grid').omGrid("getSelections", true);
                if (dels.length <= 0) {
                    showFailure("请先选择选项！");
                    return;
                }
                var delIds = "";
                $(dels).each(function(index, item) {
                    delIds = item.realmName;
                });
                showConfirm("设置默认域", "是否置为默认域？", setDefaultRealm, delIds, "自定义存储");
            }
        } ]
    });

    $('#realm-self-grid')
            .omGrid(
                    {
                        limit : 0,
                        autoFit : true,
                        showIndex : false,
                        width : 'fit',
                        height : 220,
                        colModel : [
                                {
                                    header : '名称',
                                    name : 'realmName',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : '授权提供程序的全类名',
                                    name : 'authorizationProvider',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : '身份验证提供程序的全类名',
                                    name : 'authenticationProvider',
                                    width : 150,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : '是否默认域',
                                    name : 'isDefaultRealm',
                                    width : 150,
                                    align : 'center',
                                    renderer : function(colValue, rowData, rowIndex) {
                                        if ($("#default_name").val() == rowData.realmName) {
                                            return "&nbsp;&nbsp; <img src=" + resBase + "/images/check.png/>";
                                        } else {
                                            return "";
                                        }
                                    }

                                },
                                {
                                    header : '操作',
                                    name : 'opration',
                                    width : 100,
                                    align : 'center',
                                    renderer : function(colValue, rowData, rowIndex) {
                                        if ($("#default_name").val() != rowData.realmName) {
                                            return "&nbsp;&nbsp; <img src="
                                                    + resBase
                                                    + "/images/delete.png style='cursor:pointer' onclick=\"showConfirm('删除域','是否要删除域',deleteRealm,'"
                                                    + rowData.realmName + "','realm-self')\"  />";
                                        } else {
                                            return "";
                                        }
                                    }
                                } ],
                        dataSource : contextPath + '/protect/sysconfig/realm/customRealms'
                    });
}

function initTextStoreRealmTab() {
    $('#text_realm_button').omButton({
        width : '60px',
        onClick : function() {
            save_realm_text();
        }
    });

    $('#realm-text-buttonbar').omButtonbar({
        btns : [ {
            label : "复制为新域",
            id : "button1",
            icons : {
                left : resBase + '/images/copy.png'
            },
            onClick : function() {
                copyRealm("realm-text");
            }
        }, {
            separtor : true
        }, {
            label : "设为默认域",
            id : "button3",
            icons : {
                left : resBase + '/images/setting2.png'
            },
            onClick : function() {
                var dels = $('#realm-text-grid').omGrid("getSelections", true);
                if (dels.length <= 0) {
                    showFailure("请先选择选项！");
                    return;
                }
                var delIds = "";
                $(dels).each(function(index, item) {
                    delIds = item.realmName;
                });
                showConfirm("设置默认域", "是否置为默认域？", setDefaultRealm, delIds, "文本存储");
            }
        } ]
    });

    $('#realm-text-grid')
            .omGrid(
                    {
                        limit : 0,
                        autoFit : true,
                        showIndex : false,
                        width : 'fit',
                        height : 220,
                        colModel : [
                                {
                                    header : '名称',
                                    name : 'realmName',
                                    width : 200,
                                    align : 'left',
                                    sort : 'clientSide'
                                },
                                {
                                    header : '是否默认域',
                                    name : 'isDefaultRealm',
                                    width : 200,
                                    align : 'center',
                                    renderer : function(colValue, rowData, rowIndex) {
                                        if ($("#default_name").val() == rowData.realmName) {
                                            return "&nbsp;&nbsp; <img src=" + resBase + "/images/check.png/>";
                                        } else {
                                            return "";
                                        }
                                    }

                                },
                                {
                                    header : '操作',
                                    name : 'opration',
                                    width : 150,
                                    align : 'center',
                                    renderer : function(colValue, rowData, rowIndex) {
                                        if ($("#default_name").val() != rowData.realmName) {
                                            return "&nbsp;&nbsp; <img src="
                                                    + resBase
                                                    + "/images/delete.png style='cursor:pointer' onclick=\"showConfirm('删除域','是否要删除域',deleteRealm,'"
                                                    + rowData.realmName + "','realm-text')\"  />";
                                        } else {
                                            return "";
                                        }
                                    }
                                } ],
                        dataSource : contextPath + '/protect/sysconfig/realm/fileRealms'
                    });
}

function save_realm_text() {
    var value = $.trim($("#text_realm_name").val());
    if (value == "") {
        showFailure("安全域名称不能为空！");
        return false;
    }
    $.ajax({
        url : contextPath + '/protect/sysconfig/realm/saveFileRealm',
        type : "get",
        dataType : "json",
        data : {
            fileRealmName : value
        },
        success : function(data) {
            if (data == "success") {
                $("#realm-text-grid").omGrid("reload");
                showSuccess();
                $("#text_realm_name").val('');
            } else {
                showFailure(data);
            }
        },
        error : function() {
            showFailure();
        }
    });
}

function save_realm_self() {
    var name = $.trim($("#self_realm_name").val());
    var authenticationProvider = $.trim($("#self_realm_authenticationProvider").val());
    var authorizationProvider = $.trim($("#self_realm_authorizationProvider").val());

    if (name == "") {
        showFailure("安全域名称不能为空！");
        return false;
    }

    if (authenticationProvider == "") {
        showFailure("身份验证提供程序的全类名不能为空！");
        return false;
    }

    if (authorizationProvider == "") {
        showFailure("授权提供程序的全类名不能为空！");
        return false;
    }
    $.ajax({
        url : contextPath + '/protect/sysconfig/realm/saveCustomRealm',
        type : "get",
        dataType : "json",
        data : {
            fileRealmName : name,
            authenticationProvider : authenticationProvider,
            authorizationProvider : authorizationProvider
        },
        success : function(data) {
            if (data == "success") {
                $("#realm-self-grid").omGrid("reload");
                showSuccess();
                $("#self_realm_name").val('');
                $("#self_realm_authenticationProvider").val('');
                $("#self_realm_authorizationProvider").val('');
                
            } else {
                showFailure(data);
            }
        },
        error : function() {
            showFailure();
        }
    });
}

function validateldap() {
    var ldapRealmName = $.trim($("#ldapRealmName").val());
    var ldapHost = $.trim($("#ldapHost").val());
    var ldapPort = $.trim($("#ldapPort").val());
    var ldapRootDN = $.trim($("#ldapRootDN").val());
    var ldapRootDNPassword = $.trim($("#ldapRootDNPassword").val());
    var ldapsSearchBaseDN = $.trim($("#ldapsSearchBaseDN").val());
    var ldapGroupBaseDN = $.trim($("#ldapGroupBaseDN").val());
    var ldapUserFieldName = $.trim($("#ldapUserFieldName").val());
    var ldapMemberFieldName = $.trim($("#ldapMemberFieldName").val());
    var ldapPasswordFieldName = $.trim($("#ldapPasswordFieldName").val());
    if (ldapRealmName == "") {
        showFailure("安全域名称不能为空！");
        return false;
    }
    if (ldapHost == "") {
        showFailure("LDAP主机不能为空！");
        return false;
    }
    if (ldapPort == "") {
        showFailure(" LDAP端口不能为空！");
        return false;
    }

    if (ldapRootDN == "") {
        showFailure("LDAP根DN不能为空！");
        return false;
    }

    if (ldapRootDNPassword == "") {
        showFailure("根DN密码不能为空！");
        return false;
    }

    if (ldapsSearchBaseDN == "") {
        showFailure("搜索用户基DN不能为空！");
        return false;
    }
    if (ldapGroupBaseDN == "") {
        showFailure("搜索组基DN不能为空！");
        return false;
    }
    if (ldapGroupBaseDN == "") {
        showFailure("必要属性不能为空！");
        return false;
    }
    if (ldapUserFieldName == "") {
        showFailure("用户名字段名不能为空！");
        return false;
    }
    if (ldapMemberFieldName == "") {
        showFailure("组项中用户成员字段名不能为空！");
        return false;
    }
    if (ldapPasswordFieldName == "") {
        showFailure("密码字段名不能为空！");
        return false;
    } else {
        return true;
    }
}

function validateJdbc() {
    var jdbcRealmName = $.trim($("#jdbcRealmName").val());
    var jdbcDataSourceName = $.trim($("#jdbcDataSourceName").val());
    var jdbcUserTableName = $.trim($("#jdbcUserTableName").val());
    var jdbcUserName = $.trim($("#jdbcUserName").val());
    var jdbcPassword = $.trim($("#jdbcPassword").val());
    var jdbcSQLByUser = $.trim($("#jdbcSQLByUser").val());
    var jdbcSQLByGroup = $.trim($("#jdbcSQLByGroup").val());
    var jdbcEncodeClass = $.trim($("#jdbcEncodeClass").val());

    var pt = $("#jdbcPasswordEncodeTrue").is(":checked");
    var pf = $("#jdbcPasswordEncodeFalse").is(":checked");

    if (jdbcRealmName == "") {
        showFailure("安全域名称不能为空！");
        return false;
    }
    if (jdbcDataSourceName == "") {
        showFailure("数据源JNDI名不能为空！");
        return false;
    }
    if (jdbcUserTableName == "") {
        showFailure("用户信息表名不能为空！");
        return false;
    }
    if (jdbcUserName == "") {
        showFailure("用户名字段名不能为空！");
        return false;
    }
    if (jdbcPassword == "") {
        showFailure("密码字段名不能为空！");
        return false;
    }
    if (jdbcSQLByUser == "") {
        showFailure("查询用户名不能为空！");
        return false;
    }
    if (jdbcSQLByGroup == "") {
        showFailure("查询组名不能为空！");
        return false;
    }
    if (!pt && !pf) {
        showFailure("请选择密码编码！");
        return false;
    }

    if (pt && jdbcEncodeClass == "") {
        showFailure("编码密码的全类名不能为空！");
        return false;
    }
    return true;
}

function copyRealm(type) {
    if (type == "realm-text") {

        var names = $('#realm-text-grid').omGrid("getSelections", true);
        if (names.length <= 0) {
            showFailure("请先选择选项！");
            return;
        }
        $("#text_realm_name").val("CopyOf" + names[0].realmName);
    } else if (type == "realm-self") {

        var names = $('#realm-self-grid').omGrid("getSelections", true);
        if (names.length <= 0) {
            showFailure("请先选择选项！");
            return;
        }
        $("#self_realm_name").val("CopyOf" + names[0].realmName);
        $("#self_realm_authorizationProvider").val(names[0].authorizationProvider);
        $("#self_realm_authenticationProvider").val(names[0].authenticationProvider);
    } else if (type == "realm-ldap") {

        var names = $('#realm-ldap-grid').omGrid("getSelections", true);
        if (names.length <= 0) {
            showFailure("请先选择选项！");
            return;
        }
        $("#ldapRealmName").val("CopyOf" + names[0].realmName);
        $("#ldapHost").val(names[0].providerProps.host);
        $("#ldapPort").val(names[0].providerProps.port);
        $("#ldapRootDN").val(names[0].providerProps.rootDN);
        $("#ldapRootDNPassword").val(names[0].providerProps.password);
        $("#ldapsSearchBaseDN").val(names[0].providerProps.searchBaseDN);
        $("#ldapGroupBaseDN").val(names[0].providerProps.groupBaseDN);
        $("#ldapUserFieldName").val(names[0].providerProps.userField);
        $("#ldapMemberFieldName").val(names[0].providerProps.memberField);
        $("#ldapPasswordFieldName").val(names[0].providerProps.passwordField);

    } else {

        var names = $('#realm-jdbc-grid').omGrid("getSelections", true);
        if (names.length <= 0) {
            showFailure("请先选择选项！");
            return;
        }

        $("#jdbcRealmName").val("CopyOf" + names[0].realmName);
        $("#jdbcDataSourceName").val(names[0].providerProps['datasource-jndi-name']);
        $("#jdbcUserTableName").val(names[0].providerProps['user-table-name']);
        $("#jdbcUserName").val(names[0].providerProps.usernameField);
        $("#jdbcPassword").val(names[0].providerProps.passwordField);
        $("#jdbcSQLByUser").val(names[0].providerProps['query-by-username-sql']);
        $("#jdbcSQLByGroup").val(names[0].providerProps['query-by-groupname-sql']);

        if (names[0].providerProps.needEncode == "false") {
            $("#jdbcPasswordEncodeFalse").prop('checked', true);
            $("#jdbcPasswordEncodeTrue").prop('checked', false);
            $("#jdbcEncodeClass").val("");
        } else {
            $("#jdbcPasswordEncodeFalse").prop('checked', false);
            $("#jdbcPasswordEncodeTrue").prop('checked', true);
            $("#jdbcEncodeClass").val(names[0].providerProps['encoder-class-name']);
        }
    }
}

function showSuccess() {
	$.omMessageTip.show({
        type : 'success',
        title : '成功',
        content : '操作成功',
        timeout : 4000
    });
}

function showFailure(content) {
    $.omMessageTip.show({
        type : 'error',
        title : '失败',
        content : content == null ? "操作失败" : content,
        timeout : 4000
    });
}

function showConfirm(title, content, fn, key1, key2) {
    $.omMessageBox.confirm({
        title : title,
        content : content,
        onClose : function(v) {
            if (v) {
                fn(key1, key2);
            } else {
                return false;
            }
        }
    });
}

function setDefaultRealm(value, type) {
    $.ajax({
        url : contextPath + '/protect/sysconfig/realm/setDefaultRealm',
        type : "get",
        dataType : "json",
        data : {
            realmName : value
        },
        success : function(data) {
            if (data == "success") {
                showSuccess();
                $("#default_name").val(value);
                $("#default_type").val(type);
                $("#realm-text-grid").omGrid('reload');
                $("#realm-self-grid").omGrid('reload');
                $("#realm-ldap-grid").omGrid('reload');
                $("#realm-jdbc-grid").omGrid('reload');
            } else {
                showFailure(data);
            }
        },
        error : function() {
            showFailure();
        }
    });
}

function deleteRealm(key, type) {
    $.ajax({
        url : contextPath + '/protect/sysconfig/realm/deleteRealm',
        type : "get",
        dataType : "json",
        data : {
            realmName : key
        },
        success : function(data) {
            if (data == "success") {
                showSuccess();
                if (type == "realm-text") {
                    $("#realm-text-grid").omGrid('reload');
                }
                if (type == "realm-self") {
                    $("#realm-self-grid").omGrid('reload');
                }
                if (type == "realm-ldap") {
                    $("#realm-ldap-grid").omGrid('reload');
                }
                if (type == "realm-jdbc") {
                    $("#realm-jdbc-grid").omGrid('reload');
                }
            } else {
                showFailure(data);
            }
        },
        error : function() {
            showFailure();
        }
    });
}
