var contextPath = "";
var resBase = "";
$(document).ready(function() {
	contextPath = $("#contextPath").val();
	resBase = $("#resBase").val();
	
	$('#buttonbar').omButtonbar({
		btns : [{
					label : "备份",
					id : "button1",
					icons : {
						left : resBase + '/images/add.png'
					},
					onClick : function() {
						backup();
					}
				}, {
					separtor : true
				}, {
					label : "删除",
					id : "button3",
					icons : {
						left : resBase + '/images/delete.png'
					},
					onClick : function() {
						var dels = $('#sysconfig-backup-grid').omGrid("getSelections",
								true);
						if (dels.length <= 0) {
							showFailure("请先选择选项！");
							return;
						}
						var delIds = "";
						$(dels).each(function(index, item) {
									delIds += item.filename + ",";
								});
						showDelConfirm(delIds);
					}
				}, {
					separtor : true
				}, {
					label : "刷新",
					id : "button4",
					icons : {
						left : resBase + '/images/refresh.png'
					},
					onClick : function() {
						$("#sysconfig-backup-grid").omGrid('reload');
					}
				}]
	});

	$('#sysconfig-backup-grid').omGrid({
		limit : 0,
		showIndex : false,
		height : 600,
		width : '100%',
		singleSelect : false,
		colModel : [{
					header : '已备份文件',
					name : 'filename',
					align : 'left',
			/**
            		sort: function(data1, data2) {
						if(data1.filename !== undefined && data2.filename !== undefined) {
                            var value1 = data1.filename.replace(/[^0-9]/ig,"");
                            var value2 = data2.filename.replace(/[^0-9]/ig,"");
                            return Number(value1) - Number(value2);
						}
						return 0;
					},
			 **/
					width: 'autoExpand'
				}, {
					header : '操作',
					name : 'opration',
					align : 'center',
                    width: '50',
					renderer : function(colValue, rowData, rowIndex) {
						return "&nbsp;&nbsp; <img src="
								+ resBase
								+ "/images/reset.png title='还原' style='cursor:pointer' onclick=\"showRestoreConfirm('"
								+ rowData.filename + "')\";/>";
					}
				}],
		dataSource : contextPath + '/protect/sysconfig/sysconfigbackup/listbackup'
	});
	
});

function showSuccess() {
	$.omMessageBox.alert({
				type : 'success',
				title : '成功',
				content : '操作成功'
			});
}

function showFailure(content) {
	$.omMessageBox.alert({
				type : 'error',
				title : '失败',
				content : content == null ? "操作失败" : content
			});
}

function backup() {
	$.ajax({
		url : contextPath + '/protect/sysconfig/sysconfigbackup/addbackup',
		type : "get",
		dataType : "json",
		success : function(data) {
			if (data == "success") {
				showSuccess();
				$("#sysconfig-backup-grid").omGrid('reload');	
			} else {
				showFailure(data);
			}
		},
		error : function() {
			showFailure("备份失败");
		}
	});		
}


function showDelConfirm(key) {
	$.omMessageBox.confirm({
				title : '确认删除',
				content : '确认删除记录吗？' ,
				onClose : function(v) {
					if (v) {
						deleteByKey(key);
					} else {
						return false;
					}
				}
			});
}

function showRestoreConfirm(key) {
	$.omMessageBox.confirm({
				title : '确认还原',
				content : '确认还原记录吗？' ,
				onClose : function(v) {
					if (v) {
						restoreByKey(key);
					} else {
						return false;
					}
				}
			});
}

function deleteByKey(key) {
	$.ajax({
				url : contextPath + '/protect/sysconfig/sysconfigbackup/delbackups',
				type : "get",
				dataType : "json",
				data : {
					ids : key
				},
				success : function() {
					showSuccess();
					$("#sysconfig-backup-grid").omGrid('reload');
				},
				error : function() {
					showFailure();
				}
			});
}

function restoreByKey(key) {
	$.ajax({
				url : contextPath + '/protect/sysconfig/sysconfigbackup/restorebackup',
				type : "get",
				dataType : "json",
				data : {
					ids : key
				},
				success : function() {
                    $.omMessageBox.alert({
                        type : 'success',
                        title : '成功',
                        content : '操作成功，重启后生效！'
                    });
					$("#sysconfig-backup-grid").omGrid('reload');
				},
				error : function() {
					showFailure();
				}
			});
}

