var contextPath = "";
var resBase = "";
$(document).ready(function() {
	contextPath = $("#contextPath").val();
	resBase = $("#resBase").val();
	var xmsV = $("#xms_value").val();
	var xmxV = $("#xmx_value").val();
	var xmnV = $("#xmn_value").val();
	var gcmethodV = $("#gc_method").val();
	var jvmdetailV = $("#jvm_details").val();

	$('#xms').omNumberField({
				allowDecimals : false,
				allowNegative : false
			});
	$('#xmx').omNumberField({
				allowDecimals : false,
				allowNegative : false
			});
	$('#xmn').omNumberField({
				allowDecimals : false,
				allowNegative : false
			});

	$('#xms').val(xmsV);
	$('#xmx').val(xmxV);
	$('#xmn').val(xmnV);
	$('#details').val(jvmdetailV);
	if(gcmethodV==null || gcmethodV == '' ){
		gcmethodV = 1;
	}
	$('#gcmethod option:nth-child('+ gcmethodV +')').attr("selected", "selected");
	

	$('#buttonbar').omButtonbar({
		btns : [{
					label : "新增",
					id : "button1",
					icons : {
						left : resBase + '/images/add.png'
					},
					onClick : function() {
						openDetail(true);
					}
				}, {
					separtor : true
				}, {
					label : "删除",
					id : "button3",
					icons : {
						left : resBase + '/images/delete.png'
					},
					onClick : function() {
						var dels = $('#param-grid').omGrid("getSelections",
								true);
						if (dels.length <= 0) {
							showFailure("请先选择选项！");
							return;
						}
						var delIds = "";
						$(dels).each(function(index, item) {
									delIds += item.key + ",";
								});
						showDelConfirm(delIds);
					}
				}, {
					separtor : true
				}, {
					label : "刷新",
					id : "button4",
					icons : {
						left : resBase + '/images/refresh.png'
					},
					onClick : function() {
						$("#param-grid").omGrid('reload');
					}
				}]
	});

	$('#buttonbar-jvm').omButtonbar({
		btns : [{
					label : "保存",
					id : "button1",
					icons : {
						left : resBase + '/images/save.png'
					},
					onClick : function() {
						$.getJSON(contextPath
										+ '/protect/sysconfig/sysparam/savevm',
								{
									xms : $('#xms').val(),
									xmx : $('#xmx').val(),
									xmn : $('#xmn').val(),
									gc  : $('#gcmethod').val(),
									details : $('#details').val()
								}, function(data) {
									showSuccess("操作成功！重启后生效！");
								});
		}
				},{
					separtor : true
				}, {
					label : "恢复默认值",
					id : "button3",
					icons : {
						left : resBase + '/images/reset.png'
					},
					onClick : function() {
						$.ajax({
									url : contextPath
											+ '/protect/sysconfig/sysparam/setdefault',
									type : "get",
									dataType : "json",
									success : function() {
										showSuccess();
										$('#xms').val(128);
										$('#xmx').val(512);
										$('#xmn').val(128);
									},
									error : function() {
										showFailure();
									}
								});
					}
				}]
	});

	$('#param-grid').omGrid({
		limit : 0,
		showIndex : false,
		height : 200,
		width: 'fit',
		singleSelect : false,
		colModel : [{
					header : '参数类型',
					name : 'type',
					align : 'left',
					sort : 'clientSide',
					width: 100
				}, {
					header : '参数名称',
					name : 'key',
					align : 'left',
					sort : 'clientSide',
                    width: 150
				}, {
					header : '参数值',
					name : 'value',
					align : 'left',
					sort : 'clientSide',
                    width: 200
				}, {
					header : '参数说明',
					name : 'description',
					align : 'left',
					sort : 'clientSide',
                    width: 'autoExpand'
				}, {
					header : '操作',
					name : 'opration',
					align : 'center',
                    width: 80,
					renderer : function(colValue, rowData, rowIndex) {
						return "<img src="
								+ resBase
								+ "/images/delete.png title='删除参数' style='cursor:pointer' onclick=\"showDelConfirm('"
								+ rowData.key + "')\";/>";
					}
				}],
		dataSource : contextPath + '/protect/sysconfig/sysparam/listparam'
	});

	$('#jvm-grid').omGrid({
		limit : 0,
		showIndex : false,
		header : false,
		height : 200,
		colModel : [{
					header : '键',
					name : 'key',
					width : 200,
					align : 'left',
					sort : 'clientSide'
				}, {
					header : '值',
					name : 'value',
					width : 'autoExpand',
					align : 'left',
					sort : 'clientSide'
				}],
		dataSource : contextPath + '/protect/sysconfig/sysparam/listvm'
	});

	$("#detail").omDialog({
		autoOpen : false
	});

});

function showSuccess(param) {
	$.omMessageBox.alert({
				type : 'success',
				title : '成功',
				content : param ?  param : '操作成功'
			});
}

function showFailure(content) {
	$.omMessageBox.alert({
				type : 'error',
				title : '失败',
				content : content == null ? "操作失败" : content
			});
}

var submitFlag = false;

function openDetail(isNew, key, value, type, des) {
	submitFlag = true;
	if (isNew) {
		$('#apusicValue').val('');
		$('#apusicDes').val('').attr("disabled", false);
		$("#detail").omDialog({
					autoOpen : true,
					height : 300,
					width : 400,
					modal : true,
					title : "新增Apusic参数"
				});
		$('#apusicType').omCombo({
					editable : false,
					value : "all",
					disabled : false,
					autoFilter : true,
					width : '240px',
					dataSource : [{
								text : '全部',
								value : 'all'
							}, {
								text : 'Http相关参数',
								value : 'http'
							}, {
								text : 'Jsp相关参数',
								value : 'jsp'
							}, {
								text : '日志相关参数',
								value : 'log'
							}, {
								text : '安全相关参数',
								value : 'security'
							}, {
								text : '其它相关参数',
								value : 'other'
							}],
					onValueChange : function(target, newValue, oldValue, event) {
						getOps(newValue);
						$('#apusicDes').val('');
					}

				});

		$('#apusicKey').omCombo({
					width : '240px',
					listAutoWidth : true,
					editable : false,
					disabled : false,
					onValueChange : function(target, newValue, oldValue, event) {
						getDes(newValue);
					}
				});
		$('#save').omButton({
					width : '60px',
					onClick : function() {
						addOps();
					}
				});
		$('#cancel').omButton({
					width : '60px',
					onClick : function() {
						$("#detail").omDialog('close');
					}
				});

	} else {
		$("#detail").omDialog({
					autoOpen : true,
					height : 300,
					width : 400,
					modal : true,
					title : "修改Apusic参数"
				});
		$('#apusicType').omCombo({
					editable : false,
					value : type,
					disabled : true,
					autoFilter : true,
					width : '240px',
					dataSource : [{
								text : '全部',
								value : 'all'
							}, {
								text : 'Http相关参数',
								value : 'http'
							}, {
								text : 'Jsp相关参数',
								value : 'jsp'
							}, {
								text : '日志相关参数',
								value : 'log'
							}, {
								text : '安全相关参数',
								value : 'security'
							}, {
								text : '其它相关参数',
								value : 'other'
							}],
					onValueChange : function(target, newValue, oldValue, event) {
						getOps(newValue, key);
					}

				});

		$('#apusicKey').omCombo({
					width : '240px',
					listAutoWidth : true,
					disabled : true,
					editable : false,
					onValueChange : function(target, newValue, oldValue, event) {
						getDes(newValue);
					}
				});

		$('#save').omButton({
					width : '60px',
					onClick : function() {
						updateOps();
					}
				});
		$('#cancel').omButton({
					width : '60px',
					onClick : function() {
						$("#detail").omDialog('close');
					}
				});
		$('#apusicValue').val(value);
		$('#apusicDes').val(des).attr("disabled", true);
	}

}

function addOps() {
	var key = $("#apusicKey").val();
	var value = $("#apusicValue").val();
	if (key == null || value == null) {
		showFailure("请输入属性值！");
		return false;
	}
	if(submitFlag){
		$.ajax({
			url : contextPath + '/protect/sysconfig/sysparam/addops',
			type : "get",
			dataType : "json",
			data : {
				key : key,
				value : value
			},
			beforeSend : function(XMLReq){
				submitFlag = false;
			},
			success : function(data) {
				if (data == "success") {
					showSuccess();
					$("#param-grid").omGrid('reload');
					$("#detail").omDialog('close');
				} else {
					$("#detail").omDialog('close');
					showFailure(data);
				}

			},
			error : function() {
				showFailure("新增失败");
			}
		});		
	}

}

function updateOps(key, value) {
	var key = $("#apusicKey").val();
	var value = $("#apusicValue").val();
	if (key == null || value == null) {
		showFailure("请输入属性值！");
		return false;
	}
	if(submitFlag){
		$.ajax({
			url : contextPath + '/protect/sysconfig/sysparam/updateops',
			type : "get",
			dataType : "json",
			data : {
				key : key,
				value : value
			},
			beforeSend : function(XMLReq){
				submitFlag = false;
			},
			success : function(data) {
				if (data == "success") {
					showSuccess();
					$("#param-grid").omGrid('reload');
					$("#detail").omDialog('close');
				} else {
					$("#detail").omDialog('close');
					showFailure(data);
				}

			},
			error : function() {
				showFailure("修改失败");
			}
		});		
	}

}

function showDelConfirm(key) {
	$.omMessageBox.confirm({
				title : '确认删除',
				content : '确认删除记录吗？',
				onClose : function(v) {
					if (v) {
						deleteByKey(key);
					} else {
						return false;
					}
				}
			});
}

function deleteByKey(key) {
	$.ajax({
				url : contextPath + '/protect/sysconfig/sysparam/delops',
				type : "get",
				dataType : "json",
				data : {
					ids : key
				},
				success : function() {
					showSuccess('删除成功！内置参数将会被修改为默认值！');
					$("#param-grid").omGrid('reload');
				},
				error : function() {
					showFailure();
				}
			});
}
function getOps(key, value) {
	$.ajax({
				url : contextPath + '/protect/sysconfig/sysparam/selectops',
				type : "get",
				dataType : "json",
				data : {
					key : key
				},
				success : function(data) {
					$('#apusicKey').val('').omCombo('setData', data);
					$('#apusicKey').omCombo({
								value : value
							});
				},
				error : function() {
					showFailure();
				}
			});
}

function getDes(key) {
	$.ajax({
				url : contextPath + '/protect/sysconfig/sysparam/selectdes',
				type : "get",
				dataType : "json",
				data : {
					key : key
				},
				success : function(data) {
					$('#apusicDes').val(data);
				},
				error : function() {
					showFailure();
				}
			});
}
